/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 1 "parser.y" /* yacc.c:339  */

/*
  OMPi OpenMP Compiler
  == Copyright since 2001 the OMPi Team
  == Dept. of Computer Science & Engineering, University of Ioannina

  This file is part of OMPi.

  OMPi is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  OMPi is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with OMPi; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
*/

/* parser.y */

/*
 * 2010/11/10:
 *   dropped OpenMP-specific for parsing; fewer rules, less code
 * 2009/05/11:
 *   added AUTO schedule type
 * 2009/05/03:
 *   added ATNODE ompix clause
 */

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include <stdarg.h>
#include <ctype.h>
#include <assert.h>
#include "scanner.h"
#include "ompi.h"
#include "ast.h"
#include "symtab.h"
#include "ast_free.h"
#include "ast_copy.h"
#include "ast_vars.h"
#include "ast_print.h"
#include "ast_arith.h"
#include "x_clauses.h"
#include "str.h"

void    check_uknown_var(char *name);
void    parse_error(int exitvalue, char *format, ...);
void    parse_warning(char *format, ...);
void    yyerror(const char *s);
void    check_for_main_and_declare(astspec s, astdecl d);
void    add_declaration_links(astspec s, astdecl d);
astdecl fix_known_typename(astspec s);
void    check_schedule(ompclsubt_e sched, ompclmod_e mod);
char    *strdupcat(char *first, char *second, int freethem);


aststmt pastree = NULL;       /* The generated AST */
aststmt pastree_stmt = NULL;  /* For when parsing statment strings */
astexpr pastree_expr = NULL;  /* For when parsing expression strings */
int     checkDecls = 1;       /* 0 when scanning strings (no context check) */
int     tempsave;
int     isTypedef  = 0;       /* To keep track of typedefs */

char    *parsingstring;       /* For error reporting when parsing string */

int     __has_target = 0;

//TODO this is not 100% correct (e.g. if returns lies in a dead code area).
/* Return and goto statements that lead outside the outlined region constitute
 * programmer errors and so we should stop the compilation. When simply 
 * analyzing vars (and not outlining) we ignore this rule.
 */
int     errorOnReturn = 0;

#line 150 "parser.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_YY_PARSER_H_INCLUDED
# define YY_YY_PARSER_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    NOELSE = 258,
    ELSE = 259,
    START_SYMBOL_EXPRESSION = 260,
    START_SYMBOL_BLOCKLIST = 261,
    START_SYMBOL_TRANSUNIT = 262,
    IDENTIFIER = 263,
    TYPE_NAME = 264,
    CONSTANT = 265,
    STRING_LITERAL = 266,
    PTR_OP = 267,
    INC_OP = 268,
    DEC_OP = 269,
    LEFT_OP = 270,
    RIGHT_OP = 271,
    LE_OP = 272,
    GE_OP = 273,
    EQ_OP = 274,
    NE_OP = 275,
    AND_OP = 276,
    OR_OP = 277,
    MUL_ASSIGN = 278,
    DIV_ASSIGN = 279,
    MOD_ASSIGN = 280,
    ADD_ASSIGN = 281,
    SUB_ASSIGN = 282,
    LEFT_ASSIGN = 283,
    RIGHT_ASSIGN = 284,
    AND_ASSIGN = 285,
    XOR_ASSIGN = 286,
    OR_ASSIGN = 287,
    SIZEOF = 288,
    TYPEDEF = 289,
    EXTERN = 290,
    STATIC = 291,
    AUTO = 292,
    REGISTER = 293,
    RESTRICT = 294,
    CHAR = 295,
    SHORT = 296,
    INT = 297,
    LONG = 298,
    SIGNED = 299,
    UNSIGNED = 300,
    FLOAT = 301,
    DOUBLE = 302,
    CONST = 303,
    VOLATILE = 304,
    VOID = 305,
    INLINE = 306,
    UBOOL = 307,
    UCOMPLEX = 308,
    UIMAGINARY = 309,
    STRUCT = 310,
    UNION = 311,
    ENUM = 312,
    ELLIPSIS = 313,
    CASE = 314,
    DEFAULT = 315,
    IF = 316,
    SWITCH = 317,
    WHILE = 318,
    DO = 319,
    FOR = 320,
    GOTO = 321,
    CONTINUE = 322,
    BREAK = 323,
    RETURN = 324,
    __BUILTIN_VA_ARG = 325,
    __BUILTIN_OFFSETOF = 326,
    __BUILTIN_TYPES_COMPATIBLE_P = 327,
    __ATTRIBUTE__ = 328,
    __ASM__ = 329,
    PRAGMA_OTHER = 330,
    PRAGMA_OMP = 331,
    PRAGMA_OMP_THREADPRIVATE = 332,
    OMP_PARALLEL = 333,
    OMP_SECTIONS = 334,
    OMP_NOWAIT = 335,
    OMP_ORDERED = 336,
    OMP_SCHEDULE = 337,
    OMP_STATIC = 338,
    OMP_DYNAMIC = 339,
    OMP_GUIDED = 340,
    OMP_RUNTIME = 341,
    OMP_AUTO = 342,
    OMP_SECTION = 343,
    OMP_AFFINITY = 344,
    OMP_SINGLE = 345,
    OMP_MASTER = 346,
    OMP_CRITICAL = 347,
    OMP_BARRIER = 348,
    OMP_ATOMIC = 349,
    OMP_FLUSH = 350,
    OMP_PRIVATE = 351,
    OMP_FIRSTPRIVATE = 352,
    OMP_LASTPRIVATE = 353,
    OMP_SHARED = 354,
    OMP_DEFAULT = 355,
    OMP_NONE = 356,
    OMP_REDUCTION = 357,
    OMP_COPYIN = 358,
    OMP_NUMTHREADS = 359,
    OMP_COPYPRIVATE = 360,
    OMP_FOR = 361,
    OMP_IF = 362,
    OMP_TASK = 363,
    OMP_UNTIED = 364,
    OMP_TASKWAIT = 365,
    OMP_COLLAPSE = 366,
    OMP_FINAL = 367,
    OMP_MERGEABLE = 368,
    OMP_TASKYIELD = 369,
    OMP_READ = 370,
    OMP_WRITE = 371,
    OMP_CAPTURE = 372,
    OMP_UPDATE = 373,
    OMP_MIN = 374,
    OMP_MAX = 375,
    OMP_PROCBIND = 376,
    OMP_CLOSE = 377,
    OMP_SPREAD = 378,
    OMP_SIMD = 379,
    OMP_INBRANCH = 380,
    OMP_NOTINBRANCH = 381,
    OMP_UNIFORM = 382,
    OMP_LINEAR = 383,
    OMP_ALIGNED = 384,
    OMP_SIMDLEN = 385,
    OMP_SAFELEN = 386,
    OMP_DECLARE = 387,
    OMP_TARGET = 388,
    OMP_DATA = 389,
    OMP_DEVICE = 390,
    OMP_MAP = 391,
    OMP_ALLOC = 392,
    OMP_TO = 393,
    OMP_FROM = 394,
    OMP_TOFROM = 395,
    OMP_END = 396,
    OMP_TEAMS = 397,
    OMP_DISTRIBUTE = 398,
    OMP_NUMTEAMS = 399,
    OMP_THREADLIMIT = 400,
    OMP_DISTSCHEDULE = 401,
    OMP_DEPEND = 402,
    OMP_IN = 403,
    OMP_OUT = 404,
    OMP_INOUT = 405,
    OMP_TASKGROUP = 406,
    OMP_SEQ_CST = 407,
    OMP_CANCEL = 408,
    OMP_INITIALIZER = 409,
    PRAGMA_OMP_CANCELLATIONPOINT = 410,
    PRAGMA_OMP_DECLARETARGET = 411,
    PRAGMA_OMP_ENDDECLARETARGET = 412,
    OMP_HINT = 413,
    OMP_SOURCE = 414,
    OMP_SINK = 415,
    OMP_RELEASE = 416,
    OMP_DELETE = 417,
    OMP_ALWAYS = 418,
    OMP_ENTER = 419,
    OMP_EXIT = 420,
    OMP_IS_DEVICE_PTR = 421,
    OMP_USE_DEVICE_PTR = 422,
    OMP_PRIORITY = 423,
    OMP_TASKLOOP = 424,
    OMP_THREADS = 425,
    OMP_LINK = 426,
    OMP_DEFAULTMAP = 427,
    OMP_SCALAR = 428,
    OMP_MONOTONIC = 429,
    OMP_NONMONOTONIC = 430,
    OMP_INREDUCTION = 431,
    OMP_TASKREDUCTION = 432,
    OMP_INSCAN = 433,
    OMP_PRIMARY = 434,
    OMP_MASKED = 435,
    OMP_FILTER = 436,
    PRAGMA_OMPIX = 437,
    OMPIX_TASKDEF = 438,
    OMPIX_TASKSYNC = 439,
    OMPIX_UPONRETURN = 440,
    OMPIX_ATNODE = 441,
    OMPIX_DETACHED = 442,
    OMPIX_ATWORKER = 443,
    OMPIX_TASKSCHEDULE = 444,
    OMPIX_STRIDE = 445,
    OMPIX_START = 446,
    OMPIX_SCOPE = 447,
    OMPIX_NODES = 448,
    OMPIX_WORKERS = 449,
    OMPIX_LOCAL = 450,
    OMPIX_GLOBAL = 451,
    OMPIX_HERE = 452,
    OMPIX_REMOTE = 453,
    OMPIX_HINTS = 454,
    OMPIX_TIED = 455,
    OMPIX_PROCEXTERN = 456,
    OMPIX_TAG = 457
  };
#endif
/* Tokens.  */
#define NOELSE 258
#define ELSE 259
#define START_SYMBOL_EXPRESSION 260
#define START_SYMBOL_BLOCKLIST 261
#define START_SYMBOL_TRANSUNIT 262
#define IDENTIFIER 263
#define TYPE_NAME 264
#define CONSTANT 265
#define STRING_LITERAL 266
#define PTR_OP 267
#define INC_OP 268
#define DEC_OP 269
#define LEFT_OP 270
#define RIGHT_OP 271
#define LE_OP 272
#define GE_OP 273
#define EQ_OP 274
#define NE_OP 275
#define AND_OP 276
#define OR_OP 277
#define MUL_ASSIGN 278
#define DIV_ASSIGN 279
#define MOD_ASSIGN 280
#define ADD_ASSIGN 281
#define SUB_ASSIGN 282
#define LEFT_ASSIGN 283
#define RIGHT_ASSIGN 284
#define AND_ASSIGN 285
#define XOR_ASSIGN 286
#define OR_ASSIGN 287
#define SIZEOF 288
#define TYPEDEF 289
#define EXTERN 290
#define STATIC 291
#define AUTO 292
#define REGISTER 293
#define RESTRICT 294
#define CHAR 295
#define SHORT 296
#define INT 297
#define LONG 298
#define SIGNED 299
#define UNSIGNED 300
#define FLOAT 301
#define DOUBLE 302
#define CONST 303
#define VOLATILE 304
#define VOID 305
#define INLINE 306
#define UBOOL 307
#define UCOMPLEX 308
#define UIMAGINARY 309
#define STRUCT 310
#define UNION 311
#define ENUM 312
#define ELLIPSIS 313
#define CASE 314
#define DEFAULT 315
#define IF 316
#define SWITCH 317
#define WHILE 318
#define DO 319
#define FOR 320
#define GOTO 321
#define CONTINUE 322
#define BREAK 323
#define RETURN 324
#define __BUILTIN_VA_ARG 325
#define __BUILTIN_OFFSETOF 326
#define __BUILTIN_TYPES_COMPATIBLE_P 327
#define __ATTRIBUTE__ 328
#define __ASM__ 329
#define PRAGMA_OTHER 330
#define PRAGMA_OMP 331
#define PRAGMA_OMP_THREADPRIVATE 332
#define OMP_PARALLEL 333
#define OMP_SECTIONS 334
#define OMP_NOWAIT 335
#define OMP_ORDERED 336
#define OMP_SCHEDULE 337
#define OMP_STATIC 338
#define OMP_DYNAMIC 339
#define OMP_GUIDED 340
#define OMP_RUNTIME 341
#define OMP_AUTO 342
#define OMP_SECTION 343
#define OMP_AFFINITY 344
#define OMP_SINGLE 345
#define OMP_MASTER 346
#define OMP_CRITICAL 347
#define OMP_BARRIER 348
#define OMP_ATOMIC 349
#define OMP_FLUSH 350
#define OMP_PRIVATE 351
#define OMP_FIRSTPRIVATE 352
#define OMP_LASTPRIVATE 353
#define OMP_SHARED 354
#define OMP_DEFAULT 355
#define OMP_NONE 356
#define OMP_REDUCTION 357
#define OMP_COPYIN 358
#define OMP_NUMTHREADS 359
#define OMP_COPYPRIVATE 360
#define OMP_FOR 361
#define OMP_IF 362
#define OMP_TASK 363
#define OMP_UNTIED 364
#define OMP_TASKWAIT 365
#define OMP_COLLAPSE 366
#define OMP_FINAL 367
#define OMP_MERGEABLE 368
#define OMP_TASKYIELD 369
#define OMP_READ 370
#define OMP_WRITE 371
#define OMP_CAPTURE 372
#define OMP_UPDATE 373
#define OMP_MIN 374
#define OMP_MAX 375
#define OMP_PROCBIND 376
#define OMP_CLOSE 377
#define OMP_SPREAD 378
#define OMP_SIMD 379
#define OMP_INBRANCH 380
#define OMP_NOTINBRANCH 381
#define OMP_UNIFORM 382
#define OMP_LINEAR 383
#define OMP_ALIGNED 384
#define OMP_SIMDLEN 385
#define OMP_SAFELEN 386
#define OMP_DECLARE 387
#define OMP_TARGET 388
#define OMP_DATA 389
#define OMP_DEVICE 390
#define OMP_MAP 391
#define OMP_ALLOC 392
#define OMP_TO 393
#define OMP_FROM 394
#define OMP_TOFROM 395
#define OMP_END 396
#define OMP_TEAMS 397
#define OMP_DISTRIBUTE 398
#define OMP_NUMTEAMS 399
#define OMP_THREADLIMIT 400
#define OMP_DISTSCHEDULE 401
#define OMP_DEPEND 402
#define OMP_IN 403
#define OMP_OUT 404
#define OMP_INOUT 405
#define OMP_TASKGROUP 406
#define OMP_SEQ_CST 407
#define OMP_CANCEL 408
#define OMP_INITIALIZER 409
#define PRAGMA_OMP_CANCELLATIONPOINT 410
#define PRAGMA_OMP_DECLARETARGET 411
#define PRAGMA_OMP_ENDDECLARETARGET 412
#define OMP_HINT 413
#define OMP_SOURCE 414
#define OMP_SINK 415
#define OMP_RELEASE 416
#define OMP_DELETE 417
#define OMP_ALWAYS 418
#define OMP_ENTER 419
#define OMP_EXIT 420
#define OMP_IS_DEVICE_PTR 421
#define OMP_USE_DEVICE_PTR 422
#define OMP_PRIORITY 423
#define OMP_TASKLOOP 424
#define OMP_THREADS 425
#define OMP_LINK 426
#define OMP_DEFAULTMAP 427
#define OMP_SCALAR 428
#define OMP_MONOTONIC 429
#define OMP_NONMONOTONIC 430
#define OMP_INREDUCTION 431
#define OMP_TASKREDUCTION 432
#define OMP_INSCAN 433
#define OMP_PRIMARY 434
#define OMP_MASKED 435
#define OMP_FILTER 436
#define PRAGMA_OMPIX 437
#define OMPIX_TASKDEF 438
#define OMPIX_TASKSYNC 439
#define OMPIX_UPONRETURN 440
#define OMPIX_ATNODE 441
#define OMPIX_DETACHED 442
#define OMPIX_ATWORKER 443
#define OMPIX_TASKSCHEDULE 444
#define OMPIX_STRIDE 445
#define OMPIX_START 446
#define OMPIX_SCOPE 447
#define OMPIX_NODES 448
#define OMPIX_WORKERS 449
#define OMPIX_LOCAL 450
#define OMPIX_GLOBAL 451
#define OMPIX_HERE 452
#define OMPIX_REMOTE 453
#define OMPIX_HINTS 454
#define OMPIX_TIED 455
#define OMPIX_PROCEXTERN 456
#define OMPIX_TAG 457

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 85 "parser.y" /* yacc.c:355  */

  char      name[2048];  /* A general string */
  int       type;        /* A general integer */
  char     *string;      /* A dynamically allocated string (only for 2 rules) */
  symbol    symb;        /* A symbol */
  astexpr   expr;        /* An expression node in the AST */
  astspec   spec;        /* A declaration specifier node in the AST */
  astdecl   decl;        /* A declarator node in the AST */
  aststmt   stmt;        /* A statement node in the AST */
  asmop     asmo;        /* An asm operand */
  ompcon    ocon;        /* An OpenMP construct */
  ompdir    odir;        /* An OpenMP directive */
  ompclause ocla;        /* An OpenMP clause */
  omparrdim oasd;        /* An array section dimension/slice */
  ompxli    oxli;        /* OpenMP extended list items (ids/array secitons) */

  oxcon     xcon;        /* OMPi extensions */
  oxdir     xdir;
  oxclause  xcla;

#line 615 "parser.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_PARSER_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 632 "parser.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  247
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   5262

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  228
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  399
/* YYNRULES -- Number of rules.  */
#define YYNRULES  1015
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1711

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   457

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     227,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   216,     2,     2,     2,   218,   211,     2,
     203,   204,   212,   213,   210,   214,   207,   217,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   224,   226,
     219,   225,   220,   223,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   205,     2,   206,   221,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   208,   222,   209,   215,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   564,   564,   565,   566,   567,   584,   605,   609,   632,
     654,   658,   662,   673,   677,   687,   694,   698,   702,   711,
     715,   719,   723,   727,   731,   740,   743,   747,   755,   759,
     763,   767,   774,   778,   787,   792,   797,   806,   810,   814,
     818,   822,   826,   834,   838,   846,   850,   854,   858,   866,
     870,   874,   882,   886,   890,   898,   902,   906,   910,   914,
     922,   926,   930,   938,   942,   950,   954,   962,   966,   974,
     978,   986,   990,   998,  1002,  1010,  1014,  1022,  1026,  1030,
    1034,  1038,  1042,  1046,  1050,  1054,  1058,  1062,  1070,  1074,
    1082,  1096,  1111,  1118,  1123,  1127,  1131,  1139,  1143,  1147,
    1151,  1155,  1159,  1163,  1167,  1175,  1179,  1193,  1210,  1209,
    1232,  1237,  1241,  1245,  1249,  1257,  1261,  1265,  1269,  1273,
    1277,  1281,  1285,  1289,  1293,  1297,  1301,  1305,  1309,  1313,
    1322,  1326,  1330,  1345,  1352,  1359,  1370,  1374,  1382,  1386,
    1394,  1398,  1406,  1410,  1414,  1418,  1426,  1430,  1438,  1442,
    1446,  1454,  1458,  1471,  1483,  1487,  1499,  1511,  1519,  1531,
    1535,  1543,  1547,  1555,  1559,  1563,  1567,  1575,  1583,  1587,
    1600,  1604,  1612,  1616,  1620,  1624,  1628,  1632,  1636,  1640,
    1644,  1648,  1652,  1656,  1664,  1668,  1672,  1676,  1684,  1688,
    1696,  1700,  1708,  1712,  1720,  1724,  1728,  1736,  1740,  1748,
    1752,  1760,  1764,  1768,  1776,  1780,  1784,  1788,  1792,  1796,
    1800,  1804,  1808,  1812,  1816,  1824,  1832,  1836,  1840,  1848,
    1852,  1856,  1860,  1868,  1876,  1880,  1888,  1892,  1896,  1910,
    1914,  1918,  1922,  1926,  1930,  1934,  1938,  1943,  1959,  1967,
    1971,  1981,  1985,  1989,  1997,  2001,  2001,  2012,  2016,  2025,
    2029,  2033,  2038,  2047,  2051,  2060,  2064,  2068,  2077,  2081,
    2085,  2089,  2093,  2097,  2101,  2105,  2109,  2113,  2117,  2121,
    2125,  2129,  2133,  2141,  2146,  2150,  2154,  2161,  2178,  2182,
    2190,  2194,  2201,  2205,  2209,  2221,  2222,  2227,  2226,  2253,
    2252,  2288,  2287,  2316,  2315,  2353,  2357,  2377,  2381,  2388,
    2392,  2396,  2400,  2404,  2411,  2415,  2422,  2423,  2427,  2430,
    2434,  2441,  2445,  2452,  2455,  2459,  2466,  2470,  2477,  2481,
    2488,  2492,  2505,  2508,  2515,  2519,  2526,  2533,  2537,  2554,
    2557,  2561,  2577,  2578,  2579,  2598,  2602,  2610,  2619,  2623,
    2630,  2634,  2638,  2642,  2646,  2650,  2654,  2658,  2662,  2666,
    2671,  2676,  2680,  2684,  2688,  2692,  2696,  2700,  2704,  2708,
    2712,  2716,  2720,  2724,  2728,  2732,  2736,  2740,  2744,  2748,
    2752,  2756,  2761,  2766,  2783,  2787,  2792,  2797,  2802,  2807,
    2812,  2817,  2822,  2829,  2836,  2844,  2852,  2855,  2859,  2866,
    2870,  2874,  2878,  2882,  2886,  2890,  2897,  2897,  2902,  2902,
    2908,  2913,  2913,  2921,  2928,  2936,  2939,  2952,  2968,  2972,
    2976,  2980,  2984,  2988,  2995,  2999,  3011,  3017,  3016,  3026,
    3025,  3037,  3041,  3048,  3052,  3056,  3060,  3064,  3068,  3073,
    3076,  3080,  3087,  3094,  3102,  3105,  3109,  3116,  3120,  3124,
    3128,  3132,  3139,  3146,  3151,  3155,  3162,  3169,  3176,  3184,
    3187,  3191,  3198,  3202,  3206,  3210,  3217,  3217,  3226,  3234,
    3242,  3245,  3249,  3257,  3261,  3265,  3269,  3273,  3277,  3285,
    3297,  3301,  3309,  3313,  3321,  3321,  3330,  3330,  3339,  3339,
    3348,  3351,  3359,  3367,  3371,  3379,  3387,  3390,  3394,  3403,
    3415,  3419,  3423,  3427,  3435,  3443,  3451,  3454,  3458,  3465,
    3469,  3477,  3485,  3493,  3496,  3500,  3507,  3511,  3519,  3528,
    3536,  3539,  3543,  3550,  3554,  3562,  3566,  3574,  3574,  3584,
    3584,  3589,  3589,  3599,  3602,  3606,  3614,  3618,  3622,  3626,
    3630,  3634,  3642,  3642,  3651,  3660,  3660,  3669,  3669,  3680,
    3688,  3691,  3695,  3702,  3706,  3710,  3714,  3718,  3722,  3729,
    3733,  3741,  3745,  3753,  3764,  3768,  3772,  3779,  3786,  3790,
    3794,  3798,  3805,  3816,  3820,  3824,  3831,  3839,  3843,  3847,
    3851,  3859,  3867,  3871,  3875,  3882,  3886,  3890,  3894,  3898,
    3906,  3906,  3915,  3915,  3920,  3920,  3930,  3935,  3942,  3949,
    3957,  3962,  3970,  3974,  3978,  3986,  3986,  3992,  3991,  4009,
    4019,  4027,  4030,  4034,  4041,  4045,  4049,  4053,  4057,  4061,
    4071,  4071,  4077,  4077,  4088,  4089,  4095,  4103,  4111,  4114,
    4118,  4125,  4129,  4133,  4137,  4141,  4148,  4152,  4152,  4161,
    4170,  4178,  4181,  4185,  4192,  4196,  4200,  4208,  4217,  4225,
    4228,  4241,  4257,  4261,  4269,  4278,  4286,  4289,  4293,  4300,
    4304,  4312,  4321,  4329,  4332,  4336,  4343,  4347,  4351,  4355,
    4359,  4367,  4376,  4384,  4387,  4391,  4398,  4402,  4406,  4410,
    4414,  4418,  4422,  4426,  4430,  4434,  4442,  4450,  4458,  4461,
    4465,  4472,  4476,  4480,  4484,  4492,  4500,  4508,  4511,  4515,
    4522,  4526,  4530,  4534,  4542,  4551,  4559,  4562,  4566,  4573,
    4577,  4581,  4585,  4589,  4597,  4606,  4615,  4618,  4623,  4631,
    4635,  4639,  4643,  4651,  4660,  4669,  4672,  4686,  4703,  4707,
    4715,  4725,  4733,  4736,  4749,  4765,  4769,  4773,  4777,  4785,
    4794,  4802,  4805,  4809,  4816,  4820,  4828,  4838,  4846,  4849,
    4853,  4860,  4864,  4868,  4872,  4880,  4889,  4897,  4900,  4913,
    4929,  4933,  4937,  4941,  4949,  4958,  4967,  4970,  4974,  4982,
    4986,  4990,  4994,  4998,  5002,  5006,  5010,  5018,  5018,  5023,
    5027,  5032,  5040,  5040,  5049,  5053,  5057,  5065,  5065,  5075,
    5083,  5091,  5094,  5107,  5123,  5127,  5131,  5135,  5139,  5143,
    5147,  5151,  5155,  5162,  5170,  5178,  5181,  5185,  5192,  5196,
    5200,  5204,  5208,  5212,  5216,  5220,  5227,  5234,  5241,  5248,
    5252,  5257,  5264,  5272,  5279,  5287,  5295,  5304,  5312,  5315,
    5319,  5327,  5327,  5337,  5344,  5355,  5363,  5370,  5378,  5381,
    5391,  5394,  5398,  5402,  5406,  5415,  5418,  5425,  5429,  5436,
    5436,  5444,  5448,  5455,  5462,  5466,  5475,  5478,  5482,  5490,
    5494,  5502,  5506,  5510,  5518,  5526,  5530,  5537,  5543,  5549,
    5559,  5563,  5567,  5574,  5578,  5582,  5586,  5594,  5601,  5601,
    5601,  5609,  5609,  5609,  5616,  5623,  5627,  5631,  5635,  5639,
    5643,  5647,  5651,  5655,  5659,  5666,  5670,  5678,  5681,  5686,
    5697,  5701,  5706,  5713,  5713,  5721,  5721,  5729,  5729,  5737,
    5737,  5745,  5745,  5753,  5752,  5762,  5765,  5769,  5773,  5780,
    5780,  5786,  5786,  5794,  5795,  5796,  5797,  5798,  5799,  5800,
    5801,  5802,  5806,  5821,  5828,  5838,  5842,  5853,  5860,  5874,
    5878,  5889,  5894,  5902,  5902,  5911,  5911,  5919,  5923,  5927,
    5931,  5935,  5943,  5947,  5951,  5955,  5967,  5985,  6018,  6022,
    6029,  6037,  6036,  6049,  6052,  6056,  6063,  6067,  6071,  6075,
    6079,  6086,  6090,  6094,  6098,  6105,  6109,  6113,  6117,  6126,
    6125,  6142,  6151,  6150,  6163,  6166,  6170,  6177,  6181,  6185,
    6189,  6196,  6200,  6207,  6212,  6220,  6228,  6237,  6245,  6248,
    6252,  6259,  6263,  6267,  6271,  6275,  6279,  6283,  6287,  6291,
    6295,  6303,  6311,  6311,  6310,  6319,  6332,  6348,  6352,  6359,
    6366,  6370,  6370,  6378,  6382,  6382
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "NOELSE", "ELSE",
  "START_SYMBOL_EXPRESSION", "START_SYMBOL_BLOCKLIST",
  "START_SYMBOL_TRANSUNIT", "IDENTIFIER", "TYPE_NAME", "CONSTANT",
  "STRING_LITERAL", "PTR_OP", "INC_OP", "DEC_OP", "LEFT_OP", "RIGHT_OP",
  "LE_OP", "GE_OP", "EQ_OP", "NE_OP", "AND_OP", "OR_OP", "MUL_ASSIGN",
  "DIV_ASSIGN", "MOD_ASSIGN", "ADD_ASSIGN", "SUB_ASSIGN", "LEFT_ASSIGN",
  "RIGHT_ASSIGN", "AND_ASSIGN", "XOR_ASSIGN", "OR_ASSIGN", "SIZEOF",
  "TYPEDEF", "EXTERN", "STATIC", "AUTO", "REGISTER", "RESTRICT", "CHAR",
  "SHORT", "INT", "LONG", "SIGNED", "UNSIGNED", "FLOAT", "DOUBLE", "CONST",
  "VOLATILE", "VOID", "INLINE", "UBOOL", "UCOMPLEX", "UIMAGINARY",
  "STRUCT", "UNION", "ENUM", "ELLIPSIS", "CASE", "DEFAULT", "IF", "SWITCH",
  "WHILE", "DO", "FOR", "GOTO", "CONTINUE", "BREAK", "RETURN",
  "__BUILTIN_VA_ARG", "__BUILTIN_OFFSETOF", "__BUILTIN_TYPES_COMPATIBLE_P",
  "__ATTRIBUTE__", "__ASM__", "PRAGMA_OTHER", "PRAGMA_OMP",
  "PRAGMA_OMP_THREADPRIVATE", "OMP_PARALLEL", "OMP_SECTIONS", "OMP_NOWAIT",
  "OMP_ORDERED", "OMP_SCHEDULE", "OMP_STATIC", "OMP_DYNAMIC", "OMP_GUIDED",
  "OMP_RUNTIME", "OMP_AUTO", "OMP_SECTION", "OMP_AFFINITY", "OMP_SINGLE",
  "OMP_MASTER", "OMP_CRITICAL", "OMP_BARRIER", "OMP_ATOMIC", "OMP_FLUSH",
  "OMP_PRIVATE", "OMP_FIRSTPRIVATE", "OMP_LASTPRIVATE", "OMP_SHARED",
  "OMP_DEFAULT", "OMP_NONE", "OMP_REDUCTION", "OMP_COPYIN",
  "OMP_NUMTHREADS", "OMP_COPYPRIVATE", "OMP_FOR", "OMP_IF", "OMP_TASK",
  "OMP_UNTIED", "OMP_TASKWAIT", "OMP_COLLAPSE", "OMP_FINAL",
  "OMP_MERGEABLE", "OMP_TASKYIELD", "OMP_READ", "OMP_WRITE", "OMP_CAPTURE",
  "OMP_UPDATE", "OMP_MIN", "OMP_MAX", "OMP_PROCBIND", "OMP_CLOSE",
  "OMP_SPREAD", "OMP_SIMD", "OMP_INBRANCH", "OMP_NOTINBRANCH",
  "OMP_UNIFORM", "OMP_LINEAR", "OMP_ALIGNED", "OMP_SIMDLEN", "OMP_SAFELEN",
  "OMP_DECLARE", "OMP_TARGET", "OMP_DATA", "OMP_DEVICE", "OMP_MAP",
  "OMP_ALLOC", "OMP_TO", "OMP_FROM", "OMP_TOFROM", "OMP_END", "OMP_TEAMS",
  "OMP_DISTRIBUTE", "OMP_NUMTEAMS", "OMP_THREADLIMIT", "OMP_DISTSCHEDULE",
  "OMP_DEPEND", "OMP_IN", "OMP_OUT", "OMP_INOUT", "OMP_TASKGROUP",
  "OMP_SEQ_CST", "OMP_CANCEL", "OMP_INITIALIZER",
  "PRAGMA_OMP_CANCELLATIONPOINT", "PRAGMA_OMP_DECLARETARGET",
  "PRAGMA_OMP_ENDDECLARETARGET", "OMP_HINT", "OMP_SOURCE", "OMP_SINK",
  "OMP_RELEASE", "OMP_DELETE", "OMP_ALWAYS", "OMP_ENTER", "OMP_EXIT",
  "OMP_IS_DEVICE_PTR", "OMP_USE_DEVICE_PTR", "OMP_PRIORITY",
  "OMP_TASKLOOP", "OMP_THREADS", "OMP_LINK", "OMP_DEFAULTMAP",
  "OMP_SCALAR", "OMP_MONOTONIC", "OMP_NONMONOTONIC", "OMP_INREDUCTION",
  "OMP_TASKREDUCTION", "OMP_INSCAN", "OMP_PRIMARY", "OMP_MASKED",
  "OMP_FILTER", "PRAGMA_OMPIX", "OMPIX_TASKDEF", "OMPIX_TASKSYNC",
  "OMPIX_UPONRETURN", "OMPIX_ATNODE", "OMPIX_DETACHED", "OMPIX_ATWORKER",
  "OMPIX_TASKSCHEDULE", "OMPIX_STRIDE", "OMPIX_START", "OMPIX_SCOPE",
  "OMPIX_NODES", "OMPIX_WORKERS", "OMPIX_LOCAL", "OMPIX_GLOBAL",
  "OMPIX_HERE", "OMPIX_REMOTE", "OMPIX_HINTS", "OMPIX_TIED",
  "OMPIX_PROCEXTERN", "OMPIX_TAG", "'('", "')'", "'['", "']'", "'.'",
  "'{'", "'}'", "','", "'&'", "'*'", "'+'", "'-'", "'~'", "'!'", "'/'",
  "'%'", "'<'", "'>'", "'^'", "'|'", "'?'", "':'", "'='", "';'", "'\\n'",
  "$accept", "start_trick", "enumeration_constant", "string_literal",
  "primary_expression", "postfix_expression", "argument_expression_list",
  "unary_expression", "unary_operator", "cast_expression",
  "multiplicative_expression", "additive_expression", "shift_expression",
  "relational_expression", "equality_expression", "AND_expression",
  "exclusive_OR_expression", "inclusive_OR_expression",
  "logical_AND_expression", "logical_OR_expression",
  "conditional_expression", "assignment_expression", "assignment_operator",
  "expression", "constant_expression", "declaration",
  "declaration_specifiers", "init_declarator_list", "init_declarator",
  "$@1", "storage_class_specifier", "type_specifier",
  "struct_or_union_specifier", "struct_or_union",
  "struct_declaration_list", "struct_declaration",
  "specifier_qualifier_list", "struct_declarator_list",
  "struct_declarator", "enum_specifier", "enumerator_list", "enumerator",
  "type_qualifier", "function_specifier", "declarator",
  "direct_declarator", "pointer", "type_qualifier_list",
  "parameter_type_list", "parameter_list", "parameter_declaration",
  "identifier_list", "type_name", "abstract_declarator",
  "direct_abstract_declarator", "typedef_name", "initializer",
  "initializer_list", "designation", "designator_list", "designator",
  "statement", "statement_for_labeled", "labeled_statement",
  "compound_statement", "@2", "block_item_list", "block_item",
  "expression_statement", "selection_statement", "iteration_statement",
  "iteration_statement_for", "jump_statement", "translation_unit",
  "external_declaration", "function_definition",
  "normal_function_definition", "$@3", "$@4",
  "oldstyle_function_definition", "$@5", "$@6", "declaration_list",
  "asm_statement", "asm_stmtrest", "asm_qualifiers", "asm_qualifier",
  "asm_output", "asm_outoperand", "asm_input", "asm_inoperand",
  "asm_clobbers", "labellist", "attribute_optseq", "attribute_seq",
  "attribute", "attribute_name_list", "attribute_name", "attr_name",
  "declaration_definition", "function_statement",
  "declarations_definitions_seq", "openmp_construct", "openmp_directive",
  "structured_block", "parallel_construct", "parallel_directive",
  "parallel_clause_optseq", "parallel_clause", "unique_parallel_clause",
  "$@7", "$@8", "$@9", "for_construct", "for_directive",
  "for_clause_optseq", "for_clause", "unique_for_clause", "$@10", "$@11",
  "schedule_kind", "schedule_mod", "sections_construct",
  "sections_directive", "sections_clause_optseq", "sections_clause",
  "section_scope", "section_sequence", "section_directive",
  "single_construct", "single_directive", "single_clause_optseq",
  "single_clause", "unique_single_clause", "$@12", "simd_construct",
  "simd_directive", "simd_clause_optseq", "simd_clause",
  "unique_simd_clause", "inbranch_clause", "uniform_clause", "$@13",
  "linear_clause", "$@14", "aligned_clause", "$@15", "optional_expression",
  "declare_simd_construct", "declare_simd_directive_seq",
  "declare_simd_directive", "declare_simd_clause_optseq",
  "declare_simd_clause", "for_simd_construct", "for_simd_directive",
  "for_simd_clause_optseq", "for_simd_clause",
  "parallel_for_simd_construct", "parallel_for_simd_directive",
  "parallel_for_simd_clause_optseq", "parallel_for_simd_clause",
  "target_data_construct", "target_data_directive",
  "target_data_clause_optseq", "target_data_clause", "device_clause",
  "$@16", "map_clause", "$@17", "$@18", "map_modifier", "map_type",
  "use_device_ptr_clause", "$@19", "defaultmap_clause",
  "is_device_ptr_clause", "$@20", "target_construct", "@21",
  "target_directive", "target_clause_optseq", "target_clause",
  "unique_target_clause", "target_enter_data_directive",
  "target_enter_data_clause_seq", "target_enter_data_clause",
  "target_exit_data_directive", "target_exit_data_clause_seq",
  "target_exit_data_clause", "target_update_directive",
  "target_update_clause_seq", "target_update_clause", "filter_clause",
  "$@22", "motion_clause", "$@23", "$@24", "declare_target_construct",
  "declare_target_directive", "end_declare_target_directive",
  "declare_target_directive_v45", "declare_target_clause_optseq",
  "unique_declare_target_clause", "$@25", "$@26", "teams_construct",
  "teams_directive", "teams_clause_optseq", "teams_clause",
  "unique_teams_clause", "$@27", "$@28", "numteamsopt",
  "distribute_construct", "distribute_directive",
  "distribute_clause_optseq", "distribute_clause",
  "unique_distribute_clause", "$@29", "distribute_simd_construct",
  "distribute_simd_directive", "distribute_simd_clause_optseq",
  "distribute_simd_clause", "distribute_parallel_for_construct",
  "distribute_parallel_for_directive",
  "distribute_parallel_for_clause_optseq",
  "distribute_parallel_for_clause",
  "distribute_parallel_for_simd_construct",
  "distribute_parallel_for_simd_directive",
  "distribute_parallel_for_simd_clause_optseq",
  "distribute_parallel_for_simd_clause", "target_teams_construct",
  "target_teams_directive", "target_teams_clause_optseq",
  "target_teams_clause", "target_parallel_construct",
  "target_parallel_directive", "target_parallel_clause_optseq",
  "target_parallel_clause", "teams_distribute_construct",
  "teams_distribute_directive", "teams_distribute_clause_optseq",
  "teams_distribute_clause", "teams_distribute_simd_construct",
  "teams_distribute_simd_directive", "teams_distribute_simd_clause_optseq",
  "teams_distribute_simd_clause", "target_teams_distribute_construct",
  "target_teams_distribute_directive",
  "target_teams_distribute_clause_optseq",
  "target_teams_distribute_clause",
  "target_teams_distribute_simd_construct",
  "target_teams_distribute_simd_directive",
  "target_teams_distribute_simd_clause_optseq",
  "target_teams_distribute_simd_clause",
  "teams_distribute_parallel_for_construct",
  "teams_distribute_parallel_for_directive",
  "teams_distribute_parallel_for_clause_optseq",
  "teams_distribute_parallel_for_clause",
  "target_teams_distribute_parallel_for_construct",
  "target_teams_distribute_parallel_for_directive",
  "target_teams_distribute_parallel_for_clause_optseq",
  "target_teams_distribute_parallel_for_clause",
  "teams_distribute_parallel_for_simd_construct",
  "teams_distribute_parallel_for_simd_directive",
  "teams_distribute_parallel_for_simd_clause_optseq",
  "teams_distribute_parallel_for_simd_clause",
  "target_teams_distribute_parallel_for_simd_construct",
  "target_teams_distribute_parallel_for_simd_directive",
  "target_teams_distribute_parallel_for_simd_clause_optseq",
  "target_teams_distribute_parallel_for_simd_clause",
  "target_parallel_for_construct", "target_parallel_for_directive",
  "target_parallel_for_clause_optseq", "target_parallel_for_clause",
  "task_construct", "task_directive", "task_clause_optseq", "task_clause",
  "unique_task_clause", "$@30", "depend_clause", "$@31", "dependence_type",
  "inreduction_clause", "$@32", "parallel_for_construct",
  "parallel_for_directive", "parallel_for_clause_optseq",
  "parallel_for_clause", "parallel_sections_construct",
  "parallel_sections_directive", "parallel_sections_clause_optseq",
  "parallel_sections_clause", "master_construct", "master_directive",
  "critical_construct", "critical_directive", "region_phrase",
  "hint_clause", "barrier_directive", "taskwait_directive",
  "taskgroup_construct", "taskgroup_directive", "taskgroup_clause_optseq",
  "taskreduction_clause", "$@33", "taskyield_directive",
  "atomic_construct", "atomic_directive", "masked_construct",
  "masked_directive", "masked_clause_opt", "atomic_clause_opt",
  "seq_cst_clause_opt", "flush_directive", "flush_vars", "$@34",
  "ordered_construct", "ordered_directive_full",
  "ordered_directive_standalone", "ordered_clause_optseq_full",
  "ordered_clause_type_full", "ordered_clause_optseq_standalone",
  "ordered_clause_depend_sink", "sink_vec", "sink_vec_elem",
  "cancel_directive", "construct_type_clause",
  "cancellation_point_directive", "threadprivate_directive", "$@35",
  "$@36", "declare_reduction_directive", "$@37", "$@38",
  "reduction_identifier", "reduction_type_list", "initializer_clause_opt",
  "data_default_clause", "data_privatization_clause", "$@39",
  "data_privatization_in_clause", "$@40", "data_privatization_out_clause",
  "$@41", "data_sharing_clause", "$@42", "data_reduction_clause", "$@43",
  "$@44", "reduction_modifier", "if_clause", "$@45", "$@46",
  "if_related_construct", "collapse_clause", "variable_list",
  "variable_array_section_list", "varid_or_array_section",
  "funcname_variable_array_section_list", "funcvarid_or_array_section",
  "array_section_slice_list", "$@47", "$@48", "array_section_slice",
  "procbind_clause", "thrprv_variable_list", "ompix_directive",
  "ox_tasksync_directive", "ox_taskschedule_directive", "$@49",
  "ox_taskschedule_clause_optseq", "ox_taskschedule_clause",
  "ox_scope_spec", "ompix_construct", "ox_taskdef_construct", "$@50",
  "ox_taskdef_directive", "$@51", "ox_taskdef_clause_optseq",
  "ox_taskdef_clause", "ox_variable_size_list", "ox_variable_size_elem",
  "ox_task_construct", "ox_task_directive", "ox_task_clause_optseq",
  "ox_task_clause", "ox_procextern_construct", "ox_procextern_directive",
  "$@52", "$@53", "extern_variable_list", "ox_tag_construct",
  "ox_tag_directive", "ox_tag_clause", "$@54", "tag_clause", "$@55", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,    40,    41,    91,    93,    46,   123,   125,
      44,    38,    42,    43,    45,   126,    33,    47,    37,    60,
      62,    94,   124,    63,    58,    61,    59,    10
};
# endif

#define YYPACT_NINF -1421

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1421)))

#define YYTABLE_NINF -970

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    2981,  2861,  1865,  3051, -1421, -1421, -1421, -1421, -1421, -1421,
   -1421, -1421, -1421, -1421, -1421, -1421, -1421, -1421, -1421, -1421,
   -1421, -1421, -1421, -1421, -1421, -1421, -1421, -1421, -1421,    24,
     -20, -1421,    28, -1421,   279,   233,   151,   371,   221, -1421,
      83,  5151,  5151, -1421,    24, -1421,  5151,  5151,   260,   194,
      81, -1421,  3051, -1421, -1421, -1421, -1421, -1421, -1421,  3354,
   -1421, -1421,  3231, -1421, -1421, -1421, -1421,  3410, -1421, -1421,
     305, -1421, -1421,  2907,  2907,  2933,   331,   340,   344,  2185,
   -1421, -1421, -1421, -1421, -1421, -1421,   452, -1421,   465,   100,
    2861, -1421,   255,   516,   725,   140,   735,   345,   363,   317,
     565,    79, -1421, -1421,   384,  -111,  2861,   382,   393,   418,
     444,  1989,   446,   636,   433,   443,  1259,   451, -1421,  4828,
     819,   670,   448, -1421,   -32, -1421,    83, -1421, -1421, -1421,
    1865, -1421, -1421, -1421, -1421, -1421, -1421, -1421, -1421, -1421,
   -1421,  1989, -1421,   609, -1421,   482, -1421,  1989, -1421,   609,
   -1421,   609, -1421,   609, -1421,  1989, -1421, -1421, -1421, -1421,
   -1421, -1421,  1989, -1421,   609, -1421,   609, -1421,   609, -1421,
    1989, -1421,  1989, -1421,  1989, -1421,   609, -1421,   609, -1421,
     609, -1421,   609, -1421,   609, -1421,   609, -1421,   609, -1421,
     609, -1421,   609, -1421,  1989, -1421,   609, -1421,   482, -1421,
    1989, -1421,  1989, -1421, -1421, -1421,  1989, -1421, -1421,  1292,
   -1421,  1989, -1421, -1421,  1989, -1421, -1421, -1421, -1421, -1421,
   -1421, -1421, -1421, -1421,   686, -1421, -1421,    23,  3051,   134,
      24, -1421,   496,    -4,   499, -1421, -1421,   699, -1421,   289,
   -1421, -1421, -1421,   513, -1421, -1421,   371, -1421, -1421,   186,
   -1421,   463, -1421, -1421,   139, -1421, -1421,   544,  3847,  3727,
    2270,   194, -1421,   638,   151, -1421, -1421, -1421, -1421, -1421,
   -1421,  3174,   151, -1421,   560,  2861,  2185, -1421, -1421,  2185,
   -1421,  2861,  3749,  3749,   -55,  3749,   584,  3749,   569, -1421,
     785, -1421, -1421,  2861,  2861,   806, -1421, -1421, -1421, -1421,
   -1421, -1421, -1421, -1421, -1421, -1421, -1421,  2861, -1421, -1421,
    2861,  2861,  2861,  2861,  2861,  2861,  2861,  2861,  2861,  2861,
    2861,  2861,  2861,  2861,  2861,  2861,  2861,  2861,  2861,  2861,
      24, -1421,   559,  1579,  2861,  2861,  2861,  4924,   -21,   802,
    1936,   572, -1421, -1421, -1421,   297, -1421, -1421,   665,   862,
   -1421,   451, -1421,    86, -1421,   730, -1421,   658,   -92,   661,
    1481,   203,   790, -1421,   692,   694, -1421,   635,   801,    39,
   -1421,   819,   765, -1421, -1421, -1421, -1421,   738, -1421,   742,
   -1421,   750,   759, -1421,  1865, -1421,   773, -1421, -1421, -1421,
   -1421,  2061, -1421, -1421, -1421, -1421, -1421, -1421,  1989, -1421,
   -1421, -1421, -1421, -1421, -1421, -1421, -1421, -1421, -1421, -1421,
   -1421, -1421, -1421, -1421, -1421, -1421, -1421, -1421, -1421, -1421,
   -1421, -1421, -1421, -1421,   805, -1421, -1421,   798,  1005,   810,
   -1421,  1488,   818, -1421,  1037,   844,   857,   828,   328, -1421,
       1, -1421, -1421, -1421,   859, -1421, -1421, -1421,   151, -1421,
   -1421,   544,  3847,   899,  3529,   908, -1421, -1421,  3671, -1421,
   -1421,   146,   863,   882, -1421,   582,  2336, -1421,   888,   913,
    2319,  1007,   927,   921, -1421, -1421, -1421,   544,   602, -1421,
     934,   942,   946,   953,   971, -1421, -1421,  3480,  2483,   204,
   -1421,   300, -1421,  2530, -1421, -1421,   625,   231, -1421, -1421,
   -1421, -1421, -1421, -1421,   255,   255,   516,   516,   725,   725,
     725,   725,   140,   140,   735,   345,   363,   317,   565,   441,
   -1421,  1989,  1579,  4821, -1421, -1421, -1421,   629,   646,   648,
      74,   994,  1537,   318,  1813, -1421, -1421,   862,    72, -1421,
   -1421, -1421,  1069,  1733,   669,  1013,   299,   -66, -1421,  1141,
   -1421,  1196, -1421,   -63, -1421, -1421, -1421, -1421, -1421,  1056,
   -1421, -1421,  1020, -1421,   930,  3149, -1421, -1421,  1221,  1122,
    1174, -1421,  1099,  1132,  1137,  3335,    62,   474,  1150, -1421,
     830,   342,   -14,  1076, -1421,  1059, -1421,   327, -1421, -1421,
     862, -1421,  1656,  4904, -1421,    10,  1989, -1421,  2861,  1005,
   -1421,  1058,   651, -1421,  1005, -1421, -1421, -1421,   676, -1421,
    1088,   803,  1025, -1421,   705,   699,  1288, -1421,  1117,  1084,
     699, -1421,   372,  1335, -1421,  2585, -1421,  3671,  3749, -1421,
    3551, -1421,   163,  3749, -1421, -1421,  3301, -1421,   177, -1421,
   -1421,  5101, -1421,  1338,  1109,  2336, -1421, -1421,  2861, -1421,
    1129,  1142, -1421, -1421, -1421,  2861,  1158,  1158,  3749,  1362,
    3749, -1421,  1153,  1169, -1421,  1172,  1176,   300,  3798,  2601,
    2417, -1421, -1421, -1421,  2861, -1421, -1421,  1989,  1989,  1989,
    2861,  2632,   325,  2085,  2650,   336,    58, -1421,    98,  1425,
   -1421,  4358, -1421, -1421, -1421, -1421,  1181,  1202, -1421,  1210,
    1224,  1227,  3054, -1421, -1421, -1421, -1421, -1421, -1421, -1421,
   -1421, -1421, -1421, -1421, -1421,  1278, -1421, -1421, -1421, -1421,
   -1421, -1421,   776, -1421, -1421,    29, -1421, -1421,  1229,  1262,
   -1421, -1421, -1421, -1421,   787, -1421, -1421, -1421, -1421, -1421,
    1233,  1248, -1421,  1236, -1421,  1239,  1446, -1421,  4115, -1421,
    1298,  1323,  1339,  1357,  1484, -1421, -1421, -1421, -1421, -1421,
   -1421, -1421, -1421, -1421, -1421,  1366, -1421,  1371,  1375,  1376,
    2627, -1421, -1421, -1421, -1421, -1421, -1421, -1421, -1421, -1421,
   -1421, -1421, -1421,  1381,  2078, -1421, -1421, -1421, -1421, -1421,
   -1421, -1421, -1421, -1421, -1421, -1421,  4073, -1421,  1382, -1421,
   -1421, -1421,   684, -1421, -1421, -1421, -1421,   887,    78,  3033,
     852,   884, -1421,  1385,  1388,  1391,  2006, -1421, -1421, -1421,
   -1421, -1421, -1421, -1421, -1421, -1421, -1421, -1421,  1404, -1421,
    1345,  1397,  1399,  1245, -1421, -1421, -1421, -1421, -1421, -1421,
   -1421, -1421,  1389,  2727,  1401,   939, -1421, -1421, -1421, -1421,
   -1421, -1421, -1421,  1403,  1361, -1421, -1421,  1469, -1421,  1384,
   -1421, -1421,  1429, -1421,  1433,  1434, -1421,  1453, -1421,   616,
   -1421, -1421,   891,   122, -1421,  1430,  1570, -1421,  1989, -1421,
     720,   772,  2861, -1421,   102,   786,  1455,  1488,  2861, -1421,
   -1421, -1421, -1421, -1421, -1421, -1421, -1421, -1421, -1421, -1421,
    1436, -1421, -1421, -1421,  1458,  1499, -1421, -1421, -1421, -1421,
   -1421, -1421, -1421,  1654,   741,   828,   745, -1421,  1407, -1421,
   -1421, -1421,  1460,  1465,  1468,  1470,   556, -1421, -1421, -1421,
     758,  2417, -1421, -1421, -1421,  3600, -1421, -1421,  2861, -1421,
     379, -1421,  1448,  3622, -1421, -1421, -1421, -1421,  1471,  1472,
   -1421, -1421, -1421,  1475,  1476,  1477, -1421, -1421, -1421, -1421,
   -1421,  1478, -1421,  1482,  1508,  2861,  1061, -1421,   895,  2585,
     197, -1421, -1421,  1671, -1421, -1421,   762,  1989,   838,  2677,
    2698,   394,  1989,   839,  2748,  1450,  1668,   105,   287, -1421,
    2316, -1421, -1421, -1421, -1421, -1421, -1421, -1421, -1421, -1421,
   -1421,  4241,  4787, -1421, -1421, -1421, -1421, -1421, -1421, -1421,
   -1421, -1421, -1421, -1421,  1532,  1533,  1534,  1535,   480,   726,
    1536, -1421,   931,   419, -1421,  1538, -1421,  1480,  1463, -1421,
    1582, -1421,  1540, -1421, -1421,  2861, -1421, -1421, -1421,   848,
    3925, -1421, -1421, -1421, -1421,  2861,    16,  2861,   862, -1421,
   -1421,  1011,  2861,   803, -1421,  1541,  1542,  2861, -1421,  3979,
   -1421,  4400, -1421, -1421, -1421, -1421, -1421, -1421, -1421, -1421,
   -1421, -1421, -1421, -1421,  1543,  1544,  1174, -1421, -1421,  1551,
     351, -1421, -1421, -1421, -1421, -1421, -1421,  1649, -1421,  1289,
   -1421,  4962, -1421, -1421, -1421, -1421, -1421, -1421, -1421, -1421,
   -1421,   702, -1421, -1421, -1421, -1421, -1421, -1421,   740, -1421,
   -1421, -1421,   216, -1421,  1616, -1421,  1633,  1670,  1711, -1421,
   -1421, -1421, -1421, -1421, -1421, -1421, -1421, -1421, -1421,  4306,
    1078, -1421, -1421, -1421, -1421, -1421,  1675, -1421,   803, -1421,
    1546, -1421,  2861,  2861,  2861,  2438,  2861, -1421, -1421,  1556,
    1557,  1559, -1421,   304, -1421, -1421, -1421,  1554, -1421, -1421,
    1539, -1421,   114, -1421, -1421, -1421, -1421,   128, -1421, -1421,
     855,  3820,  1567,  2861, -1421,  1547, -1421, -1421,  1117, -1421,
    1288,  2861,   457,  1565,  1407,   803,  1767,  1767,  1767, -1421,
   -1421,  1768,   918, -1421, -1421,    57, -1421,  2861, -1421, -1421,
   -1421, -1421, -1421, -1421, -1421, -1421, -1421,  1572, -1421, -1421,
   -1421,  2252, -1421, -1421, -1421,  1989,  1553, -1421,  1989,  1989,
     867,  1989,   886,  2769, -1421,  1989,  1989,   889,   178,  1574,
    2907, -1421,    98,   178, -1421,  4679, -1421, -1421, -1421, -1421,
   -1421,  1446,  1446,  1446,  1446,  1581,  1584,  1585, -1421, -1421,
   -1421, -1421,  1573,  1446,  2861, -1421, -1421, -1421,   497, -1421,
    2861,  1562,  1592,  1593,  1596,  1598,  1446,  1576,  1796,  1446,
     911, -1421,  1798, -1421,   919,  1607,  1594,  1595,   674,   967,
     126,  2861, -1421, -1421, -1421, -1421,   974, -1421,  1446,  1446,
     978, -1421,  4565, -1421, -1421, -1421, -1421, -1421, -1421,  2861,
    1288,  1288, -1421, -1421, -1421,  1701,  4021, -1421,  4339, -1421,
   -1421, -1421, -1421, -1421, -1421, -1421,   852, -1421, -1421,   884,
   -1421, -1421,  1618,  1288,   949,  1446,  1617, -1421,  4279,  2460,
   -1421, -1421, -1421, -1421, -1421, -1421, -1421,  2861,  2861,  4205,
    4751, -1421, -1421, -1421, -1421, -1421,   990, -1421, -1421,   992,
    1001,  1015,  1627,  1638,  1639,  1640,  1641,  2861,  2861,  1038,
   -1421,  2861, -1421, -1421, -1421, -1421, -1421,   468,  1446,  1026,
   -1421, -1421,   384,  2861, -1421,  1642,  1623,  1644,  1039, -1421,
    1051,  1054,  1624, -1421, -1421,  2369, -1421, -1421, -1421, -1421,
   -1421,  2585, -1421, -1421, -1421, -1421,  1989, -1421,  1989,  1989,
    1064, -1421, -1421,  1989,  1842,   158,   485, -1421,   862,  1648,
   -1421,   431, -1421,  1074,  1089,  1091,  1106, -1421, -1421, -1421,
    1629,   803,  1110,  1114, -1421, -1421,  1724,  1726,  1130, -1421,
   -1421, -1421, -1421, -1421,  1149, -1421,  1113,  1657,  1652,  1151,
   -1421, -1421, -1421, -1421, -1421, -1421, -1421, -1421, -1421, -1421,
   -1421, -1421,  1161, -1421, -1421,  1653,  1188,  1662, -1421,  1663,
     487,   487, -1421, -1421,  1193,  1204,  1206,  1446, -1421,  3897,
   -1421,  4942, -1421, -1421, -1421, -1421, -1421, -1421, -1421, -1421,
   -1421,  1218, -1421, -1421, -1421, -1421, -1421, -1421,  1664,  1219,
    1704,  4153,  4715, -1421, -1421, -1421, -1421, -1421,   512,  1235,
    4643, -1421, -1421, -1421, -1421, -1421, -1421, -1421,  1665, -1421,
   -1421, -1421, -1421, -1421, -1421, -1421, -1421,  1677,  1686, -1421,
    1681,  1688,  1242,  3820, -1421,  1249, -1421,   384, -1421,  1767,
    2150, -1421,  1767, -1421, -1421, -1421, -1421, -1421, -1421, -1421,
   -1421,  1989, -1421,  1687,  2861,   178,   862,   173, -1421, -1421,
     862, -1421, -1421, -1421, -1421,  1288, -1421, -1421, -1421, -1421,
   -1421, -1421,  2861, -1421,  2861,  2861, -1421,  1796, -1421,  2861,
   -1421, -1421,  2861, -1421,  1288,  1288,  2861,  1690,  1691, -1421,
   -1421, -1421,  1254,  3845, -1421,  4494, -1421, -1421, -1421, -1421,
   -1421, -1421, -1421, -1421, -1421,  1692,  4607, -1421, -1421, -1421,
   -1421, -1421,  2861,  1719, -1421, -1421,  2861,  1288, -1421, -1421,
    1143, -1421, -1421, -1421,  2861, -1421,  1272,  1940,  1745, -1421,
   -1421,   862,  1276, -1421,   452,   514,  2907,  1277,  1290,  1728,
    1305,   255,   255, -1421,  1307,  2861,  1310,  1326,  1327,   384,
   -1421, -1421, -1421, -1421,  4442, -1421, -1421, -1421, -1421, -1421,
   -1421,  1288, -1421, -1421,   384, -1421,  1329,  1330, -1421, -1421,
    1331, -1421,  1747, -1421,   182, -1421,   862,  1946,  1751, -1421,
   -1421,  1288, -1421, -1421,  1348, -1421, -1421, -1421, -1421,  1349,
   -1421, -1421, -1421, -1421,  2861,   452, -1421,  1352, -1421,  1353,
   -1421, -1421,  1802,  1363, -1421,  1949, -1421,  1755,  1732, -1421,
   -1421,  1953, -1421,   -91,  2861,  2861,  1373,  1758,  1759, -1421,
   -1421
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,     0,     0,     0,   170,   215,   110,   111,   112,   113,
     114,   164,   116,   117,   118,   119,   122,   123,   120,   121,
     163,   165,   115,   167,   124,   125,   126,   136,   137,   322,
       0,   284,     0,   868,     0,     0,     0,   184,     0,   281,
       0,    97,    99,   127,   322,   128,   101,   103,   293,   168,
       0,   129,     2,   278,   280,   285,   286,   166,    94,     0,
     483,    95,     0,   587,    93,    96,   282,     0,   283,  1001,
       9,    10,     7,     0,     0,     0,     0,     0,     0,     0,
      37,    38,    39,    40,    41,    42,    11,    13,    28,    43,
       0,    45,    49,    52,    55,    60,    63,    65,    67,    69,
      71,    73,    75,    88,     3,     9,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   238,     0,
       0,     0,   245,   253,     0,   249,     0,   250,   229,   230,
       4,   247,   231,   232,   233,   260,   234,   235,   236,   251,
     340,     0,   341,     0,   342,     0,   343,     0,   351,     0,
     352,     0,   353,     0,   354,     0,   355,   537,   381,   382,
     380,   356,     0,   357,     0,   358,     0,   359,     0,   360,
       0,   361,     0,   362,     0,   364,     0,   365,     0,   366,
       0,   367,     0,   368,     0,   369,     0,   370,     0,   371,
       0,   363,     0,   350,     0,   344,     0,   345,     0,   346,
       0,   347,     0,   374,   376,   372,     0,   377,   348,     0,
     373,     0,   375,   349,     0,   842,   378,   379,   252,   948,
     949,   237,   965,   966,     0,   967,   968,     0,     5,     0,
     323,   324,     0,     0,     0,   595,   597,     0,   588,     0,
     592,   972,  1002,     0,   188,   186,   185,     1,    91,     0,
     105,   291,    98,   100,     0,   102,   104,     0,     0,     0,
       0,   169,   279,     0,     0,   337,   482,   484,   336,   335,
     338,     0,     0,   289,   971,    25,     0,    29,    30,     0,
      32,     0,     0,     0,     0,   142,   199,   144,     0,     8,
       0,    21,    22,    25,     0,     0,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    77,     0,    43,    31,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     322,    90,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   274,   275,   276,     0,   306,   307,     0,     0,
     297,     0,   304,   386,   434,   846,   449,     0,     0,     0,
     830,     0,   405,   756,     0,     0,   460,   540,   601,   618,
     818,     0,   828,   863,   864,   865,   866,     0,   988,     0,
     951,     0,     0,   244,     0,   254,   107,   248,   383,   384,
     403,     0,   432,   447,   458,   494,   501,   508,     0,   599,
     616,   629,   637,   644,   651,   661,   676,   685,   694,   704,
     713,   720,   729,   736,   745,   754,   779,   793,   806,   808,
     816,   824,   826,   841,     0,  1007,  1008,   157,     0,   158,
     325,   329,     0,   486,     0,     0,     0,   931,     0,   929,
       0,   591,   593,   974,     0,   171,   189,   187,     0,    92,
     108,     0,     0,   134,     0,   135,   290,   295,     0,   197,
     182,   195,     0,   190,   192,     0,     0,   172,    38,     0,
       0,     0,   291,     0,   339,   586,   287,     0,     0,    26,
       0,     0,     0,     0,     0,    12,   143,     0,     0,   201,
     200,   202,   145,     0,    18,    20,     0,     0,    17,    19,
      76,    46,    47,    48,    50,    51,    53,    54,    58,    59,
      56,    57,    61,    62,    64,    66,    68,    70,    72,     0,
      89,     0,     0,     0,   239,   243,   240,     0,     0,     0,
     540,     0,     0,     0,     0,   273,   277,     0,     0,   298,
     305,   795,   781,     0,     0,     0,     0,     0,   851,     0,
     807,     0,   809,     0,   814,   831,   832,   834,   833,   835,
     839,   837,     0,   496,     0,     0,   815,   823,     0,   663,
       0,   510,   653,     0,     0,     0,   678,     0,     0,   631,
       0,     0,     0,     0,   829,     0,   867,     0,   950,   953,
       0,  1009,     0,     0,   443,     0,     0,   538,    25,     0,
       6,   161,     0,   159,     0,   332,   333,   334,     0,   327,
     330,     0,     0,   946,     0,     0,     0,   935,   932,     0,
       0,   594,     0,     0,   106,     0,   288,     0,     0,   131,
       0,   138,     0,     0,   296,   294,     0,   194,   201,   196,
     181,     0,   183,     0,     0,     0,   179,   174,     0,   173,
      38,     0,   589,   970,    15,     0,     0,    33,     0,     0,
       0,   211,     0,     0,   205,    38,     0,   203,     0,     0,
       0,    44,    16,    14,     0,   241,   242,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   299,   308,     0,
     503,     0,   401,   893,   895,   899,     0,     0,   398,     0,
       0,     0,     0,   385,   387,   389,   391,   392,   393,   394,
     395,   390,   400,   441,   897,     0,   433,   435,   437,   438,
     439,   440,     0,   850,   849,     0,   843,   847,     0,     0,
     845,   852,   455,   456,     0,   448,   450,   452,   453,   454,
       0,     0,   810,     0,   836,     0,     0,   838,     0,   413,
     414,     0,     0,     0,     0,   404,   406,   408,   409,   410,
     411,   412,   421,   422,   769,     0,   770,     0,     0,     0,
       0,   755,   757,   759,   765,   766,   761,   762,   763,   764,
     760,   476,   478,     0,     0,   459,   461,   463,   470,   471,
     465,   466,   467,   464,   468,   747,     0,   579,     0,   582,
     584,   576,     0,   572,   575,   578,   577,     0,   696,     0,
       0,     0,   546,     0,     0,     0,     0,   539,   549,   550,
     551,   552,   541,   543,   545,   547,   548,   544,     0,   687,
       0,     0,     0,     0,   600,   602,   604,   605,   606,   607,
     608,   609,   639,     0,     0,     0,   617,   619,   625,   621,
     622,   623,   624,     0,     0,   817,   819,     0,   860,     0,
     580,   827,     0,   997,     0,     0,   998,     0,   996,     0,
     987,   989,     0,  1011,   246,     0,     0,   442,     0,   444,
       0,     0,     0,   151,     0,     0,     0,   329,    25,   874,
     881,   882,   883,   884,   878,   876,   875,   877,   879,   880,
       0,   472,   473,   474,     0,     0,   485,   493,   492,   490,
     491,   487,   869,     0,     0,   927,     0,   925,     0,   933,
     590,   930,     0,     0,     0,     0,     0,   973,   975,  1005,
       0,     0,   216,   109,   292,     0,   130,   139,     0,   141,
       0,   146,   148,     0,   191,   193,   198,   176,     0,     0,
     180,   175,    27,     0,     0,     0,   213,   204,   209,   207,
     212,     0,   206,    38,     0,     0,     0,   219,     0,     0,
       0,   224,    74,   255,   257,   258,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   309,
       0,   794,   798,   796,   800,   801,   802,   803,   804,   805,
     799,     0,     0,   780,   784,   785,   782,   787,   788,   789,
     790,   791,   792,   786,     0,     0,     0,     0,     0,   905,
       0,   396,   909,     0,   388,     0,   436,     0,     0,   848,
       0,   853,     0,   451,   812,     0,   811,   825,   923,     0,
       0,   495,   499,   500,   497,     0,   429,     0,     0,   407,
     767,     0,     0,     0,   758,     0,     0,     0,   462,     0,
     675,     0,   662,   666,   667,   664,   674,   669,   670,   671,
     672,   673,   668,   517,     0,     0,     0,   571,   573,     0,
       0,   509,   511,   513,   514,   516,   515,     0,   706,     0,
     660,     0,   652,   657,   656,   654,   659,   658,   561,   558,
     557,     0,   554,   560,   559,   570,   567,   566,     0,   563,
     569,   568,   523,   535,     0,   542,   715,     0,     0,   677,
     681,   684,   679,   682,   683,   610,   612,   603,   646,     0,
       0,   630,   635,   634,   632,   636,     0,   620,     0,   820,
       0,   861,     0,     0,     0,     0,     0,   990,   960,     0,
       0,     0,   959,     0,   952,   954,  1010,     0,   446,   445,
       0,   152,     0,   162,   154,   160,   153,     0,   326,   328,
       0,     0,     0,     0,   488,     0,   947,   596,   928,   598,
       0,   941,   939,     0,     0,     0,     0,     0,     0,   976,
    1003,     0,     0,   132,   150,     0,   140,     0,   133,   177,
     178,    34,    35,    36,   214,   210,   208,     0,   227,   228,
      23,     0,   220,   223,   225,     0,     0,   261,     0,     0,
       0,     0,     0,     0,   269,     0,     0,     0,   313,     0,
       0,   300,     0,   313,   797,     0,   502,   507,   504,   506,
     783,     0,     0,     0,     0,     0,     0,     0,   906,   907,
     908,   901,     0,     0,     0,   913,   914,   921,   915,   920,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   840,     0,   498,     0,     0,     0,     0,     0,     0,
    1014,     0,   774,   775,   776,   772,     0,   777,     0,     0,
       0,   753,     0,   746,   750,   748,   752,   751,   665,     0,
       0,     0,   574,   532,   512,   722,     0,   703,     0,   695,
     700,   699,   697,   702,   701,   655,     0,   553,   555,     0,
     562,   564,   524,     0,     0,     0,     0,   731,     0,     0,
     686,   690,   693,   688,   691,   692,   680,     0,     0,     0,
       0,   638,   642,   640,   643,   633,     0,   821,   862,     0,
       0,     0,     0,     0,    38,     0,     0,     0,     0,     0,
     955,     0,   986,   155,   156,   331,   885,     0,     0,     0,
     870,   926,   940,   938,   936,     0,     0,   983,     0,   981,
       0,     0,     0,  1006,   217,     0,   147,   149,   226,    24,
     221,     0,   256,   259,   264,   263,     0,   262,     0,     0,
       0,   271,   270,     0,     0,     0,     0,   314,     0,     0,
     310,     0,   505,     0,     0,     0,     0,   892,   890,   891,
       0,     0,     0,     0,   919,   916,     0,     0,     0,   911,
     942,   944,   945,   943,     0,   844,   857,     0,   855,     0,
     813,   924,   415,   419,   430,   431,   428,   423,   424,   425,
     426,   427,     0,   922,  1013,     0,     0,     0,   771,     0,
     480,   480,   469,   749,     0,     0,     0,     0,   738,     0,
     712,     0,   705,   710,   709,   707,   711,   698,   556,   565,
     525,     0,   526,   527,   528,   529,   530,   531,     0,     0,
       0,     0,     0,   714,   718,   719,   716,   689,   614,     0,
       0,   645,   650,   649,   647,   641,   626,   627,     0,   581,
    1000,   999,   993,   994,   991,   992,   995,     0,     0,   961,
     962,     0,     0,     0,   871,     0,   489,   937,   934,     0,
       0,   977,     0,   978,   979,  1004,   218,   222,   267,   266,
     265,     0,   272,     0,     0,     0,     0,     0,   312,   301,
       0,   402,   894,   896,   900,     0,   903,   399,   397,   917,
     918,   910,     0,   898,     0,     0,   854,     0,   457,     0,
     416,   417,     0,   768,     0,     0,     0,     0,     0,   518,
     583,   585,     0,     0,   728,     0,   721,   725,   726,   723,
     727,   708,   522,   519,   536,     0,     0,   730,   734,   735,
     732,   717,     0,     0,   613,   648,     0,     0,   956,   957,
       0,   958,  1012,   886,     0,   475,     0,     0,     0,   982,
     268,     0,     0,   315,   318,     0,     0,     0,     0,     0,
       0,   858,   859,   856,     0,     0,     0,     0,     0,   481,
     477,   479,   533,   744,     0,   737,   741,   742,   739,   743,
     724,     0,   534,   733,   615,   611,     0,     0,   964,   963,
       0,   980,     0,   985,     0,   317,     0,     0,     0,   302,
     902,     0,   912,   420,     0,  1015,   773,   778,   740,     0,
     628,   822,   872,   984,     0,   319,   320,     0,   311,     0,
     418,   520,   887,     0,   303,     0,   904,     0,     0,   316,
     321,     0,   873,     0,    25,     0,     0,     0,     0,   888,
     889
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1421, -1421, -1421,  -333, -1421, -1421,  -285,   -72, -1421,   -23,
    -302,  1079,  1297,  1162,  1643,  1672,  1669,  1678,  1637, -1421,
    -102,  -255, -1421,    -1,  -859,   106,  1198, -1421,  1517, -1421,
   -1421,   -73, -1421, -1421,  -411,  -590,  -225, -1421,   800, -1421,
    -161,  -838,   347, -1421,    -8,   -43,   -28,  -176,  -240, -1421,
    1360, -1421,  -206,  -235,  -407,  -215,  -601,  1036, -1150, -1421,
     998,     8,  1483, -1421,  -185, -1421,  1614,  -117,  1801, -1421,
   -1421,  5066, -1421,  2008,   143,    26,  1947, -1421, -1421, -1421,
   -1421, -1421,  1563, -1421,  1666, -1421,  1667, -1421,   791,   797,
     486,   469, -1421,    -9, -1421,    -2, -1421,  1145, -1421,  1762,
   -1421, -1421,  1807,  -160,   906, -1421, -1421, -1421,  1333,  -502,
   -1421, -1421, -1421, -1421, -1421, -1421,  -414,  -547, -1421, -1421,
   -1421, -1421, -1421, -1421, -1421,  1321,  1839, -1421,  1443, -1421,
   -1421, -1421,  1306, -1421, -1421, -1421, -1421, -1421,  1257,  -474,
   -1421, -1421, -1421,  -591, -1421,  -583, -1421,   581, -1421, -1421,
    1984, -1421,  1139, -1421, -1421, -1421,  1006, -1421, -1421, -1421,
    -958, -1421, -1421, -1421,   965,  -540, -1421,  -707, -1421, -1421,
   -1421, -1421, -1421, -1421, -1421, -1421, -1421, -1421, -1421, -1421,
   -1421,  1246,  -743, -1421, -1421, -1053, -1421, -1421, -1051, -1421,
   -1421,  -769, -1421, -1421, -1421, -1421, -1421, -1421, -1421, -1421,
   -1421, -1421,  -125, -1421, -1421, -1421, -1421, -1421,  -532,  -184,
   -1421, -1421, -1421, -1421, -1421, -1421,  -565, -1008, -1421, -1421,
   -1421, -1421,  -818, -1421, -1421, -1421, -1061, -1421, -1421, -1421,
   -1105, -1421, -1421, -1421,   975, -1421, -1421, -1421,  1009, -1421,
   -1421, -1421,  -799, -1421, -1421, -1421, -1068, -1421, -1421, -1421,
     774, -1421, -1421, -1421,   596, -1421, -1421, -1421, -1101, -1421,
   -1421, -1421,   498, -1421, -1421, -1421, -1420, -1421, -1421, -1421,
     440, -1421, -1421, -1421,   793, -1421, -1421, -1421,  1317, -1421,
   -1421,  -511, -1421, -1421, -1421, -1421, -1421, -1421, -1421,  -628,
   -1421, -1421, -1421,  1098, -1421, -1421, -1421, -1421, -1421, -1421,
   -1421, -1421, -1421, -1421, -1421,  1243, -1421, -1421, -1421, -1421,
   -1421, -1421, -1421, -1421, -1421, -1421, -1421, -1421, -1421, -1421,
   -1421, -1421,  1364, -1421,  -497,   523, -1421, -1421,  1729, -1421,
   -1421, -1421, -1421, -1421, -1421, -1421,  -997, -1421, -1421,   377,
    -398, -1421,    73, -1421,   159, -1421,    48, -1421,   -88, -1421,
   -1421, -1421,  -345, -1421, -1421, -1421,  -478,   -74, -1126,   924,
    1486,  1485,  1191, -1421, -1421,   923, -1421, -1421, -1421, -1421,
   -1421, -1421, -1421,   955, -1421,  1882,    44, -1421, -1421, -1421,
   -1421,  1184, -1151,   579, -1421, -1421, -1421,  1247,    55, -1421,
   -1421, -1421, -1421, -1421, -1421, -1421, -1421, -1421, -1421
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    38,   601,    86,    87,    88,   478,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   307,   124,   332,    39,   126,   249,   250,   625,
      41,    42,    43,    44,   630,   631,   286,   940,   941,    45,
     602,   603,    46,    47,    48,    49,    50,   246,   662,   463,
     464,   465,   288,   663,   491,    51,   967,   968,   969,   970,
     971,   388,   525,   128,   129,   384,   130,   131,   132,   133,
     134,   135,   136,    52,    53,    54,    55,   451,   257,    56,
     452,   258,   458,   137,   350,   351,   352,   988,   989,  1406,
    1407,  1625,  1687,   229,   230,    57,   608,   609,   610,   270,
     266,   271,   138,   139,   389,   140,   141,   543,   704,  1004,
    1254,  1020,  1014,   142,   143,   564,  1042,  1005,  1635,  1569,
    1452,  1278,   144,   145,   544,   717,   392,   595,   596,   146,
     147,   549,   736,   737,  1032,   148,   149,   568,   786,  1237,
     907,   908,  1172,   788,  1055,   789,  1056,  1577,    58,    59,
      60,   612,   911,   150,   151,   748,  1044,   152,   153,  1001,
    1502,   154,   155,   807,  1082,   818,  1299,   819,  1651,  1323,
    1324,  1488,  1085,  1467,   820,   821,  1325,   156,   398,   157,
     575,   822,   823,   158,  1101,  1102,   159,  1108,  1109,   160,
     802,   803,   584,  1142,   804,  1074,  1075,    61,    62,   475,
      63,   239,   240,   435,   436,   161,   162,   577,  1094,   836,
    1337,  1338,  1603,   163,   164,   580,  1133,   848,  1606,   165,
     166,   843,  1332,   167,   168,  1129,  1495,   169,   170,  1339,
    1599,   171,   172,   809,  1095,   173,   174,   796,  1065,   175,
     176,   830,  1311,   177,   178,  1117,  1474,   179,   180,  1089,
    1312,   181,   182,  1306,  1475,   183,   184,  1328,  1588,   185,
     186,  1469,  1589,   187,   188,  1491,  1647,   189,   190,  1583,
    1648,   191,   192,  1059,  1295,   193,   194,   565,   772,   773,
    1281,   805,  1457,  1285,   775,  1459,   195,   196,   691,  1239,
     197,   198,   689,   993,   199,   200,   201,   202,   553,   743,
     203,   204,   205,   206,   581,   856,  1508,   207,   208,   209,
     210,   211,   585,   559,   745,   212,   562,   746,   213,   214,
     215,   546,   727,   547,   548,  1437,  1438,   216,   377,   217,
      64,   234,  1175,    65,  1614,  1692,   900,  1367,  1698,  1007,
    1008,  1015,  1009,  1016,  1010,  1025,  1011,  1017,  1012,  1420,
    1629,  1252,  1013,  1260,  1562,  1261,   762,  1039,   916,   917,
     438,   439,   618,  1184,   918,  1183,   712,   614,   218,   219,
     220,   589,   872,  1155,  1521,   221,   222,   477,    67,   443,
     622,   928,  1378,  1379,   223,   224,   587,   871,   225,    69,
     444,  1382,   930,   226,   227,   382,  1157,   763,  1455
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     104,   277,   278,   280,   331,   469,   285,   261,   496,   245,
     127,   504,   505,   387,   429,   847,   538,   757,   308,   462,
     479,   909,  1251,  1163,   933,  1134,   482,   231,   243,   910,
     801,  1122,   251,  1078,   308,   254,  1380,  1381,   479,   455,
     937,   705,   231,  1238,    66,   835,  1165,    66,  1318,  1333,
     731,   490,   500,  1064,   774,    68,  1287,  1321,    68,   273,
     486,  1391,   492,  1006,   824,     4,  1093,   309,  1343,   289,
     480,  1600,   456,   481,   520,   495,   483,   484,   284,  1194,
     499,   728,   667,   289,   470,   265,   876,   378,   269,     4,
     794,     4,   275,   700,   787,   741,    66,    30,   432,   337,
    1084,   327,   852,  1100,  1107,  1275,  1207,    68,   125,    72,
     600,   551,  1704,   330,   442,   345,   289,   578,   386,   339,
     433,  1342,   600,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   289,  1705,   552,   600,   289,   127,   235,
     828,  1347,   427,     5,   729,   707,   718,   453,     5,   485,
     756,   738,   569,   723,     4,   329,  1087,   317,   318,     4,
     233,   730,   241,   579,   742,   541,   758,   777,   268,   289,
     790,     4,   236,   526,  1465,  1466,  1653,   825,   329,   838,
     242,   381,   849,   232,   289,     4,   829,   992,  1376,    72,
    1276,  1277,   542,   289,   385,   262,   857,  1481,   711,   724,
     705,   757,  1088,   285,   686,   338,   285,   757,   571,   285,
     285,   644,   285,   858,   285,   651,   572,   935,   447,   877,
     780,   247,   943,   793,  -521,   806,   639,  1496,   430,   632,
     827,   667,  1031,   666,  1504,  1391,   125,   859,   308,   308,
     308,   308,   308,   308,   308,   308,   308,   308,   308,   308,
     308,   308,   308,   308,   308,   308,   472,   873,   489,   774,
      36,  1497,   801,  1478,   476,  1121,   626,  1083,  1479,    37,
    1099,  1106,    66,   635,  1043,   284,   687,  1412,   284,  1505,
    1137,   938,   985,    68,    36,  1066,    36,   501,   502,   503,
     645,   995,   653,   497,  1063,    37,   688,   269,  1096,  1103,
    1110,  1127,   328,   986,   707,   824,   794,  1302,  1230,   248,
     787,  1164,  1345,   880,   909,   621,  1294,   718,  1064,  1336,
    1342,   521,   910,  1363,  1165,   306,  1156,   519,   231,  1165,
    1454,  1503,  1342,   527,   528,   529,   738,  1364,  1387,   533,
    1049,   524,   428,   479,  1000,   937,  1310,   454,  1093,   636,
     758,   488,   852,   937,    36,   987,   758,   711,    37,   319,
     320,  1544,   526,    37,   457,   852,    36,   852,  1212,  1132,
     932,   262,   777,  1084,  1240,    37,  1626,   268,  1616,  1322,
     636,   285,   488,  1404,   244,  1684,   790,   938,   862,   939,
     948,  1601,   127,   949,  1100,  1605,   448,   259,  1068,   260,
     952,  1107,   965,   632,   966,   632,   560,   487,   632,   488,
      11,   838,   449,  1148,   964,   932,   241,   235,   825,    20,
      21,   308,  1213,   723,  1556,   780,   287,   235,   961,  1628,
     561,  1297,   849,   638,   242,   838,   863,   673,   881,   793,
     386,   329,   934,   885,    30,   849,   534,   849,  1637,  1638,
     236,  1072,   953,   637,   955,   710,   721,   806,   700,   489,
     236,  1342,  1086,   289,  1097,  1104,  1111,   310,  -289,   724,
     671,   827,   311,   312,   922,   387,   761,   290,   291,   292,
     792,  1657,   237,  1503,  1342,   864,   798,   813,   992,   841,
     125,  1231,  1503,   757,  1149,  1150,  1151,  1232,  1135,   440,
     346,  1344,   347,   668,  1152,   669,   238,   329,   275,   725,
    1262,  1233,  1140,   865,   866,   867,   441,   348,  1079,   853,
     923,   924,   925,   536,  1121,  1679,   726,   868,   329,   675,
     524,   682,   619,   685,   281,   329,   801,   869,   620,   325,
    1083,  1263,  1264,   282,   683,  1689,   329,   283,  1296,  1294,
    1066,   979,   854,  1121,   870,   285,   323,   285,   457,  1063,
     285,  1099,   984,  1473,   634,  1310,  1043,  1245,  1106,   855,
     693,   694,   972,   695,   696,  1503,   697,  1342,  1313,  1246,
    1096,  1247,   926,    37,   324,   285,   326,   285,  1503,  1195,
    1103,   709,   995,   446,   329,   261,   334,  1110,  1265,   927,
     127,   999,   308,  1170,   329,  1196,   333,   244,   638,  1100,
    1390,   852,  1107,   779,   710,  1424,   708,   719,   831,   832,
    1223,   335,   739,   287,   942,   840,   287,   721,   243,   287,
     287,  1425,   287,   479,   287,  1549,  1503,   759,   778,   852,
     852,  1545,   758,  1132,   341,  1000,  1120,   336,   826,   340,
     839,   329,   852,   850,   349,  1550,  1132,   383,   922,   342,
     761,  1426,  1427,  1068,  1297,   674,   761,   329,   293,   343,
     294,  -287,   295,  -107,   112,  1446,   932,   862,  1523,   976,
     978,  1373,   981,   983,   833,   973,   974,   975,   450,  -107,
     391,   849,  1524,   838,   424,  1545,   792,  1272,   125,   431,
    1344,   834,   434,   720,   923,   924,   925,   437,  1071,  1546,
     632,  1576,  1344,   569,   932,  1280,  1072,   445,   632,   849,
     849,   841,   329,   760,  1666,   863,  1587,   791,  1473,   313,
     314,   806,   849,   634,   889,  1086,  1602,   998,  1667,   851,
     315,   316,  1124,  1121,  1314,   841,  1097,   890,   891,   713,
     709,  1209,   122,   570,   321,   322,  1104,  1447,  1448,  1449,
    1450,  1451,   996,  1111,   797,   693,   694,   714,  -969,   571,
     471,   697,  1135,   493,   864,   708,  1099,   572,   378,  1106,
     331,  1296,  1098,   522,  1390,  1135,   642,   487,   719,   488,
    1537,   700,   643,   494,     5,  1476,    37,  1313,   535,   573,
     574,   287,   865,   866,   867,  1103,   654,   739,  1110,   700,
     308,   889,   655,   244,   498,     5,   868,   446,   779,   798,
    1105,   759,   799,   800,   890,   891,  1248,   759,   852,   672,
     852,   767,  1132,   677,  1249,   655,   331,   798,   813,   329,
    1646,  1344,  1587,   778,  1070,   892,   893,   700,   997,   767,
     678,   852,   679,   241,   379,  1132,   329,   840,   329,   380,
     883,   884,   285,   331,  1344,   531,   308,   732,   537,  1069,
     285,   242,   381,    72,   720,   798,   813,   545,  1123,   715,
     886,   840,   839,   693,   694,   550,   887,   767,   554,   826,
    1355,  1356,   733,   308,  1076,  1405,   716,   373,   374,   987,
    1405,  1646,   999,   850,  1250,  1120,   839,   760,   849,   912,
     849,  1077,  1316,   760,   563,   913,   850,  1182,   850,   566,
     706,   567,   892,   893,  1160,   375,   693,   694,   714,  1317,
     655,   849,  1098,  1331,  1120,  1027,  1028,   894,   895,   896,
     897,   752,   776,   791,   576,  1177,   583,   898,   899,  1179,
    1319,   620,   761,   590,   837,  1180,   932,  1344,  1590,   700,
    1476,  1135,  1190,  1314,  1105,   586,  1216,  1320,  1191,   588,
     376,  1104,   329,  1071,  1111,   287,   844,   287,  1220,  1222,
     287,  1161,  1162,  1227,  1135,  1217,   591,   798,   813,   851,
    1224,   700,   446,   852,   700,  1166,  1167,  1132,   450,   767,
    1148,  1124,   851,   841,   851,   287,   599,   287,   598,  1255,
     749,   750,   751,   600,   894,   895,   896,   897,   604,   798,
     813,   611,   798,   813,   898,   899,   693,   694,   714,  1335,
    1124,   767,   697,   617,  1270,   693,   694,   714,   998,  1256,
     845,   752,  1218,  1225,  1274,   613,  1279,   615,   329,   329,
     752,  1286,  1271,   393,  1079,  1257,  1290,   846,  1272,  1365,
     616,   397,   623,   996,  1258,   655,   994,   640,   399,  1208,
       5,  1396,  1649,   849,  1590,  1547,   403,   329,   404,   706,
     405,  1149,  1150,  1151,  1259,   844,  1482,  1483,  1484,  1485,
    1398,  1152,   641,  1403,   646,   331,   329,  1080,  1366,   329,
     415,  1153,  1517,  1518,  1210,  1211,   418,   628,   419,  1070,
    1486,  1487,   420,   759,  1081,  1440,   633,   422,  1154,   647,
     423,   329,  1331,  1442,  1120,   308,  1135,  1384,  1385,   329,
     932,   433,   753,  1649,  1069,  -287,   932,  1123,   656,   840,
     754,  1349,  1350,  1351,  1494,  1331,   657,   776,   652,   997,
     901,   902,   903,   781,   782,   904,   658,   755,  1409,  1282,
    1283,  1284,   850,   659,   839,  1334,  1123,  1413,  1414,  1415,
    1416,  1453,  1369,  1067,   693,   694,   714,   329,  1458,  1422,
    1372,   660,  1462,  1182,   329,   700,   837,   942,   329,   752,
     850,   850,  1434,   690,  1506,  1439,  1509,   680,    40,   760,
    1507,    40,   329,   850,   740,  1510,   781,   782,   744,   783,
     837,   329,  1405,  1624,  1460,  1461,   722,  1624,  1335,  1511,
    1124,   732,  1400,  1392,   844,   329,  1394,  1395,   795,  1397,
    1526,  1519,  1520,  1401,  1402,   905,   329,   693,   694,   252,
     253,  1335,   808,  1531,   255,   256,   733,   747,   851,  1532,
      40,  1489,   906,  1423,   797,  1533,   842,   264,  1534,  1428,
      40,  1532,  1631,  1632,  1532,   272,   810,    70,  1541,    71,
      72,   811,    73,    74,   329,  1618,   851,   851,  1551,   860,
    1456,   700,   287,   882,  1272,  1494,   861,  1331,  1664,   851,
     287,   888,    75,  1552,  1525,  1553,   915,   594,  1464,  1272,
      70,  1272,    71,    72,   597,    73,    74,  1598,  1494,   798,
    1554,   920,   799,   800,  1557,   947,  1272,   693,  1558,   714,
    1272,   767,   919,   697,   329,    75,  1564,  1565,   700,    76,
      77,    78,   752,  1685,  1561,   950,  1498,  1499,  1658,  1659,
     329,   693,   694,   929,   695,   696,   946,   697,   951,   781,
     782,   734,   783,  1563,  1334,  1568,  1123,   956,   713,  1272,
    1522,  1272,    76,    77,    78,  1570,   670,   994,   735,  1307,
     954,  1571,  1527,   957,   693,   694,   714,  1334,   958,   850,
     697,   850,   959,  1335,  1018,   693,   694,   714,   695,   831,
     832,   697,  1573,  1582,   506,   507,   700,  1579,   329,  1598,
     752,  1494,   850,   329,  1538,  1019,  1539,  1540,  1580,   728,
    1581,  1542,  1598,  1021,  1180,    70,  1180,    71,    72,  1706,
      73,    74,  1592,  1594,   798,   813,    40,  1022,  1180,  1272,
    1023,   784,  1030,   831,   832,   844,   767,  1034,  1067,  1604,
      75,   693,   694,   714,   695,   329,  1612,   697,   785,   479,
    1613,  1035,   329,  1615,  1038,   814,   752,   461,  1642,  1272,
    1598,   815,    79,  1036,  1272,   851,  1037,   851,   837,    40,
      80,    81,    82,    83,    84,    85,  1661,    76,    77,    78,
    1665,  1669,  1532,   512,   513,   344,   329,  1666,   851,   831,
     832,   844,   308,   308,  1670,    79,   605,   606,   607,  1308,
    1180,  1045,   879,    80,    81,    82,    83,    84,    85,  1672,
    1116,  1673,   692,  1128,  1675,   329,  1309,   329,   123,  1334,
     329,   693,   694,   714,   695,   696,  1046,   697,   698,   699,
    1676,  1677,   700,  1680,  1681,  1682,  1180,  1180,   853,   329,
    1180,   329,  1047,  1622,   850,    70,   701,    71,    72,  1620,
      73,    74,  1690,  1691,  1668,  1118,  1694,  1696,   329,  1180,
    1048,  1630,  1695,  1180,   749,   750,   751,  1699,  1634,  1050,
      75,  1636,  1119,   329,  1051,  1639,   700,  1708,  1052,  1053,
     693,   694,   714,   655,  1057,  1073,   697,   105,  1112,    71,
      72,  1113,    73,    74,  1114,   752,   555,   556,   557,   558,
    1125,  1654,  1126,  1707,  1136,  1656,  1138,    76,    77,    78,
      79,  1141,    75,  1660,   508,   509,   510,   511,    80,    81,
      82,    83,    84,    85,   901,   902,   903,   781,   782,   904,
     851,  1181,  1143,   308,  1674,   990,  1144,  1145,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,    76,
      77,    78,   991,   117,   118,   523,  1146,  1158,   875,  1168,
    1171,  1173,  1176,  1185,   105,     5,    71,    72,  1186,    73,
      74,  1187,  1197,  1188,  1228,  1215,  1229,  1199,  1200,  1201,
    1202,  1203,  1204,  1693,  1267,   461,   753,  1268,  1205,    75,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,  1206,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,    76,    77,    78,    30,
     117,   118,   119,    33,   120,  1241,  1242,  1243,  1244,  1253,
      79,  1266,  1028,  1269,  1288,  1289,  1300,  1301,    80,    81,
      82,    83,    84,    85,  1303,  1305,  1326,  1327,  1346,  1357,
    1358,   338,  1359,   681,  1361,  1362,   693,   694,   714,   695,
    1368,  1374,   697,  1348,  1370,  1377,  1383,   700,  1388,  1393,
    1408,   752,    79,  1421,  1159,  1417,  1429,   122,  1418,  1419,
      80,    81,    82,    83,    84,    85,  1430,  1431,   781,   782,
    1432,   783,  1433,  1435,  1436,   123,  1441,   693,   694,   714,
     695,   120,    34,   697,   831,   832,   844,  1443,  1444,  1445,
     692,    70,   752,    71,    72,  1468,    73,    74,  1480,   693,
     694,  1512,   695,   696,   461,   697,   698,   699,   121,   461,
     700,  1490,  1513,  1514,  1515,  1516,    75,  1529,  1528,  1530,
    1543,  1535,  1548,  1555,   701,   831,   832,   844,  1559,    79,
    1560,  1566,  1567,  1572,   122,   874,   461,    80,    81,    82,
      83,    84,    85,   105,     5,    71,    72,  1595,    73,    74,
    1329,  1608,   123,    76,    77,    78,  1574,  1575,  1593,  1607,
    1609,  1610,  1611,  1621,  1640,  1641,  1652,  1330,    75,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,  1655,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,    76,    77,    78,    30,   117,
     118,   119,    33,   702,    70,     5,    71,    72,  1662,    73,
      74,  1663,  1671,  1683,  1686,  1688,  1697,  1700,  1701,  1702,
     703,  1703,  1709,  1710,   518,   624,   514,  1192,  1214,    75,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,   516,  1386,   515,   105,   592,    71,
      72,   945,    73,    74,   517,   676,    76,    77,    78,    30,
     421,   228,    32,    33,   274,   627,    79,   539,   540,  1627,
     120,    34,    75,  1410,    80,    81,    82,    83,    84,    85,
    1411,  1623,  1169,   474,   425,  1024,  1026,   417,   878,   684,
    1033,  1058,  1578,   267,  1174,  1304,  1273,   121,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,    76,
      77,    78,  1115,   117,   118,   337,  1315,  1591,    79,   105,
    1298,    71,    72,   122,    73,    74,    80,    81,    82,    83,
      84,    85,  1477,  1650,  1678,  1463,   812,  1054,  1234,  1029,
    1633,   123,    34,    70,    75,    71,    72,  1139,    73,    74,
     582,   914,   693,   694,  1371,   921,  1178,  1375,  1360,   426,
    1189,  1619,     0,   700,     0,     0,  1147,     0,    75,     0,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,    76,    77,    78,     0,   117,   118,   593,     0,    79,
       0,   798,   813,     0,     0,     0,     0,    80,    81,    82,
      83,    84,    85,   767,     0,    76,    77,    78,    70,     0,
      71,    72,   532,    73,    74,     0,     0,     0,     0,     0,
       0,   338,   814,     0,   693,     0,   714,     0,   815,     0,
     697,     0,     0,    75,     0,   700,     0,     0,     0,   752,
       0,     0,    79,    70,     5,    71,    72,   122,    73,    74,
      80,    81,    82,    83,    84,    85,   781,   782,     0,   783,
       0,     0,     0,     0,     0,   123,     0,     0,    75,     0,
      76,    77,    78,     0,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,     0,    24,    25,    26,
      27,    28,    29,   338,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    76,    77,    78,    30,     0,
      70,     0,    71,    72,    79,    73,    74,     0,     0,   122,
       0,     0,    80,    81,    82,    83,    84,    85,    70,     0,
      71,    72,     0,    73,    74,    75,     0,   123,    79,     0,
       0,     0,     0,     0,     0,     0,    80,    81,    82,    83,
      84,    85,     0,    75,     0,     0,   466,     0,     0,    11,
       0,   980,     0,     0,     0,     0,     0,     0,    20,    21,
       0,     0,    76,    77,    78,     0,     0,    70,     0,    71,
      72,     0,    73,    74,     0,     0,     0,     0,     0,     0,
      76,    77,    78,    30,    70,     0,    71,    72,     0,    73,
      74,     0,    75,    79,     0,   648,     0,     0,    11,     0,
       0,    80,    81,    82,    83,    84,    85,    20,    21,    75,
       0,     0,     0,  1617,     0,    11,     0,    70,     0,    71,
      72,     0,    73,    74,    20,    21,     0,     0,    79,    76,
      77,    78,    30,     0,     0,     0,    80,    81,    82,    83,
      84,    85,    75,   692,     0,     0,    76,    77,    78,    30,
       0,     0,   693,   694,   714,   695,   696,     0,   697,   698,
     699,     0,     0,   700,     0,    70,     0,    71,    72,     0,
      73,    74,     0,     0,     0,     0,     0,   701,     0,    76,
      77,    78,     0,     0,     0,     0,    70,     0,    71,    72,
      75,    73,    74,     0,     0,    79,     0,   965,     0,   966,
     931,  1389,     0,    80,    81,    82,    83,    84,    85,     0,
       0,    75,     0,    79,     0,     0,   467,     0,     0,     0,
       0,    80,   468,    82,    83,    84,    85,    76,    77,    78,
       0,    70,     0,    71,    72,     0,    73,    74,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    76,    77,
      78,     0,     0,     0,     0,     0,    75,     0,     0,     0,
       0,     0,    79,     0,     0,   649,     0,     0,     0,     0,
      80,   650,    82,    83,    84,    85,     0,     0,    70,    79,
      71,    72,     0,    73,    74,     0,     0,    80,    81,    82,
      83,    84,    85,    76,    77,    78,   693,   694,   714,   695,
       0,     0,   697,    75,     0,     0,     0,   700,     0,     0,
       0,   752,    79,     0,   965,     0,   966,   931,  1536,     0,
      80,    81,    82,    83,    84,    85,     0,     0,   781,   782,
       0,   783,     0,    70,     0,    71,    72,     0,    73,    74,
      76,    77,    78,     0,   831,   832,   844,     0,     0,    70,
       0,    71,    72,     0,    73,    74,     0,     0,    75,     0,
      79,     0,   965,     0,   966,   931,     0,     0,    80,    81,
      82,    83,    84,    85,    75,  1352,  1353,     0,     0,     0,
      70,    79,    71,    72,     0,    73,    74,     0,     0,    80,
    1354,    82,    83,    84,    85,    76,    77,    78,    70,     0,
      71,    72,     0,    73,    74,    75,     0,     0,     0,     0,
       0,    76,    77,    78,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    75,     0,    70,    79,    71,    72,   664,
      73,    74,     0,     0,    80,   665,    82,    83,    84,    85,
       0,     0,    76,    77,    78,     0,    70,     0,    71,    72,
      75,    73,    74,     0,     0,     0,     0,     0,     0,     0,
      76,    77,    78,   693,   694,     0,   695,   696,     0,     0,
       0,    75,     0,    79,   700,     0,   764,     0,   670,   765,
     766,    80,    81,    82,    83,    84,    85,    76,    77,    78,
       0,     0,     0,     0,     0,     0,    70,     0,    71,    72,
       0,    73,    74,     0,     0,     0,     0,     0,    76,    77,
      78,     0,     0,     0,   767,     0,     0,    70,     0,    71,
      72,    75,    73,    74,     0,     0,     0,     0,    79,     0,
       0,     0,     0,   931,     0,   768,    80,    81,    82,    83,
      84,    85,    75,   769,    79,     0,     0,   962,     0,     0,
       0,     0,    80,   963,    82,    83,    84,    85,    76,    77,
      78,     0,     0,   693,   694,   714,     0,     0,     0,     0,
       0,     0,     0,     0,   700,    79,   977,     0,   752,    76,
      77,    78,     0,    80,    81,    82,    83,    84,    85,     0,
       0,     0,     0,    79,   982,   781,   782,     0,   783,     0,
       0,    80,    81,    82,    83,    84,    85,     0,     0,    70,
       0,    71,    72,   844,    73,    74,     0,     0,     0,     0,
      79,  1219,     0,     0,     0,     0,     0,     0,    80,    81,
      82,    83,    84,    85,    75,     0,     0,     0,     0,     0,
       0,    79,  1221,     0,     0,     0,     0,     0,     0,    80,
      81,    82,    83,    84,    85,    70,     0,    71,    72,     0,
      73,    74,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    76,    77,    78,     0,     0,     0,  1130,     0,     0,
      75,    70,     0,    71,    72,     0,    73,    74,     0,     0,
       0,    79,  1226,     0,  1131,     0,     0,     0,     0,    80,
      81,    82,    83,    84,    85,     0,    75,     0,     0,     0,
       0,     0,    79,  1399,     0,     0,     0,    76,    77,    78,
      80,    81,    82,    83,    84,    85,     1,     2,     3,     4,
       5,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    76,    77,    78,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    30,     0,    31,    32,    33,     4,
       5,     0,     0,     0,    79,     0,     0,     0,     0,     0,
       0,     0,    80,    81,    82,    83,    84,    85,     0,     0,
       0,     0,     0,     0,     0,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,     0,
     276,     0,     0,  1090,     0,     0,     0,     0,    80,    81,
      82,    83,    84,    85,    30,     0,    31,    32,    33,   693,
     694,     0,   695,   696,     0,   697,   279,    34,     0,     0,
     700,   692,     0,     0,    80,    81,    82,    83,    84,    85,
     693,   694,     0,   695,   696,     0,   697,   698,   699,     0,
       0,   700,     0,    35,     0,     0,     0,     0,   798,   813,
       0,     0,     0,     0,     0,   701,     0,   831,   832,     0,
     767,     0,     4,     5,    36,     0,     0,     0,     0,     0,
       0,     0,     0,    37,     0,     0,     0,     0,     0,   814,
       0,     0,     0,     0,     0,   815,     0,    34,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,     0,    35,     0,     0,     0,     0,     0,     4,
       5,     0,     0,  1091,     0,   693,   694,    30,   695,   696,
      32,    33,     0,     0,    36,     0,   700,     0,   764,     0,
    1092,   765,   766,    37,     0,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,     0,
       0,     0,     0,     0,     0,     0,   767,     0,     0,     0,
       0,     0,     0,     0,    30,     0,     0,    32,    33,     4,
       5,     0,     0,     0,     0,     0,     0,   768,     0,     0,
       0,     0,     0,     0,     0,   769,     0,     0,     0,     0,
      34,   473,     0,     0,     0,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,   770,
       0,     0,     4,     5,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    30,     0,   771,    36,     0,     0,
       0,     0,     0,     0,     0,     0,    37,    34,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,     0,     0,     0,   812,     0,     0,     4,     5,
       0,     0,     0,     0,     0,     0,     0,    30,     0,     0,
     263,   693,   694,     0,    36,     0,     0,     0,     0,     0,
       0,     0,   700,    37,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,     0,     0,
     798,   813,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   767,    30,     0,     0,     0,     0,     0,     5,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   814,     0,     0,   636,   661,   488,   815,     0,     0,
       0,     0,     0,    37,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,     5,     0,
       0,     0,     0,     0,     0,   816,     0,     0,     0,     0,
       0,     0,     0,    30,     0,     0,     0,    36,     0,     0,
       5,     0,   817,     0,     0,     0,    37,     0,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
       0,    24,    25,    26,    27,    28,    29,     0,     0,     0,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    30,    24,    25,    26,    27,    28,    29,     5,
       0,     0,     0,    36,     0,     0,     0,     0,     0,     0,
       0,     0,    37,     0,    30,     0,     0,     0,     0,     0,
       0,     5,     0,     0,     0,     0,     0,     0,     0,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,     0,    24,    25,    26,    27,    28,    29,     0,     0,
       0,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    30,    24,    25,    26,    27,    28,    29,
       5,     0,     0,   487,   661,   488,     0,     0,     0,     0,
       0,     0,    37,     0,     0,    30,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,     0,
       0,     0,     0,     0,     0,   459,     5,     0,   629,     0,
       0,     0,     0,     0,    30,     0,     0,    32,    33,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     5,     0,
     936,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,     0,     0,     0,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      30,    24,    25,    26,    27,    28,    29,     5,     0,  1193,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    30,     0,     0,     0,     0,    34,     0,     5,
       0,  1198,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,     5,     0,     0,     0,
      12,    13,    14,    15,    16,    17,    18,    19,     0,     0,
      22,    30,    24,    25,    26,    27,    28,    29,     0,   122,
       0,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      30,     0,     0,    32,    33,  1643,   750,   751,     0,     0,
       0,   460,   692,     0,     0,     0,     0,     0,     0,     0,
       0,   693,   694,   714,   695,   696,     0,   697,   698,   699,
       0,     0,   700,     0,     0,     0,   752,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   701,     0,     0,     0,
       0,     0,     0,   781,   782,     0,   783,  1584,   750,   751,
     798,   813,     0,     0,   692,     0,     0,     0,     0,   831,
     832,   844,   767,   693,   694,   714,   695,   696,     0,   697,
     698,   699,   960,    34,   700,   749,   750,   751,   752,     0,
       0,   814,     0,     0,     0,     0,     0,   815,   701,     0,
       0,   693,   694,   714,     0,     0,     0,   697,     0,     0,
       0,     0,   798,   813,     0,     0,   752,     0,     0,     0,
       0,   831,   832,   844,   767,     0,     0,   753,     0,     0,
       0,     0,     0,   781,   782,  1644,   783,     0,     0,  1291,
     750,   751,     0,   814,     0,     0,   692,     0,     0,   815,
       0,     0,  1645,     0,     0,   693,   694,   714,   695,   696,
       0,   697,   698,   699,     0,     0,   700,     0,     0,     0,
     752,     0,     0,     0,     0,     0,     0,     0,     0,   753,
     701,  1470,     0,     0,     0,     0,     0,  1585,     0,     0,
       0,     0,     0,     0,   798,   813,     0,   693,   694,   714,
     695,     0,     0,   697,  1586,     0,   767,   753,   700,     0,
       0,     0,   752,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   814,     0,     0,     0,   781,
     782,   815,   783,  1060,     0,     0,   798,   813,     0,     0,
     692,     0,     0,     0,     0,   831,   832,   844,   767,   693,
     694,     0,   695,   696,     0,   697,   698,   699,     0,     0,
     700,   753,     0,     0,     0,     0,     0,   814,     0,  1292,
       0,     0,     0,   815,   701,   749,   750,   751,     0,     0,
       0,     0,     0,     0,     0,     0,  1293,     0,   798,   813,
       0,   693,   694,   714,     0,     0,     0,   697,     0,     0,
     767,     0,     0,     0,     0,     0,   752,     0,     0,     0,
       0,  1471,     0,     0,   750,   751,     0,     0,     0,   814,
     692,     0,     0,   781,   782,   815,   783,     0,  1472,   693,
     694,   714,   695,   696,     0,   697,   698,   699,     0,     0,
     700,     0,     0,     0,   752,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   701,     0,     0,     0,     0,     0,
       0,   781,   782,  1061,   783,     0,   750,   751,     0,     0,
       0,     0,   692,     0,     0,     0,     0,   831,   832,   844,
    1062,   693,   694,   714,   695,   696,     0,   697,   698,   699,
       0,     0,   700,     0,     0,     0,   752,   753,     0,     0,
       0,     0,   750,   751,     0,  1040,   701,     0,   692,     0,
       0,     0,     0,   781,   782,     0,   783,   693,   694,   714,
     695,   696,  1041,   697,   698,   699,     0,     0,   700,     0,
       0,   844,   752,     0,     0,   753,     0,     0,     0,     0,
     750,   751,   701,  1596,     0,     0,   692,     0,     0,   781,
     782,     0,   783,     0,     0,   693,   694,   714,   695,   696,
    1597,   697,   698,   699,     0,     0,   700,   750,   751,     0,
     752,     0,     0,   692,     0,     0,     0,     0,     0,     0,
     701,     0,   693,   694,   714,   695,   696,   753,   697,   698,
     699,     0,     0,   700,     0,  1500,     0,   752,     0,  1307,
       0,     0,     0,   831,   832,   844,     0,   701,     0,     0,
       0,     0,  1501,     0,     0,   693,   694,   714,   695,   750,
     751,   697,     0,   753,     0,   692,   700,     0,     0,     0,
     752,  1235,   844,     0,   693,   694,   714,   695,   696,     0,
     697,   698,   699,     0,     0,   700,     0,     0,  1236,   752,
       0,     0,     0,     0,   798,   813,     0,     0,     0,   701,
    1060,   753,     0,   831,   832,   844,   767,   692,     0,  1492,
       0,     0,     0,     0,     0,     0,   693,   694,     0,   695,
     696,     0,   697,   698,   699,   814,  1493,   700,   753,     0,
       0,   815,     0,     0,     0,     0,  1340,     0,     0,     0,
       0,   701,  1643,   750,   751,     0,     0,     0,     0,   692,
       0,     0,     0,  1341,     0,   798,   813,     0,   693,   694,
     714,   695,   696,     0,   697,   698,   699,   767,     0,   700,
       0,     0,     0,   752,     0,     0,     0,     0,     0,     0,
     753,     0,     0,   701,     0,     0,   814,     0,  1002,     0,
     781,   782,   815,   783,  1584,   750,   751,   798,   813,     0,
       0,   692,     0,     0,     0,  1003,   831,   832,   844,   767,
     693,   694,   714,   695,   696,     0,   697,   698,   699,     0,
       0,   700,     0,     0,     0,   752,     0,     0,   814,     0,
       0,     0,     0,     0,   815,   701,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   798,
     813,     0,     0,     0,     0,     0,     0,     0,   831,   832,
     844,   767,     0,     0,   753,  1291,   750,   751,     0,     0,
       0,     0,   692,     0,     0,     0,     0,     0,     0,     0,
     814,   693,   694,   714,   695,   696,   815,   697,   698,   699,
       0,     0,   700,     0,     0,     0,   752,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   701,     0,   750,   751,
       0,     0,     0,     0,   692,     0,   753,     0,     0,     0,
     798,   813,     0,   693,   694,   714,   695,   696,     0,   697,
     698,   699,   767,     0,   700,     0,     0,     0,   752,     0,
       0,     0,     0,     0,   750,   751,     0,     0,   701,     0,
     692,   814,     0,     0,     0,   781,   782,   815,   783,   693,
     694,   714,   695,   696,     0,   697,   698,   699,     0,     0,
     700,   831,   832,   844,   752,     0,     0,     0,     0,     0,
     750,   751,     0,     0,   701,     0,   692,   753,     0,     0,
       0,   781,   782,     0,   783,   693,   694,   714,   695,   696,
       0,   697,   698,   699,     0,     0,   700,     0,     0,   844,
     752,     0,     0,     0,     0,     0,   750,   751,     0,     0,
     701,     0,   692,     0,     0,     0,     0,   781,   782,   753,
     783,   693,   694,   714,   695,   696,     0,   697,   698,   699,
       0,     0,   700,     0,     0,     0,   752,     0,     0,     0,
       0,     0,   750,   751,     0,     0,   701,     0,   692,     0,
       0,     0,     0,     0,     0,   753,     0,   693,   694,   714,
     695,   696,     0,   697,   698,   699,     0,     0,   700,   831,
     832,   844,   752,     0,     0,     0,     0,     0,   750,   751,
       0,     0,   701,     0,   692,     0,     0,     0,     0,     0,
       0,   753,     0,   693,   694,   714,   695,   696,     0,   697,
     698,   699,     0,     0,   700,     0,     0,   844,   752,   353,
     354,     0,   355,     0,     0,     0,   353,   354,   701,   355,
       0,   356,   357,   358,   359,   360,   361,   753,   356,   357,
     358,   359,   360,   361,     0,     0,     0,   362,     0,   363,
       0,   364,     0,     0,   362,   365,   363,     0,   364,     0,
       0,     0,   365,     0,     0,   366,     0,     0,     0,     0,
       0,     0,   366,   753,   367,     0,     0,     0,     0,     0,
     233,   367,     0,   368,   369,     0,     0,     0,     0,     0,
     368,   369,   370,     0,   371,     0,     0,     0,     0,   370,
       0,   371,   353,   354,     0,   355,     0,     0,     0,   753,
       0,     0,   875,     0,   356,   357,   358,     0,   360,     0,
       0,   372,   353,   354,     0,   355,     0,     0,   372,     0,
     362,     0,   363,     0,   356,   357,   358,     0,   360,     0,
       0,     0,  1470,     0,     0,     0,     0,     0,   366,     0,
     362,     0,   363,     0,     0,     0,     0,   530,   693,   694,
     714,   695,  1090,     0,   697,     0,   368,   369,   366,   700,
       0,     0,     0,   752,     0,   370,     0,   530,   693,   694,
       0,   695,   696,     0,   697,     0,   368,   369,     0,   700,
     781,   782,     0,   783,     0,   370,     0,   798,   813,     0,
       0,     0,     0,     0,   372,     0,   831,   832,   844,   767,
       0,     0,     0,     0,     0,     0,     0,   798,   813,     0,
       0,     0,     0,     0,   372,     0,   831,   832,   814,   767,
       5,     0,     0,     0,   815,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   814,     0,
       0,     0,     0,     0,   815,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,   944,
       5,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    30,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,   390,
       0,     0,     0,     0,     0,   394,     0,   395,     0,   396,
       0,     0,     0,     0,    30,     0,     0,     0,     0,     0,
     400,     0,   401,     0,   402,     0,     0,     0,     0,     0,
       0,     0,   406,     0,   407,     0,   408,     0,   409,     0,
     410,     0,   411,     0,   412,     0,   413,     0,   414,     0,
       0,     0,   416
};

static const yytype_int16 yycheck[] =
{
       1,    73,    74,    75,   106,   260,    79,    50,   293,    37,
       2,   313,   314,   130,   229,   580,   349,   564,    90,   259,
     275,   612,  1019,   882,   625,   843,   281,    29,    36,   612,
     570,   830,    40,   802,   106,    44,  1187,  1188,   293,   254,
     630,   543,    44,  1001,     0,   577,   884,     3,  1101,  1117,
     547,   286,   307,   796,   565,     0,  1053,  1108,     3,    67,
     285,  1211,   287,   691,   575,     8,   809,    90,  1129,    11,
     276,  1491,   257,   279,   329,   290,   282,   283,    79,   938,
     295,   147,   489,    11,   260,    59,    76,   108,    62,     8,
     568,     8,   203,   107,   568,   158,    52,    73,   102,    76,
     807,    22,   580,   810,   811,    89,   965,    52,     2,    11,
       8,   203,   203,   224,   239,   116,    11,    78,   126,   111,
     124,  1129,     8,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    11,   225,   227,     8,    11,   130,   138,
      78,  1138,     8,     9,   210,   543,   544,     8,     9,   204,
     564,   549,    78,   124,     8,   210,    78,    17,    18,     8,
     132,   227,   183,   124,   227,    79,   564,   565,    62,    11,
     568,     8,   171,   333,  1300,  1301,  1596,   575,   210,   577,
     201,   202,   580,   203,    11,     8,   124,   689,  1185,    11,
     174,   175,   106,    11,   226,    52,   210,  1323,   543,   170,
     702,   748,   124,   276,   537,   182,   279,   754,   134,   282,
     283,   466,   285,   227,   287,   470,   142,   628,   246,   209,
     565,     0,   633,   568,     8,   570,   461,  1328,   230,   454,
     575,   638,   729,   488,  1339,  1385,   130,   582,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   264,   590,   286,   770,
     203,  1329,   802,  1316,   272,   830,   451,   807,  1319,   212,
     810,   811,   228,   458,   748,   276,   204,  1235,   279,  1340,
     845,   224,   224,   228,   203,   796,   203,   310,   311,   312,
     466,   689,   477,   294,   796,   212,   224,   271,   809,   810,
     811,   833,   223,   205,   702,   816,   784,  1076,   203,   226,
     784,   209,  1130,   598,   905,   440,  1059,   715,  1061,  1118,
    1328,   330,   905,   209,  1162,   225,   204,   328,   330,  1167,
     204,  1339,  1340,   334,   335,   336,   734,   209,  1197,   340,
     754,   333,   208,   598,   689,   935,  1089,   208,  1091,   203,
     748,   205,   830,   943,   203,   688,   754,   702,   212,   219,
     220,   203,   522,   212,   258,   843,   203,   845,   969,   843,
     625,   228,   770,  1080,  1002,   212,   203,   271,  1529,   163,
     203,   454,   205,   205,    37,   203,   784,   224,    61,   226,
     645,  1492,   384,   648,  1101,  1500,   210,   203,   796,   205,
     655,  1108,   205,   628,   207,   630,   203,   203,   633,   205,
      39,   809,   226,   109,   669,   670,   183,   138,   816,    48,
      49,   493,   225,   124,  1421,   770,    79,   138,   668,  1555,
     227,  1059,   830,   461,   201,   833,   109,   206,   599,   784,
     448,   210,   627,   604,    73,   843,   340,   845,  1574,  1575,
     171,   796,   658,   461,   660,   543,   544,   802,   107,   487,
     171,  1469,   807,    11,   809,   810,   811,   212,   208,   170,
     493,   816,   217,   218,   102,   592,   564,    12,    13,    14,
     568,  1607,   203,  1491,  1492,   158,   135,   136,   990,   577,
     384,   204,  1500,  1040,   190,   191,   192,   210,   843,   210,
      49,  1129,    51,   203,   200,   205,   227,   210,   203,   210,
      91,   224,   857,   186,   187,   188,   227,    66,   167,   177,
     148,   149,   150,   226,  1089,  1651,   227,   200,   210,   521,
     522,   532,   204,   534,   203,   210,  1076,   210,   210,   222,
    1080,   122,   123,   203,   226,  1671,   210,   203,  1059,  1292,
    1061,   226,   210,  1118,   227,   628,   211,   630,   452,  1061,
     633,  1101,   226,  1306,   458,  1308,  1040,    87,  1108,   227,
      96,    97,   674,    99,   100,  1583,   102,  1585,  1089,    99,
    1091,   101,   210,   212,   221,   658,    21,   660,  1596,   210,
    1101,   543,   990,   246,   210,   638,   203,  1108,   179,   227,
     592,   689,   674,   888,   210,   226,   224,   260,   636,  1316,
    1211,  1089,  1319,   565,   702,   118,   543,   544,   144,   145,
     226,   203,   549,   276,   632,   577,   279,   715,   636,   282,
     283,   134,   285,   888,   287,   204,  1644,   564,   565,  1117,
    1118,   210,  1040,  1117,     8,   990,   830,   203,   575,   203,
     577,   210,  1130,   580,   203,   224,  1130,   209,   102,   226,
     748,   164,   165,  1061,  1292,   224,   754,   210,   203,   226,
     205,   208,   207,   210,    65,     1,   931,    61,   210,   680,
     681,   224,   683,   684,   210,   677,   678,   679,   225,   226,
     208,  1089,   224,  1091,     8,   210,   784,   210,   592,   203,
    1328,   227,   203,   544,   148,   149,   150,     8,   796,   224,
     935,   224,  1340,    78,   969,  1048,  1061,   204,   943,  1117,
    1118,   809,   210,   564,   210,   109,  1469,   568,  1471,   213,
     214,  1076,  1130,   627,     8,  1080,   224,   689,   224,   580,
      15,    16,   830,  1308,  1089,   833,  1091,    21,    22,    80,
     702,   966,   208,   118,    19,    20,  1101,    83,    84,    85,
      86,    87,   689,  1108,    80,    96,    97,    98,   208,   134,
     132,   102,  1117,   204,   158,   702,  1316,   142,   108,  1319,
     882,  1292,    80,   224,  1385,  1130,   204,   203,   715,   205,
    1391,   107,   210,     8,     9,  1306,   212,  1308,   226,   164,
     165,   454,   186,   187,   188,  1316,   204,   734,  1319,   107,
     882,     8,   210,   466,     8,     9,   200,   470,   770,   135,
      80,   748,   138,   139,    21,    22,   100,   754,  1306,   204,
    1308,   147,  1306,   204,   108,   210,   938,   135,   136,   210,
    1583,  1469,  1585,   770,   796,   119,   120,   107,   689,   147,
     204,  1329,   204,   183,   184,  1329,   210,   809,   210,   189,
     209,   210,   935,   965,  1492,    63,   938,    80,   203,   796,
     943,   201,   202,    11,   715,   135,   136,   147,   830,   210,
     204,   833,   809,    96,    97,   227,   210,   147,   227,   816,
    1145,  1146,   105,   965,   210,  1228,   227,    78,    79,  1232,
    1233,  1644,   990,   830,   178,  1089,   833,   748,  1306,   204,
    1308,   227,   210,   754,   124,   210,   843,   918,   845,   227,
     543,   227,   119,   120,   204,   106,    96,    97,    98,   227,
     210,  1329,    80,  1117,  1118,   159,   160,   211,   212,   213,
     214,   111,   565,   784,   143,   204,   181,   221,   222,   204,
     210,   210,  1040,   203,   577,   210,  1211,  1585,  1469,   107,
    1471,  1306,   204,  1308,    80,   227,   204,   227,   210,   227,
     151,  1316,   210,  1061,  1319,   628,   146,   630,   979,   980,
     633,   209,   210,   984,  1329,   977,   227,   135,   136,   830,
     982,   107,   645,  1471,   107,   209,   210,  1471,   225,   147,
     109,  1089,   843,  1091,   845,   658,   208,   660,   203,    78,
      80,    81,    82,     8,   211,   212,   213,   214,   208,   135,
     136,   203,   135,   136,   221,   222,    96,    97,    98,  1117,
    1118,   147,   102,   205,  1035,    96,    97,    98,   990,   108,
     210,   111,   204,   204,  1045,     8,  1047,   203,   210,   210,
     111,  1052,   204,   147,   167,   124,  1057,   227,   210,   204,
     203,   155,   203,   990,   133,   210,   689,   204,   162,     8,
       9,   204,  1583,  1471,  1585,  1408,   170,   210,   172,   702,
     174,   190,   191,   192,   153,   146,   137,   138,   139,   140,
     204,   200,   210,   204,   206,  1197,   210,   210,  1171,   210,
     194,   210,  1357,  1358,   209,   210,   200,   208,   202,  1061,
     161,   162,   206,  1040,   227,   204,   208,   211,   227,   206,
     214,   210,  1306,   204,  1308,  1197,  1471,   209,   210,   210,
    1385,   124,   202,  1644,  1061,   208,  1391,  1089,   204,  1091,
     210,  1142,  1143,  1144,  1328,  1329,   204,   770,   227,   990,
     125,   126,   127,   128,   129,   130,   210,   227,  1230,   148,
     149,   150,  1089,   210,  1091,  1117,  1118,  1241,  1242,  1243,
    1244,   204,  1173,   796,    96,    97,    98,   210,   204,  1253,
    1181,   210,   204,  1184,   210,   107,   809,  1195,   210,   111,
    1117,  1118,  1266,   124,   204,  1269,   204,   203,     0,  1040,
     210,     3,   210,  1130,     8,   204,   128,   129,   152,   131,
     833,   210,  1545,  1546,  1288,  1289,   203,  1550,  1306,   204,
    1308,    80,  1223,  1215,   146,   210,  1218,  1219,   106,  1221,
     204,   193,   194,  1225,  1226,   210,   210,    96,    97,    41,
      42,  1329,   143,   204,    46,    47,   105,   227,  1089,   210,
      52,  1325,   227,  1254,    80,   204,   106,    59,   204,  1260,
      62,   210,  1564,  1565,   210,    67,   134,     8,   204,    10,
      11,   134,    13,    14,   210,  1530,  1117,  1118,   204,   203,
    1281,   107,   935,   225,   210,  1469,   227,  1471,  1621,  1130,
     943,   203,    33,   204,  1368,   204,     8,   391,  1299,   210,
       8,   210,    10,    11,   398,    13,    14,  1491,  1492,   135,
     204,   227,   138,   139,   204,   206,   210,    96,   204,    98,
     210,   147,   205,   102,   210,    33,   213,   214,   107,    70,
      71,    72,   111,  1666,   204,   206,  1337,  1338,   195,   196,
     210,    96,    97,     8,    99,   100,     8,   102,   206,   128,
     129,   210,   131,   204,  1306,   204,  1308,   204,    80,   210,
    1361,   210,    70,    71,    72,   204,   208,   990,   227,    80,
       8,   210,  1373,   204,    96,    97,    98,  1329,   206,  1306,
     102,  1308,   206,  1471,   203,    96,    97,    98,    99,   144,
     145,   102,   204,  1467,   315,   316,   107,   204,   210,  1583,
     111,  1585,  1329,   210,  1396,   203,  1398,  1399,   204,   147,
     204,  1403,  1596,   203,   210,     8,   210,    10,    11,  1704,
      13,    14,   204,   204,   135,   136,   228,   203,   210,   210,
     203,   210,   203,   144,   145,   146,   147,   204,  1061,   204,
      33,    96,    97,    98,    99,   210,   204,   102,   227,  1704,
    1523,   203,   210,   204,     8,   166,   111,   259,   204,   210,
    1644,   172,   203,   227,   210,  1306,   227,  1308,  1091,   271,
     211,   212,   213,   214,   215,   216,   204,    70,    71,    72,
     204,   204,   210,   321,   322,   226,   210,   210,  1329,   144,
     145,   146,  1564,  1565,   204,   203,     8,     9,    10,   210,
     210,   203,   596,   211,   212,   213,   214,   215,   216,   204,
     106,   204,    87,   124,   204,   210,   227,   210,   226,  1471,
     210,    96,    97,    98,    99,   100,   203,   102,   103,   104,
     204,   204,   107,   204,   204,   204,   210,   210,   177,   210,
     210,   210,   203,  1544,  1471,     8,   121,    10,    11,  1541,
      13,    14,   204,   204,  1626,   210,   204,   204,   210,   210,
     203,  1562,   210,   210,    80,    81,    82,   204,  1569,   203,
      33,  1572,   227,   210,   203,  1576,   107,   204,   203,   203,
      96,    97,    98,   210,   203,   203,   102,     8,   203,    10,
      11,   203,    13,    14,   203,   111,   115,   116,   117,   118,
     203,  1602,   203,  1705,   203,  1606,   203,    70,    71,    72,
     203,   227,    33,  1614,   317,   318,   319,   320,   211,   212,
     213,   214,   215,   216,   125,   126,   127,   128,   129,   130,
    1471,   224,   203,  1705,  1635,   210,   203,   203,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,   227,    74,    75,    76,   203,   227,    88,   204,
     224,   203,     8,   203,     8,     9,    10,    11,   203,    13,
      14,   203,   224,   203,   224,     4,     8,   206,   206,   204,
     204,   204,   204,  1684,   204,   487,   202,   224,   206,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,   206,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,   155,   203,   203,   203,   203,   203,
     203,   203,   160,   203,   203,   203,   203,   203,   211,   212,
     213,   214,   215,   216,   203,   106,   140,   124,    83,   203,
     203,   182,   203,   226,   210,   226,    96,    97,    98,    99,
     203,   206,   102,   227,   227,     8,     8,   107,   206,   226,
     206,   111,   203,   210,   878,   204,   224,   208,   204,   204,
     211,   212,   213,   214,   215,   216,   204,   204,   128,   129,
     204,   131,   204,   227,     8,   226,     8,    96,    97,    98,
      99,   155,   156,   102,   144,   145,   146,   210,   224,   224,
      87,     8,   111,    10,    11,   124,    13,    14,   210,    96,
      97,   204,    99,   100,   636,   102,   103,   104,   182,   641,
     107,   224,   204,   204,   204,   204,    33,   224,   206,   205,
       8,   227,   204,   224,   121,   144,   145,   146,   134,   203,
     134,   204,   210,   210,   208,   209,   668,   211,   212,   213,
     214,   215,   216,     8,     9,    10,    11,   173,    13,    14,
     210,   204,   226,    70,    71,    72,   224,   224,   224,   224,
     204,   210,   204,   206,   204,   204,   204,   227,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,   204,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,   210,     8,     9,    10,    11,     8,    13,
      14,   206,   224,   206,     8,   204,   154,     8,   203,   227,
     227,     8,   204,   204,   327,   448,   323,   931,   970,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,   325,  1195,   324,     8,   384,    10,
      11,   641,    13,    14,   326,   522,    70,    71,    72,    73,
     209,     3,    76,    77,    67,   452,   203,   351,   351,  1550,
     155,   156,    33,  1232,   211,   212,   213,   214,   215,   216,
    1233,  1545,   887,   271,   227,   702,   715,   198,   595,   226,
     734,   784,  1461,    59,   905,  1080,  1040,   182,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,   816,    74,    75,    76,  1091,  1471,   203,     8,
    1061,    10,    11,   208,    13,    14,   211,   212,   213,   214,
     215,   216,  1308,  1585,  1644,  1292,    80,   770,   990,   725,
    1567,   226,   156,     8,    33,    10,    11,   854,    13,    14,
     371,   615,    96,    97,  1180,   620,   915,  1184,  1153,   227,
     926,  1532,    -1,   107,    -1,    -1,   869,    -1,    33,    -1,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    -1,    74,    75,    76,    -1,   203,
      -1,   135,   136,    -1,    -1,    -1,    -1,   211,   212,   213,
     214,   215,   216,   147,    -1,    70,    71,    72,     8,    -1,
      10,    11,   226,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,   182,   166,    -1,    96,    -1,    98,    -1,   172,    -1,
     102,    -1,    -1,    33,    -1,   107,    -1,    -1,    -1,   111,
      -1,    -1,   203,     8,     9,    10,    11,   208,    13,    14,
     211,   212,   213,   214,   215,   216,   128,   129,    -1,   131,
      -1,    -1,    -1,    -1,    -1,   226,    -1,    -1,    33,    -1,
      70,    71,    72,    -1,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    -1,    52,    53,    54,
      55,    56,    57,   182,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    70,    71,    72,    73,    -1,
       8,    -1,    10,    11,   203,    13,    14,    -1,    -1,   208,
      -1,    -1,   211,   212,   213,   214,   215,   216,     8,    -1,
      10,    11,    -1,    13,    14,    33,    -1,   226,   203,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   211,   212,   213,   214,
     215,   216,    -1,    33,    -1,    -1,    36,    -1,    -1,    39,
      -1,   226,    -1,    -1,    -1,    -1,    -1,    -1,    48,    49,
      -1,    -1,    70,    71,    72,    -1,    -1,     8,    -1,    10,
      11,    -1,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      70,    71,    72,    73,     8,    -1,    10,    11,    -1,    13,
      14,    -1,    33,   203,    -1,    36,    -1,    -1,    39,    -1,
      -1,   211,   212,   213,   214,   215,   216,    48,    49,    33,
      -1,    -1,    -1,   223,    -1,    39,    -1,     8,    -1,    10,
      11,    -1,    13,    14,    48,    49,    -1,    -1,   203,    70,
      71,    72,    73,    -1,    -1,    -1,   211,   212,   213,   214,
     215,   216,    33,    87,    -1,    -1,    70,    71,    72,    73,
      -1,    -1,    96,    97,    98,    99,   100,    -1,   102,   103,
     104,    -1,    -1,   107,    -1,     8,    -1,    10,    11,    -1,
      13,    14,    -1,    -1,    -1,    -1,    -1,   121,    -1,    70,
      71,    72,    -1,    -1,    -1,    -1,     8,    -1,    10,    11,
      33,    13,    14,    -1,    -1,   203,    -1,   205,    -1,   207,
     208,   209,    -1,   211,   212,   213,   214,   215,   216,    -1,
      -1,    33,    -1,   203,    -1,    -1,   206,    -1,    -1,    -1,
      -1,   211,   212,   213,   214,   215,   216,    70,    71,    72,
      -1,     8,    -1,    10,    11,    -1,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,    71,
      72,    -1,    -1,    -1,    -1,    -1,    33,    -1,    -1,    -1,
      -1,    -1,   203,    -1,    -1,   206,    -1,    -1,    -1,    -1,
     211,   212,   213,   214,   215,   216,    -1,    -1,     8,   203,
      10,    11,    -1,    13,    14,    -1,    -1,   211,   212,   213,
     214,   215,   216,    70,    71,    72,    96,    97,    98,    99,
      -1,    -1,   102,    33,    -1,    -1,    -1,   107,    -1,    -1,
      -1,   111,   203,    -1,   205,    -1,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,    -1,    -1,   128,   129,
      -1,   131,    -1,     8,    -1,    10,    11,    -1,    13,    14,
      70,    71,    72,    -1,   144,   145,   146,    -1,    -1,     8,
      -1,    10,    11,    -1,    13,    14,    -1,    -1,    33,    -1,
     203,    -1,   205,    -1,   207,   208,    -1,    -1,   211,   212,
     213,   214,   215,   216,    33,   197,   198,    -1,    -1,    -1,
       8,   203,    10,    11,    -1,    13,    14,    -1,    -1,   211,
     212,   213,   214,   215,   216,    70,    71,    72,     8,    -1,
      10,    11,    -1,    13,    14,    33,    -1,    -1,    -1,    -1,
      -1,    70,    71,    72,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    -1,     8,   203,    10,    11,   206,
      13,    14,    -1,    -1,   211,   212,   213,   214,   215,   216,
      -1,    -1,    70,    71,    72,    -1,     8,    -1,    10,    11,
      33,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      70,    71,    72,    96,    97,    -1,    99,   100,    -1,    -1,
      -1,    33,    -1,   203,   107,    -1,   109,    -1,   208,   112,
     113,   211,   212,   213,   214,   215,   216,    70,    71,    72,
      -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    10,    11,
      -1,    13,    14,    -1,    -1,    -1,    -1,    -1,    70,    71,
      72,    -1,    -1,    -1,   147,    -1,    -1,     8,    -1,    10,
      11,    33,    13,    14,    -1,    -1,    -1,    -1,   203,    -1,
      -1,    -1,    -1,   208,    -1,   168,   211,   212,   213,   214,
     215,   216,    33,   176,   203,    -1,    -1,   206,    -1,    -1,
      -1,    -1,   211,   212,   213,   214,   215,   216,    70,    71,
      72,    -1,    -1,    96,    97,    98,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   107,   203,   204,    -1,   111,    70,
      71,    72,    -1,   211,   212,   213,   214,   215,   216,    -1,
      -1,    -1,    -1,   203,   204,   128,   129,    -1,   131,    -1,
      -1,   211,   212,   213,   214,   215,   216,    -1,    -1,     8,
      -1,    10,    11,   146,    13,    14,    -1,    -1,    -1,    -1,
     203,   204,    -1,    -1,    -1,    -1,    -1,    -1,   211,   212,
     213,   214,   215,   216,    33,    -1,    -1,    -1,    -1,    -1,
      -1,   203,   204,    -1,    -1,    -1,    -1,    -1,    -1,   211,
     212,   213,   214,   215,   216,     8,    -1,    10,    11,    -1,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    70,    71,    72,    -1,    -1,    -1,   210,    -1,    -1,
      33,     8,    -1,    10,    11,    -1,    13,    14,    -1,    -1,
      -1,   203,   204,    -1,   227,    -1,    -1,    -1,    -1,   211,
     212,   213,   214,   215,   216,    -1,    33,    -1,    -1,    -1,
      -1,    -1,   203,   204,    -1,    -1,    -1,    70,    71,    72,
     211,   212,   213,   214,   215,   216,     5,     6,     7,     8,
       9,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    70,    71,    72,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    73,    -1,    75,    76,    77,     8,
       9,    -1,    -1,    -1,   203,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   211,   212,   213,   214,   215,   216,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    -1,
     203,    -1,    -1,    80,    -1,    -1,    -1,    -1,   211,   212,
     213,   214,   215,   216,    73,    -1,    75,    76,    77,    96,
      97,    -1,    99,   100,    -1,   102,   203,   156,    -1,    -1,
     107,    87,    -1,    -1,   211,   212,   213,   214,   215,   216,
      96,    97,    -1,    99,   100,    -1,   102,   103,   104,    -1,
      -1,   107,    -1,   182,    -1,    -1,    -1,    -1,   135,   136,
      -1,    -1,    -1,    -1,    -1,   121,    -1,   144,   145,    -1,
     147,    -1,     8,     9,   203,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   212,    -1,    -1,    -1,    -1,    -1,   166,
      -1,    -1,    -1,    -1,    -1,   172,    -1,   156,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    -1,   182,    -1,    -1,    -1,    -1,    -1,     8,
       9,    -1,    -1,   210,    -1,    96,    97,    73,    99,   100,
      76,    77,    -1,    -1,   203,    -1,   107,    -1,   109,    -1,
     227,   112,   113,   212,    -1,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   147,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    73,    -1,    -1,    76,    77,     8,
       9,    -1,    -1,    -1,    -1,    -1,    -1,   168,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   176,    -1,    -1,    -1,    -1,
     156,   157,    -1,    -1,    -1,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,   210,
      -1,    -1,     8,     9,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    73,    -1,   227,   203,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   212,   156,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    -1,    -1,    -1,    80,    -1,    -1,     8,     9,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    73,    -1,    -1,
      76,    96,    97,    -1,   203,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   107,   212,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    -1,    -1,
     135,   136,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   147,    73,    -1,    -1,    -1,    -1,    -1,     9,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   166,    -1,    -1,   203,   204,   205,   172,    -1,    -1,
      -1,    -1,    -1,   212,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,     9,    -1,
      -1,    -1,    -1,    -1,    -1,   210,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    73,    -1,    -1,    -1,   203,    -1,    -1,
       9,    -1,   227,    -1,    -1,    -1,   212,    -1,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      -1,    52,    53,    54,    55,    56,    57,    -1,    -1,    -1,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    73,    52,    53,    54,    55,    56,    57,     9,
      -1,    -1,    -1,   203,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   212,    -1,    73,    -1,    -1,    -1,    -1,    -1,
      -1,     9,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    56,    57,    -1,    -1,
      -1,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    73,    52,    53,    54,    55,    56,    57,
       9,    -1,    -1,   203,   204,   205,    -1,    -1,    -1,    -1,
      -1,    -1,   212,    -1,    -1,    73,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    -1,
      -1,    -1,    -1,    -1,    -1,     8,     9,    -1,   209,    -1,
      -1,    -1,    -1,    -1,    73,    -1,    -1,    76,    77,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     9,    -1,
     209,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    -1,    -1,    -1,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      73,    52,    53,    54,    55,    56,    57,     9,    -1,   209,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    73,    -1,    -1,    -1,    -1,   156,    -1,     9,
      -1,   209,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,     9,    -1,    -1,    -1,
      40,    41,    42,    43,    44,    45,    46,    47,    -1,    -1,
      50,    73,    52,    53,    54,    55,    56,    57,    -1,   208,
      -1,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      73,    -1,    -1,    76,    77,    80,    81,    82,    -1,    -1,
      -1,   204,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    96,    97,    98,    99,   100,    -1,   102,   103,   104,
      -1,    -1,   107,    -1,    -1,    -1,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   121,    -1,    -1,    -1,
      -1,    -1,    -1,   128,   129,    -1,   131,    80,    81,    82,
     135,   136,    -1,    -1,    87,    -1,    -1,    -1,    -1,   144,
     145,   146,   147,    96,    97,    98,    99,   100,    -1,   102,
     103,   104,   204,   156,   107,    80,    81,    82,   111,    -1,
      -1,   166,    -1,    -1,    -1,    -1,    -1,   172,   121,    -1,
      -1,    96,    97,    98,    -1,    -1,    -1,   102,    -1,    -1,
      -1,    -1,   135,   136,    -1,    -1,   111,    -1,    -1,    -1,
      -1,   144,   145,   146,   147,    -1,    -1,   202,    -1,    -1,
      -1,    -1,    -1,   128,   129,   210,   131,    -1,    -1,    80,
      81,    82,    -1,   166,    -1,    -1,    87,    -1,    -1,   172,
      -1,    -1,   227,    -1,    -1,    96,    97,    98,    99,   100,
      -1,   102,   103,   104,    -1,    -1,   107,    -1,    -1,    -1,
     111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   202,
     121,    80,    -1,    -1,    -1,    -1,    -1,   210,    -1,    -1,
      -1,    -1,    -1,    -1,   135,   136,    -1,    96,    97,    98,
      99,    -1,    -1,   102,   227,    -1,   147,   202,   107,    -1,
      -1,    -1,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   166,    -1,    -1,    -1,   128,
     129,   172,   131,    80,    -1,    -1,   135,   136,    -1,    -1,
      87,    -1,    -1,    -1,    -1,   144,   145,   146,   147,    96,
      97,    -1,    99,   100,    -1,   102,   103,   104,    -1,    -1,
     107,   202,    -1,    -1,    -1,    -1,    -1,   166,    -1,   210,
      -1,    -1,    -1,   172,   121,    80,    81,    82,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   227,    -1,   135,   136,
      -1,    96,    97,    98,    -1,    -1,    -1,   102,    -1,    -1,
     147,    -1,    -1,    -1,    -1,    -1,   111,    -1,    -1,    -1,
      -1,   210,    -1,    -1,    81,    82,    -1,    -1,    -1,   166,
      87,    -1,    -1,   128,   129,   172,   131,    -1,   227,    96,
      97,    98,    99,   100,    -1,   102,   103,   104,    -1,    -1,
     107,    -1,    -1,    -1,   111,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   121,    -1,    -1,    -1,    -1,    -1,
      -1,   128,   129,   210,   131,    -1,    81,    82,    -1,    -1,
      -1,    -1,    87,    -1,    -1,    -1,    -1,   144,   145,   146,
     227,    96,    97,    98,    99,   100,    -1,   102,   103,   104,
      -1,    -1,   107,    -1,    -1,    -1,   111,   202,    -1,    -1,
      -1,    -1,    81,    82,    -1,   210,   121,    -1,    87,    -1,
      -1,    -1,    -1,   128,   129,    -1,   131,    96,    97,    98,
      99,   100,   227,   102,   103,   104,    -1,    -1,   107,    -1,
      -1,   146,   111,    -1,    -1,   202,    -1,    -1,    -1,    -1,
      81,    82,   121,   210,    -1,    -1,    87,    -1,    -1,   128,
     129,    -1,   131,    -1,    -1,    96,    97,    98,    99,   100,
     227,   102,   103,   104,    -1,    -1,   107,    81,    82,    -1,
     111,    -1,    -1,    87,    -1,    -1,    -1,    -1,    -1,    -1,
     121,    -1,    96,    97,    98,    99,   100,   202,   102,   103,
     104,    -1,    -1,   107,    -1,   210,    -1,   111,    -1,    80,
      -1,    -1,    -1,   144,   145,   146,    -1,   121,    -1,    -1,
      -1,    -1,   227,    -1,    -1,    96,    97,    98,    99,    81,
      82,   102,    -1,   202,    -1,    87,   107,    -1,    -1,    -1,
     111,   210,   146,    -1,    96,    97,    98,    99,   100,    -1,
     102,   103,   104,    -1,    -1,   107,    -1,    -1,   227,   111,
      -1,    -1,    -1,    -1,   135,   136,    -1,    -1,    -1,   121,
      80,   202,    -1,   144,   145,   146,   147,    87,    -1,   210,
      -1,    -1,    -1,    -1,    -1,    -1,    96,    97,    -1,    99,
     100,    -1,   102,   103,   104,   166,   227,   107,   202,    -1,
      -1,   172,    -1,    -1,    -1,    -1,   210,    -1,    -1,    -1,
      -1,   121,    80,    81,    82,    -1,    -1,    -1,    -1,    87,
      -1,    -1,    -1,   227,    -1,   135,   136,    -1,    96,    97,
      98,    99,   100,    -1,   102,   103,   104,   147,    -1,   107,
      -1,    -1,    -1,   111,    -1,    -1,    -1,    -1,    -1,    -1,
     202,    -1,    -1,   121,    -1,    -1,   166,    -1,   210,    -1,
     128,   129,   172,   131,    80,    81,    82,   135,   136,    -1,
      -1,    87,    -1,    -1,    -1,   227,   144,   145,   146,   147,
      96,    97,    98,    99,   100,    -1,   102,   103,   104,    -1,
      -1,   107,    -1,    -1,    -1,   111,    -1,    -1,   166,    -1,
      -1,    -1,    -1,    -1,   172,   121,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,
     136,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   144,   145,
     146,   147,    -1,    -1,   202,    80,    81,    82,    -1,    -1,
      -1,    -1,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     166,    96,    97,    98,    99,   100,   172,   102,   103,   104,
      -1,    -1,   107,    -1,    -1,    -1,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   121,    -1,    81,    82,
      -1,    -1,    -1,    -1,    87,    -1,   202,    -1,    -1,    -1,
     135,   136,    -1,    96,    97,    98,    99,   100,    -1,   102,
     103,   104,   147,    -1,   107,    -1,    -1,    -1,   111,    -1,
      -1,    -1,    -1,    -1,    81,    82,    -1,    -1,   121,    -1,
      87,   166,    -1,    -1,    -1,   128,   129,   172,   131,    96,
      97,    98,    99,   100,    -1,   102,   103,   104,    -1,    -1,
     107,   144,   145,   146,   111,    -1,    -1,    -1,    -1,    -1,
      81,    82,    -1,    -1,   121,    -1,    87,   202,    -1,    -1,
      -1,   128,   129,    -1,   131,    96,    97,    98,    99,   100,
      -1,   102,   103,   104,    -1,    -1,   107,    -1,    -1,   146,
     111,    -1,    -1,    -1,    -1,    -1,    81,    82,    -1,    -1,
     121,    -1,    87,    -1,    -1,    -1,    -1,   128,   129,   202,
     131,    96,    97,    98,    99,   100,    -1,   102,   103,   104,
      -1,    -1,   107,    -1,    -1,    -1,   111,    -1,    -1,    -1,
      -1,    -1,    81,    82,    -1,    -1,   121,    -1,    87,    -1,
      -1,    -1,    -1,    -1,    -1,   202,    -1,    96,    97,    98,
      99,   100,    -1,   102,   103,   104,    -1,    -1,   107,   144,
     145,   146,   111,    -1,    -1,    -1,    -1,    -1,    81,    82,
      -1,    -1,   121,    -1,    87,    -1,    -1,    -1,    -1,    -1,
      -1,   202,    -1,    96,    97,    98,    99,   100,    -1,   102,
     103,   104,    -1,    -1,   107,    -1,    -1,   146,   111,    78,
      79,    -1,    81,    -1,    -1,    -1,    78,    79,   121,    81,
      -1,    90,    91,    92,    93,    94,    95,   202,    90,    91,
      92,    93,    94,    95,    -1,    -1,    -1,   106,    -1,   108,
      -1,   110,    -1,    -1,   106,   114,   108,    -1,   110,    -1,
      -1,    -1,   114,    -1,    -1,   124,    -1,    -1,    -1,    -1,
      -1,    -1,   124,   202,   133,    -1,    -1,    -1,    -1,    -1,
     132,   133,    -1,   142,   143,    -1,    -1,    -1,    -1,    -1,
     142,   143,   151,    -1,   153,    -1,    -1,    -1,    -1,   151,
      -1,   153,    78,    79,    -1,    81,    -1,    -1,    -1,   202,
      -1,    -1,    88,    -1,    90,    91,    92,    -1,    94,    -1,
      -1,   180,    78,    79,    -1,    81,    -1,    -1,   180,    -1,
     106,    -1,   108,    -1,    90,    91,    92,    -1,    94,    -1,
      -1,    -1,    80,    -1,    -1,    -1,    -1,    -1,   124,    -1,
     106,    -1,   108,    -1,    -1,    -1,    -1,   133,    96,    97,
      98,    99,    80,    -1,   102,    -1,   142,   143,   124,   107,
      -1,    -1,    -1,   111,    -1,   151,    -1,   133,    96,    97,
      -1,    99,   100,    -1,   102,    -1,   142,   143,    -1,   107,
     128,   129,    -1,   131,    -1,   151,    -1,   135,   136,    -1,
      -1,    -1,    -1,    -1,   180,    -1,   144,   145,   146,   147,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,   136,    -1,
      -1,    -1,    -1,    -1,   180,    -1,   144,   145,   166,   147,
       9,    -1,    -1,    -1,   172,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   166,    -1,
      -1,    -1,    -1,    -1,   172,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
       9,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,   143,
      -1,    -1,    -1,    -1,    -1,   149,    -1,   151,    -1,   153,
      -1,    -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,    -1,
     164,    -1,   166,    -1,   168,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   176,    -1,   178,    -1,   180,    -1,   182,    -1,
     184,    -1,   186,    -1,   188,    -1,   190,    -1,   192,    -1,
      -1,    -1,   196
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     5,     6,     7,     8,     9,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      73,    75,    76,    77,   156,   182,   203,   212,   229,   253,
     254,   258,   259,   260,   261,   267,   270,   271,   272,   273,
     274,   283,   301,   302,   303,   304,   307,   323,   376,   377,
     378,   425,   426,   428,   558,   561,   604,   606,   616,   617,
       8,    10,    11,    13,    14,    33,    70,    71,    72,   203,
     211,   212,   213,   214,   215,   216,   231,   232,   233,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   251,     8,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    74,    75,    76,
     155,   182,   208,   226,   251,   253,   254,   289,   291,   292,
     294,   295,   296,   297,   298,   299,   300,   311,   330,   331,
     333,   334,   341,   342,   350,   351,   357,   358,   363,   364,
     381,   382,   385,   386,   389,   390,   405,   407,   411,   414,
     417,   433,   434,   441,   442,   447,   448,   451,   452,   455,
     456,   459,   460,   463,   464,   467,   468,   471,   472,   475,
     476,   479,   480,   483,   484,   487,   488,   491,   492,   495,
     496,   499,   500,   503,   504,   514,   515,   518,   519,   522,
     523,   524,   525,   528,   529,   530,   531,   535,   536,   537,
     538,   539,   543,   546,   547,   548,   555,   557,   596,   597,
     598,   603,   604,   612,   613,   616,   621,   622,   301,   321,
     322,   323,   203,   132,   559,   138,   171,   203,   227,   429,
     430,   183,   201,   272,   270,   274,   275,     0,   226,   255,
     256,   272,   254,   254,   321,   254,   254,   306,   309,   203,
     205,   273,   302,    76,   254,   303,   328,   378,   253,   303,
     327,   329,   254,   272,   304,   203,   203,   235,   235,   203,
     235,   203,   203,   203,   251,   259,   264,   270,   280,    11,
      12,    13,    14,   203,   205,   207,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,   225,   250,   235,   237,
     212,   217,   218,   213,   214,    15,    16,    17,    18,   219,
     220,    19,    20,   211,   221,   222,    21,    22,   223,   210,
     224,   248,   252,   224,   203,   203,   203,    76,   182,   289,
     203,     8,   226,   226,   226,   251,    49,    51,    66,   203,
     312,   313,   314,    78,    79,    81,    90,    91,    92,    93,
      94,    95,   106,   108,   110,   114,   124,   133,   142,   143,
     151,   153,   180,    78,    79,   106,   151,   556,   108,   184,
     189,   202,   623,   209,   293,   226,   272,   295,   289,   332,
     299,   208,   354,   332,   299,   299,   299,   332,   406,   332,
     299,   299,   299,   332,   332,   332,   299,   299,   299,   299,
     299,   299,   299,   299,   299,   332,   299,   354,   332,   332,
     332,   296,   332,   332,     8,   330,   603,     8,   208,   283,
     323,   203,   102,   124,   203,   431,   432,     8,   588,   589,
     210,   227,   430,   607,   618,   204,   270,   274,   210,   226,
     225,   305,   308,     8,   208,   283,   292,   253,   310,     8,
     204,   254,   276,   277,   278,   279,    36,   206,   212,   249,
     275,   132,   272,   157,   327,   427,   272,   605,   234,   249,
     280,   280,   249,   280,   280,   204,   264,   203,   205,   274,
     281,   282,   264,   204,     8,   283,   234,   251,     8,   283,
     249,   237,   237,   237,   238,   238,   239,   239,   240,   240,
     240,   240,   241,   241,   242,   243,   244,   245,   246,   251,
     249,   321,   224,    76,   289,   290,   331,   251,   251,   251,
     133,    63,   226,   251,   253,   226,   226,   203,   231,   312,
     314,    79,   106,   335,   352,   147,   549,   551,   552,   359,
     227,   203,   227,   526,   227,   115,   116,   117,   118,   541,
     203,   227,   544,   124,   343,   505,   227,   227,   365,    78,
     118,   134,   142,   164,   165,   408,   143,   435,    78,   124,
     443,   532,   556,   181,   420,   540,   227,   614,   227,   599,
     203,   227,   294,    76,   332,   355,   356,   332,   203,   208,
       8,   230,   268,   269,   208,     8,     9,    10,   324,   325,
     326,   203,   379,     8,   595,   203,   203,   205,   590,   204,
     210,   430,   608,   203,   256,   257,   292,   310,   208,   209,
     262,   263,   264,   208,   253,   292,   203,   272,   274,   281,
     204,   210,   204,   210,   249,   275,   206,   206,    36,   206,
     212,   249,   227,   292,   204,   210,   204,   204,   210,   210,
     210,   204,   276,   281,   206,   212,   249,   282,   203,   205,
     208,   237,   204,   206,   224,   289,   290,   204,   204,   204,
     203,   226,   251,   226,   226,   251,   231,   204,   224,   520,
     124,   516,    87,    96,    97,    99,   100,   102,   103,   104,
     107,   121,   210,   227,   336,   337,   567,   568,   570,   574,
     576,   580,   594,    80,    98,   210,   227,   353,   568,   570,
     572,   576,   203,   124,   170,   210,   227,   550,   147,   210,
     227,   552,    80,   105,   210,   227,   360,   361,   568,   570,
       8,   158,   227,   527,   152,   542,   545,   227,   383,    80,
      81,    82,   111,   202,   210,   227,   344,   345,   568,   570,
     572,   576,   584,   625,   109,   112,   113,   147,   168,   176,
     210,   227,   506,   507,   509,   512,   567,   568,   570,   574,
     580,   128,   129,   131,   210,   227,   366,   367,   371,   373,
     568,   572,   576,   580,   584,   106,   465,    80,   135,   138,
     139,   393,   418,   419,   422,   509,   580,   391,   143,   461,
     134,   134,    80,   136,   166,   172,   210,   227,   393,   395,
     402,   403,   409,   410,   509,   568,   570,   580,    78,   124,
     469,   144,   145,   210,   227,   436,   437,   567,   568,   570,
     574,   576,   106,   449,   146,   210,   227,   444,   445,   568,
     570,   572,   584,   177,   210,   227,   533,   210,   227,   580,
     203,   227,    61,   109,   158,   186,   187,   188,   200,   210,
     227,   615,   600,   231,   209,    88,    76,   209,   356,   332,
     234,   268,   225,   209,   210,   268,   204,   210,   203,     8,
      21,    22,   119,   120,   211,   212,   213,   214,   221,   222,
     564,   125,   126,   127,   130,   210,   227,   368,   369,   371,
     373,   380,   204,   210,   588,     8,   586,   587,   592,   205,
     227,   589,   102,   148,   149,   150,   210,   227,   609,     8,
     620,   208,   249,   284,   292,   262,   209,   263,   224,   226,
     265,   266,   272,   262,    58,   278,     8,   206,   249,   249,
     206,   206,   249,   280,     8,   280,   204,   204,   206,   206,
     204,   276,   206,   212,   249,   205,   207,   284,   285,   286,
     287,   288,   248,   289,   289,   289,   251,   204,   251,   226,
     226,   251,   204,   251,   226,   224,   205,   231,   315,   316,
     210,   227,   337,   521,   567,   568,   570,   572,   574,   576,
     580,   387,   210,   227,   337,   345,   517,   567,   568,   570,
     572,   574,   576,   580,   340,   569,   571,   575,   203,   203,
     339,   203,   203,   203,   336,   573,   353,   159,   160,   550,
     203,   552,   362,   360,   204,   203,   227,   227,     8,   585,
     210,   227,   344,   367,   384,   203,   203,   203,   203,   344,
     203,   203,   203,   203,   506,   372,   374,   203,   366,   501,
      80,   210,   227,   337,   410,   466,   509,   567,   568,   570,
     574,   576,   580,   203,   423,   424,   210,   227,   419,   167,
     210,   227,   392,   393,   395,   400,   580,    78,   124,   477,
      80,   210,   227,   410,   436,   462,   509,   580,    80,   393,
     395,   412,   413,   509,   580,    80,   393,   395,   415,   416,
     509,   580,   203,   203,   203,   409,   106,   473,   210,   227,
     437,   444,   470,   574,   576,   203,   203,   436,   124,   453,
     210,   227,   367,   444,   450,   580,   203,   444,   203,   533,
     580,   227,   421,   203,   203,   203,   203,   615,   109,   190,
     191,   192,   200,   210,   227,   601,   204,   624,   227,   332,
     204,   209,   210,   252,   209,   269,   209,   210,   204,   325,
     234,   224,   370,   203,   380,   560,     8,   204,   590,   204,
     210,   224,   251,   593,   591,   203,   203,   203,   203,   609,
     204,   210,   285,   209,   252,   210,   226,   224,   209,   206,
     206,   204,   204,   204,   204,   206,   206,   252,     8,   283,
     209,   210,   284,   225,   288,     4,   204,   289,   204,   204,
     251,   204,   251,   226,   289,   204,   204,   251,   224,     8,
     203,   204,   210,   224,   521,   210,   227,   367,   388,   517,
     517,   203,   203,   203,   203,    87,    99,   101,   100,   108,
     178,   564,   579,   203,   338,    78,   108,   124,   133,   153,
     581,   583,    91,   122,   123,   179,   203,   204,   224,   203,
     251,   204,   210,   384,   251,    89,   174,   175,   349,   251,
     231,   508,   148,   149,   150,   511,   251,   564,   203,   203,
     251,    80,   210,   227,   410,   502,   509,   517,   466,   394,
     203,   203,   419,   203,   392,   106,   481,    80,   210,   227,
     410,   470,   478,   509,   580,   462,   210,   227,   413,   210,
     227,   416,   163,   397,   398,   404,   140,   124,   485,   210,
     227,   437,   450,   474,   574,   576,   470,   438,   439,   457,
     210,   227,   445,   454,   517,   450,    83,   564,   227,   251,
     251,   251,   197,   198,   212,   249,   249,   203,   203,   203,
     601,   210,   226,   209,   209,   204,   259,   565,   203,   251,
     227,   587,   251,   224,   206,   593,   564,     8,   610,   611,
     610,   610,   619,     8,   209,   210,   266,   252,   206,   209,
     284,   286,   289,   226,   289,   289,   204,   289,   204,   204,
     251,   289,   289,   204,   205,   231,   317,   318,   206,   235,
     316,   317,   388,   585,   585,   585,   585,   204,   204,   204,
     577,   210,   585,   251,   118,   134,   164,   165,   251,   224,
     204,   204,   204,   204,   585,   227,     8,   553,   554,   585,
     204,     8,   204,   210,   224,   224,     1,    83,    84,    85,
      86,    87,   348,   204,   204,   626,   251,   510,   204,   513,
     585,   585,   204,   502,   251,   586,   586,   401,   124,   489,
      80,   210,   227,   410,   474,   482,   509,   478,   413,   416,
     210,   586,   137,   138,   139,   140,   161,   162,   399,   585,
     224,   493,   210,   227,   437,   454,   486,   474,   251,   251,
     210,   227,   388,   445,   458,   454,   204,   210,   534,   204,
     204,   204,   204,   204,   204,   204,   204,   249,   249,   193,
     194,   602,   251,   210,   224,   585,   204,   251,   206,   224,
     205,   204,   210,   204,   204,   227,   209,   284,   289,   289,
     289,   204,   289,     8,   203,   210,   224,   231,   204,   204,
     224,   204,   204,   204,   204,   224,   564,   204,   204,   134,
     134,   204,   582,   204,   213,   214,   204,   210,   204,   347,
     204,   210,   210,   204,   224,   224,   224,   375,   375,   204,
     204,   204,   585,   497,    80,   210,   227,   410,   486,   490,
     509,   482,   204,   224,   204,   173,   210,   227,   437,   458,
     494,   486,   224,   440,   204,   458,   446,   224,   204,   204,
     210,   204,   204,   259,   562,   204,   610,   223,   249,   611,
     289,   206,   251,   318,   231,   319,   203,   319,   586,   578,
     251,   238,   238,   553,   251,   346,   251,   586,   586,   251,
     204,   204,   204,    80,   210,   227,   410,   494,   498,   509,
     490,   396,   204,   494,   251,   204,   251,   586,   195,   196,
     251,   204,     8,   206,   231,   204,   210,   224,   235,   204,
     204,   224,   204,   204,   251,   204,   204,   204,   498,   586,
     204,   204,   204,   206,   203,   231,     8,   320,   204,   586,
     204,   204,   563,   251,   204,   210,   204,   154,   566,   204,
       8,   203,   227,     8,   203,   225,   234,   248,   204,   204,
     204
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   228,   229,   229,   229,   229,   230,   231,   231,   232,
     232,   232,   232,   233,   233,   233,   233,   233,   233,   233,
     233,   233,   233,   233,   233,   234,   234,   234,   235,   235,
     235,   235,   235,   235,   235,   235,   235,   236,   236,   236,
     236,   236,   236,   237,   237,   238,   238,   238,   238,   239,
     239,   239,   240,   240,   240,   241,   241,   241,   241,   241,
     242,   242,   242,   243,   243,   244,   244,   245,   245,   246,
     246,   247,   247,   248,   248,   249,   249,   250,   250,   250,
     250,   250,   250,   250,   250,   250,   250,   250,   251,   251,
     252,   253,   253,   253,   253,   253,   253,   254,   254,   254,
     254,   254,   254,   254,   254,   255,   255,   256,   257,   256,
     258,   258,   258,   258,   258,   259,   259,   259,   259,   259,
     259,   259,   259,   259,   259,   259,   259,   259,   259,   259,
     260,   260,   260,   260,   260,   260,   261,   261,   262,   262,
     263,   263,   264,   264,   264,   264,   265,   265,   266,   266,
     266,   267,   267,   267,   267,   267,   267,   267,   267,   268,
     268,   269,   269,   270,   270,   270,   270,   271,   272,   272,
     273,   273,   273,   273,   273,   273,   273,   273,   273,   273,
     273,   273,   273,   273,   274,   274,   274,   274,   275,   275,
     276,   276,   277,   277,   278,   278,   278,   279,   279,   280,
     280,   281,   281,   281,   282,   282,   282,   282,   282,   282,
     282,   282,   282,   282,   282,   283,   284,   284,   284,   285,
     285,   285,   285,   286,   287,   287,   288,   288,   288,   289,
     289,   289,   289,   289,   289,   289,   289,   289,   289,   290,
     290,   291,   291,   291,   292,   293,   292,   294,   294,   295,
     295,   295,   295,   296,   296,   297,   297,   297,   298,   298,
     298,   299,   299,   299,   299,   299,   299,   299,   299,   299,
     299,   299,   299,   300,   300,   300,   300,   300,   301,   301,
     302,   302,   302,   302,   302,   303,   303,   305,   304,   306,
     304,   308,   307,   309,   307,   310,   310,   311,   311,   312,
     312,   312,   312,   312,   313,   313,   314,   314,   315,   315,
     315,   316,   316,   317,   317,   317,   318,   318,   319,   319,
     320,   320,   321,   321,   322,   322,   323,   324,   324,   325,
     325,   325,   326,   326,   326,   327,   327,   328,   329,   329,
     330,   330,   330,   330,   330,   330,   330,   330,   330,   330,
     330,   330,   330,   330,   330,   330,   330,   330,   330,   330,
     330,   330,   330,   330,   330,   330,   330,   330,   330,   330,
     330,   330,   330,   330,   331,   331,   331,   331,   331,   331,
     331,   331,   331,   332,   333,   334,   335,   335,   335,   336,
     336,   336,   336,   336,   336,   336,   338,   337,   339,   337,
     337,   340,   337,   341,   342,   343,   343,   343,   344,   344,
     344,   344,   344,   344,   345,   345,   345,   346,   345,   347,
     345,   345,   345,   348,   348,   348,   348,   348,   348,   349,
     349,   349,   350,   351,   352,   352,   352,   353,   353,   353,
     353,   353,   354,   355,   355,   355,   356,   357,   358,   359,
     359,   359,   360,   360,   360,   360,   362,   361,   363,   364,
     365,   365,   365,   366,   366,   366,   366,   366,   366,   367,
     367,   367,   368,   368,   370,   369,   372,   371,   374,   373,
     375,   375,   376,   377,   377,   378,   379,   379,   379,   380,
     380,   380,   380,   380,   381,   382,   383,   383,   383,   384,
     384,   385,   386,   387,   387,   387,   388,   388,   389,   390,
     391,   391,   391,   392,   392,   392,   392,   394,   393,   396,
     395,   397,   395,   398,   398,   398,   399,   399,   399,   399,
     399,   399,   401,   400,   402,   404,   403,   406,   405,   407,
     408,   408,   408,   409,   409,   409,   409,   409,   409,   410,
     410,   410,   410,   411,   412,   412,   412,   413,   413,   413,
     413,   413,   414,   415,   415,   415,   416,   416,   416,   416,
     416,   417,   418,   418,   418,   419,   419,   419,   419,   419,
     421,   420,   423,   422,   424,   422,   425,   425,   426,   427,
     428,   428,   429,   429,   429,   431,   430,   432,   430,   433,
     434,   435,   435,   435,   436,   436,   436,   436,   436,   436,
     438,   437,   439,   437,   440,   440,   441,   442,   443,   443,
     443,   444,   444,   444,   444,   444,   445,   446,   445,   447,
     448,   449,   449,   449,   450,   450,   450,   451,   452,   453,
     453,   453,   454,   454,   455,   456,   457,   457,   457,   458,
     458,   459,   460,   461,   461,   461,   462,   462,   462,   462,
     462,   463,   464,   465,   465,   465,   466,   466,   466,   466,
     466,   466,   466,   466,   466,   466,   467,   468,   469,   469,
     469,   470,   470,   470,   470,   471,   472,   473,   473,   473,
     474,   474,   474,   474,   475,   476,   477,   477,   477,   478,
     478,   478,   478,   478,   479,   480,   481,   481,   481,   482,
     482,   482,   482,   483,   484,   485,   485,   485,   486,   486,
     487,   488,   489,   489,   489,   490,   490,   490,   490,   491,
     492,   493,   493,   493,   494,   494,   495,   496,   497,   497,
     497,   498,   498,   498,   498,   499,   500,   501,   501,   501,
     502,   502,   502,   502,   503,   504,   505,   505,   505,   506,
     506,   506,   506,   506,   506,   506,   506,   508,   507,   507,
     507,   507,   510,   509,   511,   511,   511,   513,   512,   514,
     515,   516,   516,   516,   517,   517,   517,   517,   517,   517,
     517,   517,   517,   518,   519,   520,   520,   520,   521,   521,
     521,   521,   521,   521,   521,   521,   522,   523,   524,   525,
     525,   525,   526,   527,   528,   529,   530,   531,   532,   532,
     532,   534,   533,   535,   536,   537,   538,   539,   540,   540,
     541,   541,   541,   541,   541,   542,   542,   543,   543,   545,
     544,   546,   546,   547,   548,   548,   549,   549,   549,   550,
     550,   551,   551,   551,   552,   553,   553,   554,   554,   554,
     555,   555,   555,   556,   556,   556,   556,   557,   559,   560,
     558,   562,   563,   561,   564,   564,   564,   564,   564,   564,
     564,   564,   564,   564,   564,   565,   565,   566,   566,   566,
     567,   567,   567,   569,   568,   571,   570,   573,   572,   575,
     574,   577,   576,   578,   576,   579,   579,   579,   579,   581,
     580,   582,   580,   583,   583,   583,   583,   583,   583,   583,
     583,   583,   584,   585,   585,   586,   586,   587,   587,   588,
     588,   589,   589,   591,   590,   592,   590,   593,   593,   593,
     593,   593,   594,   594,   594,   594,   595,   595,   596,   596,
     597,   599,   598,   600,   600,   600,   601,   601,   601,   601,
     601,   602,   602,   602,   602,   603,   603,   603,   603,   605,
     604,   604,   607,   606,   608,   608,   608,   609,   609,   609,
     609,   610,   610,   611,   611,   611,   612,   613,   614,   614,
     614,   615,   615,   615,   615,   615,   615,   615,   615,   615,
     615,   616,   618,   619,   617,   620,   620,   621,   621,   622,
     623,   624,   623,   625,   626,   625
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     2,     2,     1,     1,     2,     1,
       1,     1,     3,     1,     4,     4,     4,     3,     3,     3,
       3,     2,     2,     6,     7,     0,     1,     3,     1,     2,
       2,     2,     2,     4,     6,     6,     6,     1,     1,     1,
       1,     1,     1,     1,     4,     1,     3,     3,     3,     1,
       3,     3,     1,     3,     3,     1,     3,     3,     3,     3,
       1,     3,     3,     1,     3,     1,     3,     1,     3,     1,
       3,     1,     3,     1,     5,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       1,     2,     3,     1,     1,     1,     1,     1,     2,     1,
       2,     1,     2,     1,     2,     1,     3,     1,     0,     4,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       5,     4,     6,     6,     3,     3,     1,     1,     1,     2,
       3,     2,     1,     2,     1,     2,     1,     3,     1,     3,
       2,     5,     6,     6,     6,     7,     7,     3,     3,     1,
       3,     1,     3,     1,     1,     1,     1,     1,     1,     2,
       1,     3,     3,     4,     4,     5,     5,     6,     6,     4,
       5,     4,     3,     4,     1,     2,     2,     3,     1,     2,
       1,     3,     1,     3,     2,     1,     2,     1,     3,     1,
       2,     1,     1,     2,     3,     2,     3,     3,     4,     3,
       4,     2,     3,     3,     4,     1,     1,     3,     4,     1,
       2,     3,     4,     2,     1,     2,     3,     2,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     4,     4,     3,     2,     0,     4,     1,     2,     1,
       1,     1,     1,     1,     2,     5,     7,     5,     5,     7,
       1,     6,     7,     7,     7,     8,     8,     8,     9,     6,
       7,     7,     8,     3,     2,     2,     2,     3,     1,     2,
       1,     1,     1,     1,     1,     1,     1,     0,     4,     0,
       3,     0,     5,     0,     4,     1,     2,     2,     3,     3,
       5,     7,     9,    11,     1,     2,     1,     1,     0,     1,
       3,     7,     4,     0,     1,     3,     7,     4,     1,     3,
       1,     3,     0,     1,     1,     2,     6,     1,     3,     0,
       1,     4,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     4,     0,     2,     3,     1,
       1,     1,     1,     1,     1,     1,     0,     5,     0,     5,
       1,     0,     5,     2,     4,     0,     2,     3,     1,     1,
       1,     1,     1,     1,     1,     4,     5,     0,     8,     0,
       7,     1,     1,     1,     1,     1,     1,     1,     1,     0,
       2,     2,     2,     4,     0,     2,     3,     1,     1,     1,
       1,     1,     3,     1,     2,     3,     3,     2,     4,     0,
       2,     3,     1,     1,     1,     1,     0,     5,     2,     4,
       0,     2,     3,     1,     1,     1,     1,     1,     1,     4,
       1,     1,     1,     1,     0,     5,     0,     6,     0,     6,
       0,     2,     2,     1,     2,     5,     0,     2,     3,     4,
       1,     1,     1,     1,     2,     5,     0,     2,     3,     1,
       1,     2,     6,     0,     2,     3,     1,     1,     2,     5,
       0,     2,     3,     1,     1,     1,     1,     0,     5,     0,
       8,     0,     5,     0,     1,     2,     1,     1,     1,     1,
       1,     1,     0,     5,     6,     0,     5,     0,     3,     4,
       0,     2,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     6,     1,     2,     3,     1,     1,     1,
       1,     1,     6,     1,     2,     3,     1,     1,     1,     1,
       1,     5,     1,     2,     3,     1,     1,     1,     1,     1,
       0,     5,     0,     5,     0,     5,     3,     1,     2,     2,
       5,     3,     1,     2,     3,     0,     5,     0,     5,     2,
       4,     0,     2,     3,     1,     1,     1,     1,     1,     1,
       0,     6,     0,     5,     0,     2,     2,     4,     0,     2,
       3,     1,     1,     1,     1,     1,     4,     0,     7,     2,
       5,     0,     2,     3,     1,     1,     1,     2,     6,     0,
       2,     3,     1,     1,     2,     7,     0,     2,     3,     1,
       1,     2,     5,     0,     2,     3,     1,     1,     1,     1,
       1,     2,     5,     0,     2,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     5,     0,     2,
       3,     1,     1,     1,     1,     2,     6,     0,     2,     3,
       1,     1,     1,     1,     2,     6,     0,     2,     3,     1,
       1,     1,     1,     1,     2,     7,     0,     2,     3,     1,
       1,     1,     1,     2,     7,     0,     2,     3,     1,     1,
       2,     8,     0,     2,     3,     1,     1,     1,     1,     2,
       8,     0,     2,     3,     1,     1,     2,     9,     0,     2,
       3,     1,     1,     1,     1,     2,     6,     0,     2,     3,
       1,     1,     1,     1,     2,     4,     0,     2,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     5,     1,
       1,     4,     0,     7,     1,     1,     1,     0,     7,     2,
       5,     0,     2,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     5,     0,     2,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     3,     2,     3,
       4,     5,     3,     4,     3,     3,     2,     4,     0,     2,
       3,     0,     7,     3,     2,     5,     2,     4,     0,     1,
       0,     1,     1,     1,     1,     0,     1,     3,     4,     0,
       4,     2,     1,     4,     7,     4,     0,     2,     3,     1,
       1,     1,     2,     3,     6,     1,     3,     1,     3,     3,
       4,     5,     6,     1,     1,     1,     1,     3,     0,     0,
       7,     0,     0,    14,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     0,     6,     7,
       4,     4,     4,     0,     5,     0,     5,     0,     5,     0,
       5,     0,     7,     0,     9,     0,     1,     1,     1,     0,
       5,     0,     7,     1,     1,     1,     2,     3,     3,     2,
       1,     1,     4,     1,     3,     1,     3,     1,     2,     1,
       3,     1,     2,     0,     5,     0,     4,     3,     2,     1,
       2,     1,     4,     4,     4,     4,     1,     3,     1,     1,
       3,     0,     5,     0,     2,     3,     4,     4,     4,     1,
       1,     1,     1,     3,     3,     1,     1,     1,     1,     0,
       4,     2,     0,     5,     0,     2,     3,     4,     4,     4,
       6,     1,     3,     1,     5,     4,     6,     4,     0,     2,
       3,     4,     4,     4,     4,     4,     1,     1,     1,     4,
       4,     1,     0,     0,     8,     1,     3,     2,     2,     3,
       4,     0,     7,     4,     0,     7
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 564 "parser.y" /* yacc.c:1646  */
    { /* to avoid warnings */ }
#line 3883 "parser.c" /* yacc.c:1646  */
    break;

  case 3:
#line 565 "parser.y" /* yacc.c:1646  */
    { pastree_expr = (yyvsp[0].expr); }
#line 3889 "parser.c" /* yacc.c:1646  */
    break;

  case 4:
#line 566 "parser.y" /* yacc.c:1646  */
    { pastree_stmt = (yyvsp[0].stmt); }
#line 3895 "parser.c" /* yacc.c:1646  */
    break;

  case 5:
#line 567 "parser.y" /* yacc.c:1646  */
    { pastree_stmt = (yyvsp[0].stmt); }
#line 3901 "parser.c" /* yacc.c:1646  */
    break;

  case 6:
#line 585 "parser.y" /* yacc.c:1646  */
    {
      symbol s = Symbol((yyvsp[0].name));
      if (checkDecls)
      {
        if ( symtab_get(stab, s, LABELNAME) )  /* NOT a type name */
          parse_error(-1, "enum symbol '%s' is already in use.", (yyvsp[0].name));
        symtab_put(stab, s, LABELNAME);
      }
      (yyval.symb) = s;
    }
#line 3916 "parser.c" /* yacc.c:1646  */
    break;

  case 7:
#line 606 "parser.y" /* yacc.c:1646  */
    {
      (yyval.string) = strdup((yyvsp[0].name));
    }
#line 3924 "parser.c" /* yacc.c:1646  */
    break;

  case 8:
#line 610 "parser.y" /* yacc.c:1646  */
    {
      /* Or we could leave it as is (as a SpaceList) */
      if (((yyvsp[-1].string) = realloc((yyvsp[-1].string), strlen((yyvsp[-1].string)) + strlen((yyvsp[0].name)))) == NULL)
        parse_error(-1, "string out of memory\n");
      strcpy(((yyvsp[-1].string))+(strlen((yyvsp[-1].string))-1),((yyvsp[0].name))+1);  /* Catenate on the '"' */
      (yyval.string) = (yyvsp[-1].string);
    }
#line 3936 "parser.c" /* yacc.c:1646  */
    break;

  case 9:
#line 633 "parser.y" /* yacc.c:1646  */
    {
      symbol  id = Symbol((yyvsp[0].name));
      stentry e;
      bool    chflag = false;

      if (checkDecls)
      {
        check_uknown_var((yyvsp[0].name));
        /* The parser constructs the original AST; this is the only
         * place it doesn't (actually there is one more place, when replacing
         * the "main" function): threadprivate variables are replaced on the
         * fly by pointers. This makes the job of later stages much smoother,
         * but the produced AST is semantically incorrect.
         */
        if ((e = symtab_get(stab, id, IDNAME)) != NULL) /* could be enum name */
          if (istp(e) && threadmode)
            chflag = true;
      }
      (yyval.expr) = chflag ? Parenthesis(Deref(Identifier(id)))
                  : Identifier(id);
    }
#line 3962 "parser.c" /* yacc.c:1646  */
    break;

  case 10:
#line 655 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = Constant( strdup((yyvsp[0].name)) );
    }
#line 3970 "parser.c" /* yacc.c:1646  */
    break;

  case 11:
#line 659 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = String((yyvsp[0].string));
    }
#line 3978 "parser.c" /* yacc.c:1646  */
    break;

  case 12:
#line 663 "parser.y" /* yacc.c:1646  */
    {
      if ((yyvsp[-1].expr)->type == IDENT || (yyvsp[-1].expr)->type == CONSTVAL || (yyvsp[-1].expr)->type == STRING)
        (yyval.expr) = (yyvsp[-1].expr);   /* simplify */
      else
        (yyval.expr) = Parenthesis((yyvsp[-1].expr));
    }
#line 3989 "parser.c" /* yacc.c:1646  */
    break;

  case 13:
#line 674 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = (yyvsp[0].expr);
    }
#line 3997 "parser.c" /* yacc.c:1646  */
    break;

  case 14:
#line 678 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = ArrayIndex((yyvsp[-3].expr), (yyvsp[-1].expr));
    }
#line 4005 "parser.c" /* yacc.c:1646  */
    break;

  case 15:
#line 688 "parser.y" /* yacc.c:1646  */
    {
      /* Catch calls to "main()" (unlikely but possible) */
      (yyval.expr) = strcmp((yyvsp[-3].name), "main") ?
             FunctionCall(IdentName((yyvsp[-3].name)), (yyvsp[-1].expr)) :
             FunctionCall(IdentName(MAIN_NEWNAME), (yyvsp[-1].expr));
    }
#line 4016 "parser.c" /* yacc.c:1646  */
    break;

  case 16:
#line 695 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = FunctionCall((yyvsp[-3].expr), (yyvsp[-1].expr));
    }
#line 4024 "parser.c" /* yacc.c:1646  */
    break;

  case 17:
#line 699 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = DotField((yyvsp[-2].expr), Symbol((yyvsp[0].name)));
    }
#line 4032 "parser.c" /* yacc.c:1646  */
    break;

  case 18:
#line 703 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = PtrField((yyvsp[-2].expr), Symbol((yyvsp[0].name)));
    }
#line 4040 "parser.c" /* yacc.c:1646  */
    break;

  case 19:
#line 712 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = DotField((yyvsp[-2].expr), (yyvsp[0].symb));
    }
#line 4048 "parser.c" /* yacc.c:1646  */
    break;

  case 20:
#line 716 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = PtrField((yyvsp[-2].expr), (yyvsp[0].symb));
    }
#line 4056 "parser.c" /* yacc.c:1646  */
    break;

  case 21:
#line 720 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = PostOperator((yyvsp[-1].expr), UOP_inc);
    }
#line 4064 "parser.c" /* yacc.c:1646  */
    break;

  case 22:
#line 724 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = PostOperator((yyvsp[-1].expr), UOP_dec);
    }
#line 4072 "parser.c" /* yacc.c:1646  */
    break;

  case 23:
#line 728 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = CastedExpr((yyvsp[-4].decl), BracedInitializer((yyvsp[-1].expr)));
    }
#line 4080 "parser.c" /* yacc.c:1646  */
    break;

  case 24:
#line 732 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = CastedExpr((yyvsp[-5].decl), BracedInitializer((yyvsp[-2].expr)));
    }
#line 4088 "parser.c" /* yacc.c:1646  */
    break;

  case 25:
#line 740 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = NULL;
    }
#line 4096 "parser.c" /* yacc.c:1646  */
    break;

  case 26:
#line 744 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = (yyvsp[0].expr);
    }
#line 4104 "parser.c" /* yacc.c:1646  */
    break;

  case 27:
#line 748 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = CommaList((yyvsp[-2].expr), (yyvsp[0].expr));
    }
#line 4112 "parser.c" /* yacc.c:1646  */
    break;

  case 28:
#line 756 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = (yyvsp[0].expr);
    }
#line 4120 "parser.c" /* yacc.c:1646  */
    break;

  case 29:
#line 760 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = PreOperator((yyvsp[0].expr), UOP_inc);
    }
#line 4128 "parser.c" /* yacc.c:1646  */
    break;

  case 30:
#line 764 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = PreOperator((yyvsp[0].expr), UOP_dec);
    }
#line 4136 "parser.c" /* yacc.c:1646  */
    break;

  case 31:
#line 768 "parser.y" /* yacc.c:1646  */
    {
      if ((yyvsp[-1].type) == -1)
        (yyval.expr) = (yyvsp[0].expr);                    /* simplify */
      else
        (yyval.expr) = UnaryOperator((yyvsp[-1].type), (yyvsp[0].expr));
    }
#line 4147 "parser.c" /* yacc.c:1646  */
    break;

  case 32:
#line 775 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = Sizeof((yyvsp[0].expr));
    }
#line 4155 "parser.c" /* yacc.c:1646  */
    break;

  case 33:
#line 779 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = Sizeoftype((yyvsp[-1].decl));
    }
#line 4163 "parser.c" /* yacc.c:1646  */
    break;

  case 34:
#line 788 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = FunctionCall(IdentName("__builtin_va_arg"),
                        CommaList((yyvsp[-3].expr), TypeTrick((yyvsp[-1].decl))));
    }
#line 4172 "parser.c" /* yacc.c:1646  */
    break;

  case 35:
#line 793 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = FunctionCall(IdentName("__builtin_offsetof"),
                        CommaList(TypeTrick((yyvsp[-3].decl)), IdentName((yyvsp[-1].name))));
    }
#line 4181 "parser.c" /* yacc.c:1646  */
    break;

  case 36:
#line 798 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = FunctionCall(IdentName("__builtin_types_compatible_p"),
                        CommaList(TypeTrick((yyvsp[-3].decl)), TypeTrick((yyvsp[-1].decl))));
    }
#line 4190 "parser.c" /* yacc.c:1646  */
    break;

  case 37:
#line 807 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = UOP_addr;
    }
#line 4198 "parser.c" /* yacc.c:1646  */
    break;

  case 38:
#line 811 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = UOP_star;
    }
#line 4206 "parser.c" /* yacc.c:1646  */
    break;

  case 39:
#line 815 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = -1;         /* Ingore this one */
    }
#line 4214 "parser.c" /* yacc.c:1646  */
    break;

  case 40:
#line 819 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = UOP_neg;
    }
#line 4222 "parser.c" /* yacc.c:1646  */
    break;

  case 41:
#line 823 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = UOP_bnot;
    }
#line 4230 "parser.c" /* yacc.c:1646  */
    break;

  case 42:
#line 827 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = UOP_lnot;
    }
#line 4238 "parser.c" /* yacc.c:1646  */
    break;

  case 43:
#line 835 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = (yyvsp[0].expr);
    }
#line 4246 "parser.c" /* yacc.c:1646  */
    break;

  case 44:
#line 839 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = CastedExpr((yyvsp[-2].decl), (yyvsp[0].expr));
    }
#line 4254 "parser.c" /* yacc.c:1646  */
    break;

  case 45:
#line 847 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = (yyvsp[0].expr);
    }
#line 4262 "parser.c" /* yacc.c:1646  */
    break;

  case 46:
#line 851 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = BinaryOperator(BOP_mul, (yyvsp[-2].expr), (yyvsp[0].expr));
    }
#line 4270 "parser.c" /* yacc.c:1646  */
    break;

  case 47:
#line 855 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = BinaryOperator(BOP_div, (yyvsp[-2].expr), (yyvsp[0].expr));
    }
#line 4278 "parser.c" /* yacc.c:1646  */
    break;

  case 48:
#line 859 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = BinaryOperator(BOP_mod, (yyvsp[-2].expr), (yyvsp[0].expr));
    }
#line 4286 "parser.c" /* yacc.c:1646  */
    break;

  case 49:
#line 867 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = (yyvsp[0].expr);
    }
#line 4294 "parser.c" /* yacc.c:1646  */
    break;

  case 50:
#line 871 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = BinaryOperator(BOP_add, (yyvsp[-2].expr), (yyvsp[0].expr));
    }
#line 4302 "parser.c" /* yacc.c:1646  */
    break;

  case 51:
#line 875 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = BinaryOperator(BOP_sub, (yyvsp[-2].expr), (yyvsp[0].expr));
    }
#line 4310 "parser.c" /* yacc.c:1646  */
    break;

  case 52:
#line 883 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = (yyvsp[0].expr);
    }
#line 4318 "parser.c" /* yacc.c:1646  */
    break;

  case 53:
#line 887 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = BinaryOperator(BOP_shl, (yyvsp[-2].expr), (yyvsp[0].expr));
    }
#line 4326 "parser.c" /* yacc.c:1646  */
    break;

  case 54:
#line 891 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = BinaryOperator(BOP_shr, (yyvsp[-2].expr), (yyvsp[0].expr));
    }
#line 4334 "parser.c" /* yacc.c:1646  */
    break;

  case 55:
#line 899 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = (yyvsp[0].expr);
    }
#line 4342 "parser.c" /* yacc.c:1646  */
    break;

  case 56:
#line 903 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = BinaryOperator(BOP_lt, (yyvsp[-2].expr), (yyvsp[0].expr));
    }
#line 4350 "parser.c" /* yacc.c:1646  */
    break;

  case 57:
#line 907 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = BinaryOperator(BOP_gt, (yyvsp[-2].expr), (yyvsp[0].expr));
    }
#line 4358 "parser.c" /* yacc.c:1646  */
    break;

  case 58:
#line 911 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = BinaryOperator(BOP_leq, (yyvsp[-2].expr), (yyvsp[0].expr));
     }
#line 4366 "parser.c" /* yacc.c:1646  */
    break;

  case 59:
#line 915 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = BinaryOperator(BOP_geq, (yyvsp[-2].expr), (yyvsp[0].expr));
    }
#line 4374 "parser.c" /* yacc.c:1646  */
    break;

  case 60:
#line 923 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = (yyvsp[0].expr);
    }
#line 4382 "parser.c" /* yacc.c:1646  */
    break;

  case 61:
#line 927 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = BinaryOperator(BOP_eqeq, (yyvsp[-2].expr), (yyvsp[0].expr));
    }
#line 4390 "parser.c" /* yacc.c:1646  */
    break;

  case 62:
#line 931 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = BinaryOperator(BOP_neq, (yyvsp[-2].expr), (yyvsp[0].expr));
    }
#line 4398 "parser.c" /* yacc.c:1646  */
    break;

  case 63:
#line 939 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = (yyvsp[0].expr);
    }
#line 4406 "parser.c" /* yacc.c:1646  */
    break;

  case 64:
#line 943 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = BinaryOperator(BOP_band, (yyvsp[-2].expr), (yyvsp[0].expr));
    }
#line 4414 "parser.c" /* yacc.c:1646  */
    break;

  case 65:
#line 951 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = (yyvsp[0].expr);
    }
#line 4422 "parser.c" /* yacc.c:1646  */
    break;

  case 66:
#line 955 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = BinaryOperator(BOP_xor, (yyvsp[-2].expr), (yyvsp[0].expr));
    }
#line 4430 "parser.c" /* yacc.c:1646  */
    break;

  case 67:
#line 963 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = (yyvsp[0].expr);
    }
#line 4438 "parser.c" /* yacc.c:1646  */
    break;

  case 68:
#line 967 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = BinaryOperator(BOP_bor, (yyvsp[-2].expr), (yyvsp[0].expr));
    }
#line 4446 "parser.c" /* yacc.c:1646  */
    break;

  case 69:
#line 975 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = (yyvsp[0].expr);
    }
#line 4454 "parser.c" /* yacc.c:1646  */
    break;

  case 70:
#line 979 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = BinaryOperator(BOP_land, (yyvsp[-2].expr), (yyvsp[0].expr));
    }
#line 4462 "parser.c" /* yacc.c:1646  */
    break;

  case 71:
#line 987 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = (yyvsp[0].expr);
    }
#line 4470 "parser.c" /* yacc.c:1646  */
    break;

  case 72:
#line 991 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = BinaryOperator(BOP_lor, (yyvsp[-2].expr), (yyvsp[0].expr));
    }
#line 4478 "parser.c" /* yacc.c:1646  */
    break;

  case 73:
#line 999 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = (yyvsp[0].expr);
    }
#line 4486 "parser.c" /* yacc.c:1646  */
    break;

  case 74:
#line 1003 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = ConditionalExpr((yyvsp[-4].expr), (yyvsp[-2].expr), (yyvsp[0].expr));
    }
#line 4494 "parser.c" /* yacc.c:1646  */
    break;

  case 75:
#line 1011 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = (yyvsp[0].expr);
    }
#line 4502 "parser.c" /* yacc.c:1646  */
    break;

  case 76:
#line 1015 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = Assignment((yyvsp[-2].expr), (yyvsp[-1].type), (yyvsp[0].expr));
    }
#line 4510 "parser.c" /* yacc.c:1646  */
    break;

  case 77:
#line 1023 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = ASS_eq;  /* Need fix here! */
    }
#line 4518 "parser.c" /* yacc.c:1646  */
    break;

  case 78:
#line 1027 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = ASS_mul;
    }
#line 4526 "parser.c" /* yacc.c:1646  */
    break;

  case 79:
#line 1031 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = ASS_div;
    }
#line 4534 "parser.c" /* yacc.c:1646  */
    break;

  case 80:
#line 1035 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = ASS_mod;
    }
#line 4542 "parser.c" /* yacc.c:1646  */
    break;

  case 81:
#line 1039 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = ASS_add;
    }
#line 4550 "parser.c" /* yacc.c:1646  */
    break;

  case 82:
#line 1043 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = ASS_sub;
    }
#line 4558 "parser.c" /* yacc.c:1646  */
    break;

  case 83:
#line 1047 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = ASS_shl;
    }
#line 4566 "parser.c" /* yacc.c:1646  */
    break;

  case 84:
#line 1051 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = ASS_shr;
    }
#line 4574 "parser.c" /* yacc.c:1646  */
    break;

  case 85:
#line 1055 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = ASS_and;
    }
#line 4582 "parser.c" /* yacc.c:1646  */
    break;

  case 86:
#line 1059 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = ASS_xor;
    }
#line 4590 "parser.c" /* yacc.c:1646  */
    break;

  case 87:
#line 1063 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = ASS_or;
    }
#line 4598 "parser.c" /* yacc.c:1646  */
    break;

  case 88:
#line 1071 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = (yyvsp[0].expr);
    }
#line 4606 "parser.c" /* yacc.c:1646  */
    break;

  case 89:
#line 1075 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = CommaList((yyvsp[-2].expr), (yyvsp[0].expr));
    }
#line 4614 "parser.c" /* yacc.c:1646  */
    break;

  case 90:
#line 1083 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = (yyvsp[0].expr);
    }
#line 4622 "parser.c" /* yacc.c:1646  */
    break;

  case 91:
#line 1097 "parser.y" /* yacc.c:1646  */
    {
      /* There is a special case which wrongly uses this rule:
       *   typedef xxx already_known_user_type.
       * In this case the already_known_user_type (T) is re-defined,
       * and because T is known, it is not considered as a declarator,
       * but a "typedef_name", and is part of the specifier.
       * We fix it here.
       */
      if (isTypedef && (yyvsp[-1].spec)->type == SPECLIST)
        (yyval.stmt) = Declaration((yyvsp[-1].spec), fix_known_typename((yyvsp[-1].spec)));
      else
        (yyval.stmt) = Declaration((yyvsp[-1].spec), NULL);
      isTypedef = 0;
    }
#line 4641 "parser.c" /* yacc.c:1646  */
    break;

  case 92:
#line 1112 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = Declaration((yyvsp[-2].spec), (yyvsp[-1].decl));
      if (checkDecls) add_declaration_links((yyvsp[-2].spec), (yyvsp[-1].decl));
      isTypedef = 0;

    }
#line 4652 "parser.c" /* yacc.c:1646  */
    break;

  case 93:
#line 1119 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = OmpStmt(OmpConstruct(DCTHREADPRIVATE, (yyvsp[0].odir), NULL));
    }
#line 4660 "parser.c" /* yacc.c:1646  */
    break;

  case 94:
#line 1124 "parser.y" /* yacc.c:1646  */
    {
      //$$ = OmpStmt(OmpConstruct(DCTHREADPRIVATE, $1, NULL)); TODO
    }
#line 4668 "parser.c" /* yacc.c:1646  */
    break;

  case 95:
#line 1128 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = OmpStmt((yyvsp[0].ocon));
    }
#line 4676 "parser.c" /* yacc.c:1646  */
    break;

  case 96:
#line 1132 "parser.y" /* yacc.c:1646  */
    {
      //$$ = OmpStmt(OmpConstruct(DCTHREADPRIVATE, $1, NULL)); TODO
    }
#line 4684 "parser.c" /* yacc.c:1646  */
    break;

  case 97:
#line 1140 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = (yyvsp[0].spec);
    }
#line 4692 "parser.c" /* yacc.c:1646  */
    break;

  case 98:
#line 1144 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = Speclist_right((yyvsp[-1].spec), (yyvsp[0].spec));
    }
#line 4700 "parser.c" /* yacc.c:1646  */
    break;

  case 99:
#line 1148 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = (yyvsp[0].spec);
    }
#line 4708 "parser.c" /* yacc.c:1646  */
    break;

  case 100:
#line 1152 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = Speclist_right((yyvsp[-1].spec), (yyvsp[0].spec));
    }
#line 4716 "parser.c" /* yacc.c:1646  */
    break;

  case 101:
#line 1156 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = (yyvsp[0].spec);
    }
#line 4724 "parser.c" /* yacc.c:1646  */
    break;

  case 102:
#line 1160 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = Speclist_right((yyvsp[-1].spec), (yyvsp[0].spec));
    }
#line 4732 "parser.c" /* yacc.c:1646  */
    break;

  case 103:
#line 1164 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = (yyvsp[0].spec);
    }
#line 4740 "parser.c" /* yacc.c:1646  */
    break;

  case 104:
#line 1168 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = Speclist_right((yyvsp[-1].spec), (yyvsp[0].spec));
    }
#line 4748 "parser.c" /* yacc.c:1646  */
    break;

  case 105:
#line 1176 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = (yyvsp[0].decl);
    }
#line 4756 "parser.c" /* yacc.c:1646  */
    break;

  case 106:
#line 1180 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = DeclList((yyvsp[-2].decl), (yyvsp[0].decl));
    }
#line 4764 "parser.c" /* yacc.c:1646  */
    break;

  case 107:
#line 1194 "parser.y" /* yacc.c:1646  */
    {
      astdecl s = decl_getidentifier((yyvsp[0].decl));
      int     declkind = decl_getkind((yyvsp[0].decl));
      stentry e;

      if (!isTypedef && declkind == DFUNC && strcmp(s->u.id->name, "main") == 0)
        s->u.id = Symbol(MAIN_NEWNAME);       /* Catch main()'s declaration */
      if (checkDecls)
      {
        e = symtab_put(stab, s->u.id, (isTypedef) ? TYPENAME :
                                       (declkind == DFUNC) ? FUNCNAME : IDNAME);
        e->isarray = (declkind == DARRAY);
      }
      (yyval.decl) = (yyvsp[0].decl);
    }
#line 4784 "parser.c" /* yacc.c:1646  */
    break;

  case 108:
#line 1210 "parser.y" /* yacc.c:1646  */
    {
      astdecl s = decl_getidentifier((yyvsp[-1].decl));
      int     declkind = decl_getkind((yyvsp[-1].decl));
      stentry e;

      if (!isTypedef && declkind == DFUNC && strcmp(s->u.id->name, "main") == 0)
        s->u.id = Symbol(MAIN_NEWNAME);         /* Catch main()'s declaration */
      if (checkDecls)
      {
        e = symtab_put(stab, s->u.id, (isTypedef) ? TYPENAME :
                                       (declkind == DFUNC) ? FUNCNAME : IDNAME);
        e->isarray = (declkind == DARRAY);
      }
    }
#line 4803 "parser.c" /* yacc.c:1646  */
    break;

  case 109:
#line 1225 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = InitDecl((yyvsp[-3].decl), (yyvsp[0].expr));
    }
#line 4811 "parser.c" /* yacc.c:1646  */
    break;

  case 110:
#line 1233 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = StClassSpec(SPEC_typedef);    /* Just a string */
      isTypedef = 1;
    }
#line 4820 "parser.c" /* yacc.c:1646  */
    break;

  case 111:
#line 1238 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = StClassSpec(SPEC_extern);
    }
#line 4828 "parser.c" /* yacc.c:1646  */
    break;

  case 112:
#line 1242 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = StClassSpec(SPEC_static);
    }
#line 4836 "parser.c" /* yacc.c:1646  */
    break;

  case 113:
#line 1246 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = StClassSpec(SPEC_auto);
    }
#line 4844 "parser.c" /* yacc.c:1646  */
    break;

  case 114:
#line 1250 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = StClassSpec(SPEC_register);
    }
#line 4852 "parser.c" /* yacc.c:1646  */
    break;

  case 115:
#line 1258 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = Declspec(SPEC_void);
    }
#line 4860 "parser.c" /* yacc.c:1646  */
    break;

  case 116:
#line 1262 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = Declspec(SPEC_char);
    }
#line 4868 "parser.c" /* yacc.c:1646  */
    break;

  case 117:
#line 1266 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = Declspec(SPEC_short);
    }
#line 4876 "parser.c" /* yacc.c:1646  */
    break;

  case 118:
#line 1270 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = Declspec(SPEC_int);
    }
#line 4884 "parser.c" /* yacc.c:1646  */
    break;

  case 119:
#line 1274 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = Declspec(SPEC_long);
    }
#line 4892 "parser.c" /* yacc.c:1646  */
    break;

  case 120:
#line 1278 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = Declspec(SPEC_float);
    }
#line 4900 "parser.c" /* yacc.c:1646  */
    break;

  case 121:
#line 1282 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = Declspec(SPEC_double);
    }
#line 4908 "parser.c" /* yacc.c:1646  */
    break;

  case 122:
#line 1286 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = Declspec(SPEC_signed);
    }
#line 4916 "parser.c" /* yacc.c:1646  */
    break;

  case 123:
#line 1290 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = Declspec(SPEC_unsigned);
    }
#line 4924 "parser.c" /* yacc.c:1646  */
    break;

  case 124:
#line 1294 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = Declspec(SPEC_ubool);
    }
#line 4932 "parser.c" /* yacc.c:1646  */
    break;

  case 125:
#line 1298 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = Declspec(SPEC_ucomplex);
    }
#line 4940 "parser.c" /* yacc.c:1646  */
    break;

  case 126:
#line 1302 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = Declspec(SPEC_uimaginary);
    }
#line 4948 "parser.c" /* yacc.c:1646  */
    break;

  case 127:
#line 1306 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = (yyvsp[0].spec);
    }
#line 4956 "parser.c" /* yacc.c:1646  */
    break;

  case 128:
#line 1310 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = (yyvsp[0].spec);
    }
#line 4964 "parser.c" /* yacc.c:1646  */
    break;

  case 129:
#line 1314 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = Usertype((yyvsp[0].symb));
    }
#line 4972 "parser.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1323 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = SUdecl((yyvsp[-4].type), NULL, (yyvsp[-1].decl), (yyvsp[-3].spec));
    }
#line 4980 "parser.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1327 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = SUdecl((yyvsp[-3].type), NULL, NULL, (yyvsp[-2].spec));
    }
#line 4988 "parser.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1331 "parser.y" /* yacc.c:1646  */
    {
      symbol s = Symbol((yyvsp[-3].name));
      /* Well, struct & union names have their own name space, and
       * their own scopes. I.e. they can be re-declare in nested
       * scopes. We don't do any kind of duplicate checks.
       */
      if (checkDecls)
        symtab_put(stab, s, SUNAME);
      (yyval.spec) = SUdecl((yyvsp[-5].type), s, (yyvsp[-1].decl), (yyvsp[-4].spec));
    }
#line 5003 "parser.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1346 "parser.y" /* yacc.c:1646  */
    {
      symbol s = (yyvsp[-3].symb);
      if (checkDecls)
        symtab_put(stab, s, SUNAME);
      (yyval.spec) = SUdecl((yyvsp[-5].type), s, (yyvsp[-1].decl), (yyvsp[-4].spec));
    }
#line 5014 "parser.c" /* yacc.c:1646  */
    break;

  case 134:
#line 1353 "parser.y" /* yacc.c:1646  */
    {
      symbol s = Symbol((yyvsp[0].name));
      if (checkDecls)
        symtab_put(stab, s, SUNAME);
      (yyval.spec) = SUdecl((yyvsp[-2].type), s, NULL, (yyvsp[-1].spec));
    }
#line 5025 "parser.c" /* yacc.c:1646  */
    break;

  case 135:
#line 1360 "parser.y" /* yacc.c:1646  */
    {
      symbol s = (yyvsp[0].symb);
      if (checkDecls)
        symtab_put(stab, s, SUNAME);
      (yyval.spec) = SUdecl((yyvsp[-2].type), s, NULL, (yyvsp[-1].spec));
    }
#line 5036 "parser.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1371 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = SPEC_struct;
    }
#line 5044 "parser.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1375 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = SPEC_union;
    }
#line 5052 "parser.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1383 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = (yyvsp[0].decl);
    }
#line 5060 "parser.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1387 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = StructfieldList((yyvsp[-1].decl), (yyvsp[0].decl));
    }
#line 5068 "parser.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1395 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = StructfieldDecl((yyvsp[-2].spec), (yyvsp[-1].decl));
    }
#line 5076 "parser.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1399 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = StructfieldDecl((yyvsp[-1].spec), NULL);
    }
#line 5084 "parser.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1407 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = (yyvsp[0].spec);
    }
#line 5092 "parser.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1411 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = Speclist_right((yyvsp[-1].spec), (yyvsp[0].spec));
    }
#line 5100 "parser.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1415 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = (yyvsp[0].spec);
    }
#line 5108 "parser.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1419 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = Speclist_right((yyvsp[-1].spec), (yyvsp[0].spec));
    }
#line 5116 "parser.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1427 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = (yyvsp[0].decl);
    }
#line 5124 "parser.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1431 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = DeclList((yyvsp[-2].decl), (yyvsp[0].decl));
    }
#line 5132 "parser.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1439 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = (yyvsp[0].decl);
    }
#line 5140 "parser.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1443 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = BitDecl((yyvsp[-2].decl), (yyvsp[0].expr));
    }
#line 5148 "parser.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1447 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = BitDecl(NULL, (yyvsp[0].expr));
    }
#line 5156 "parser.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1455 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = Enumdecl(NULL, (yyvsp[-1].spec), (yyvsp[-3].spec));
    }
#line 5164 "parser.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1459 "parser.y" /* yacc.c:1646  */
    {
      symbol s = Symbol((yyvsp[-3].name));

      if (checkDecls)
      {
        if (symtab_get(stab, s, ENUMNAME))
          parse_error(-1, "enum name '%s' is already in use.", (yyvsp[-3].name));
        symtab_put(stab, s, ENUMNAME);
      }
      (yyval.spec) = Enumdecl(s, (yyvsp[-1].spec), (yyvsp[-4].spec));
    }
#line 5180 "parser.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1472 "parser.y" /* yacc.c:1646  */
    {
      symbol s = (yyvsp[-3].symb);

      if (checkDecls)
      {
        if (symtab_get(stab, s, ENUMNAME))
          parse_error(-1, "enum name '%s' is already in use.", s->name);
        symtab_put(stab, s, ENUMNAME);
      }
      (yyval.spec) = Enumdecl(s, (yyvsp[-1].spec), (yyvsp[-4].spec));
    }
#line 5196 "parser.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1484 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = Enumdecl(NULL, (yyvsp[-2].spec), (yyvsp[-4].spec));
    }
#line 5204 "parser.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1488 "parser.y" /* yacc.c:1646  */
    {
      symbol s = Symbol((yyvsp[-4].name));

      if (checkDecls)
      {
        if (symtab_get(stab, s, ENUMNAME))
          parse_error(-1, "enum name '%s' is already in use.", (yyvsp[-4].name));
        symtab_put(stab, s, ENUMNAME);
      }
      (yyval.spec) = Enumdecl(s, (yyvsp[-2].spec), (yyvsp[-5].spec));
    }
#line 5220 "parser.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1500 "parser.y" /* yacc.c:1646  */
    {
      symbol s = (yyvsp[-4].symb);

      if (checkDecls)
      {
        if (symtab_get(stab, s, ENUMNAME))
          parse_error(-1, "enum name '%s' is already in use.", s->name);
        symtab_put(stab, s, ENUMNAME);
      }
      (yyval.spec) = Enumdecl(s, (yyvsp[-2].spec), (yyvsp[-5].spec));
    }
#line 5236 "parser.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1512 "parser.y" /* yacc.c:1646  */
    {
      /*
      if (symtab_get(stab, s, ENUMNAME))
        parse_error(-1, "enum name '%s' is unknown.", $2);
      */
      (yyval.spec) = Enumdecl(Symbol((yyvsp[0].name)), NULL, (yyvsp[-1].spec));
    }
#line 5248 "parser.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1520 "parser.y" /* yacc.c:1646  */
    {
      /*
      if (symtab_get(stab, s, ENUMNAME))
        parse_error(-1, "enum name '%s' is unknown.", $2);
      */
      (yyval.spec) = Enumdecl((yyvsp[0].symb), NULL, (yyvsp[-1].spec));
    }
#line 5260 "parser.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1532 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = (yyvsp[0].spec);
    }
#line 5268 "parser.c" /* yacc.c:1646  */
    break;

  case 160:
#line 1536 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = Enumbodylist((yyvsp[-2].spec), (yyvsp[0].spec));
    }
#line 5276 "parser.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1544 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = Enumerator((yyvsp[0].symb), NULL);
    }
#line 5284 "parser.c" /* yacc.c:1646  */
    break;

  case 162:
#line 1548 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = Enumerator((yyvsp[-2].symb), (yyvsp[0].expr));
    }
#line 5292 "parser.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1556 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = Declspec(SPEC_const);
    }
#line 5300 "parser.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1560 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = Declspec(SPEC_restrict);
    }
#line 5308 "parser.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1564 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = Declspec(SPEC_volatile);
    }
#line 5316 "parser.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1568 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = (yyvsp[0].spec);
    }
#line 5324 "parser.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1576 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = Declspec(SPEC_inline);
    }
#line 5332 "parser.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1584 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = Declarator(NULL, (yyvsp[0].decl));
    }
#line 5340 "parser.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1588 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = Declarator((yyvsp[-1].spec), (yyvsp[0].decl));
    }
#line 5348 "parser.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1601 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = IdentifierDecl( Symbol((yyvsp[0].name)) );
    }
#line 5356 "parser.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1605 "parser.y" /* yacc.c:1646  */
    {
      /* Try to simplify a bit: (ident) -> ident */
      if ((yyvsp[-1].decl)->spec == NULL && (yyvsp[-1].decl)->decl->type == DIDENT)
        (yyval.decl) = (yyvsp[-1].decl)->decl;
      else
        (yyval.decl) = ParenDecl((yyvsp[-1].decl));
    }
#line 5368 "parser.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1613 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = ArrayDecl((yyvsp[-2].decl), NULL, NULL);
    }
#line 5376 "parser.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1617 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = ArrayDecl((yyvsp[-3].decl), (yyvsp[-1].spec), NULL);
    }
#line 5384 "parser.c" /* yacc.c:1646  */
    break;

  case 174:
#line 1621 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = ArrayDecl((yyvsp[-3].decl), NULL, (yyvsp[-1].expr));
    }
#line 5392 "parser.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1625 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = ArrayDecl((yyvsp[-4].decl), (yyvsp[-2].spec), (yyvsp[-1].expr));
    }
#line 5400 "parser.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1629 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = ArrayDecl((yyvsp[-4].decl), StClassSpec(SPEC_static), (yyvsp[-1].expr));
    }
#line 5408 "parser.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1633 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = ArrayDecl((yyvsp[-5].decl), Speclist_right( StClassSpec(SPEC_static), (yyvsp[-2].spec) ), (yyvsp[-1].expr));
    }
#line 5416 "parser.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1637 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = ArrayDecl((yyvsp[-5].decl), Speclist_left( (yyvsp[-3].spec), StClassSpec(SPEC_static) ), (yyvsp[-1].expr));
    }
#line 5424 "parser.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1641 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = ArrayDecl((yyvsp[-3].decl), Declspec(SPEC_star), NULL);
    }
#line 5432 "parser.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1645 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = ArrayDecl((yyvsp[-4].decl), Speclist_left( (yyvsp[-2].spec), Declspec(SPEC_star) ), NULL);
    }
#line 5440 "parser.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1649 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = FuncDecl((yyvsp[-3].decl), (yyvsp[-1].decl));
    }
#line 5448 "parser.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1653 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = FuncDecl((yyvsp[-2].decl), NULL);
    }
#line 5456 "parser.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1657 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = FuncDecl((yyvsp[-3].decl), (yyvsp[-1].decl));
    }
#line 5464 "parser.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1665 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = Pointer();
    }
#line 5472 "parser.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1669 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = Speclist_right(Pointer(), (yyvsp[0].spec));
    }
#line 5480 "parser.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1673 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = Speclist_right(Pointer(), (yyvsp[0].spec));
    }
#line 5488 "parser.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1677 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = Speclist_right( Pointer(), Speclist_left((yyvsp[-1].spec), (yyvsp[0].spec)) );
    }
#line 5496 "parser.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1685 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = (yyvsp[0].spec);
    }
#line 5504 "parser.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1689 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = Speclist_left((yyvsp[-1].spec), (yyvsp[0].spec));
    }
#line 5512 "parser.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1697 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = (yyvsp[0].decl);
    }
#line 5520 "parser.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1701 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = ParamList((yyvsp[-2].decl), Ellipsis());
    }
#line 5528 "parser.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1709 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = (yyvsp[0].decl);
    }
#line 5536 "parser.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1713 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = ParamList((yyvsp[-2].decl), (yyvsp[0].decl));
    }
#line 5544 "parser.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1721 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = ParamDecl((yyvsp[-1].spec), (yyvsp[0].decl));
    }
#line 5552 "parser.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1725 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = ParamDecl((yyvsp[0].spec), NULL);
    }
#line 5560 "parser.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1729 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = ParamDecl((yyvsp[-1].spec), (yyvsp[0].decl));
    }
#line 5568 "parser.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1737 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = IdentifierDecl( Symbol((yyvsp[0].name)) );
    }
#line 5576 "parser.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1741 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = IdList((yyvsp[-2].decl), IdentifierDecl( Symbol((yyvsp[0].name)) ));
    }
#line 5584 "parser.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1749 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = Casttypename((yyvsp[0].spec), NULL);
    }
#line 5592 "parser.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1753 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = Casttypename((yyvsp[-1].spec), (yyvsp[0].decl));
    }
#line 5600 "parser.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1761 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = AbstractDeclarator((yyvsp[0].spec), NULL);
    }
#line 5608 "parser.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1765 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = AbstractDeclarator(NULL, (yyvsp[0].decl));
    }
#line 5616 "parser.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1769 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = AbstractDeclarator((yyvsp[-1].spec), (yyvsp[0].decl));
    }
#line 5624 "parser.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1777 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = ParenDecl((yyvsp[-1].decl));
    }
#line 5632 "parser.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1781 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = ArrayDecl(NULL, NULL, NULL);
    }
#line 5640 "parser.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1785 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = ArrayDecl((yyvsp[-2].decl), NULL, NULL);
    }
#line 5648 "parser.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1789 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = ArrayDecl(NULL, NULL, (yyvsp[-1].expr));
    }
#line 5656 "parser.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1793 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = ArrayDecl((yyvsp[-3].decl), NULL, (yyvsp[-1].expr));
    }
#line 5664 "parser.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1797 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = ArrayDecl(NULL, Declspec(SPEC_star), NULL);
    }
#line 5672 "parser.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1801 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = ArrayDecl((yyvsp[-3].decl), Declspec(SPEC_star), NULL);
    }
#line 5680 "parser.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1805 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = FuncDecl(NULL, NULL);
    }
#line 5688 "parser.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1809 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = FuncDecl((yyvsp[-2].decl), NULL);
    }
#line 5696 "parser.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1813 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = FuncDecl(NULL, (yyvsp[-1].decl));
    }
#line 5704 "parser.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1817 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = FuncDecl((yyvsp[-3].decl), (yyvsp[-1].decl));
    }
#line 5712 "parser.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1825 "parser.y" /* yacc.c:1646  */
    {
      (yyval.symb) = Symbol((yyvsp[0].name));
    }
#line 5720 "parser.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1833 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = (yyvsp[0].expr);
    }
#line 5728 "parser.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1837 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = BracedInitializer((yyvsp[-1].expr));
    }
#line 5736 "parser.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1841 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = BracedInitializer((yyvsp[-2].expr));
    }
#line 5744 "parser.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1849 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = (yyvsp[0].expr);
    }
#line 5752 "parser.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1853 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = Designated((yyvsp[-1].expr), (yyvsp[0].expr));
    }
#line 5760 "parser.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1857 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = CommaList((yyvsp[-2].expr), (yyvsp[0].expr));
    }
#line 5768 "parser.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1861 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = CommaList((yyvsp[-3].expr), Designated((yyvsp[-1].expr), (yyvsp[0].expr)));
    }
#line 5776 "parser.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1869 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = (yyvsp[-1].expr);
    }
#line 5784 "parser.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1877 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = (yyvsp[0].expr);
    }
#line 5792 "parser.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1881 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = SpaceList((yyvsp[-1].expr), (yyvsp[0].expr));
    }
#line 5800 "parser.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1889 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = IdxDesignator((yyvsp[-1].expr));
    }
#line 5808 "parser.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1893 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = DotDesignator( Symbol((yyvsp[0].name)) );
    }
#line 5816 "parser.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1897 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = DotDesignator((yyvsp[0].symb));
    }
#line 5824 "parser.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1911 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = (yyvsp[0].stmt);
    }
#line 5832 "parser.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1915 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = (yyvsp[0].stmt);
    }
#line 5840 "parser.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1919 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = (yyvsp[0].stmt);
    }
#line 5848 "parser.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1923 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = (yyvsp[0].stmt);
    }
#line 5856 "parser.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1927 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = (yyvsp[0].stmt);
    }
#line 5864 "parser.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1931 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = (yyvsp[0].stmt);
    }
#line 5872 "parser.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1935 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = (yyvsp[0].stmt);
    }
#line 5880 "parser.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1939 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = OmpStmt((yyvsp[0].ocon));
      (yyval.stmt)->l = (yyvsp[0].ocon)->l;
    }
#line 5889 "parser.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1944 "parser.y" /* yacc.c:1646  */
    {
      #ifdef OMPI_OMP_EXT
        (yyval.stmt) = OmpixStmt((yyvsp[0].xcon));
        (yyval.stmt)->l = (yyvsp[0].xcon)->l;
      #else
        if ((yyvsp[0].xcon)->type==OX_DCTAG){
          parse_warning("tag construct ignored;"
                "activate it by configuring OMPi with --enable-ext\n");
          (yyval.stmt) = (yyvsp[0].xcon)->body;
        } else {
          (yyval.stmt) = OmpixStmt((yyvsp[0].xcon));
          (yyval.stmt)->l = (yyvsp[0].xcon)->l;
        }
      #endif
    }
#line 5909 "parser.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1960 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = Verbatim(strdup((yyvsp[0].name)));
    }
#line 5917 "parser.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1968 "parser.y" /* yacc.c:1646  */
    { 
      (yyval.stmt) = (yyvsp[0].stmt); 
    }
#line 5925 "parser.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1972 "parser.y" /* yacc.c:1646  */
    {       
      (yyval.stmt) = OmpStmt((yyvsp[0].ocon));
      (yyval.stmt)->l = (yyvsp[0].ocon)->l;
    }
#line 5934 "parser.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1982 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = Labeled( Symbol((yyvsp[-3].name)), (yyvsp[0].stmt) );
    }
#line 5942 "parser.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1986 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = Case((yyvsp[-2].expr), (yyvsp[0].stmt));
    }
#line 5950 "parser.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1990 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = Default((yyvsp[0].stmt));
    }
#line 5958 "parser.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1998 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = Compound(NULL);
    }
#line 5966 "parser.c" /* yacc.c:1646  */
    break;

  case 245:
#line 2001 "parser.y" /* yacc.c:1646  */
    { (yyval.type) = sc_original_line()-1; scope_start(stab); }
#line 5972 "parser.c" /* yacc.c:1646  */
    break;

  case 246:
#line 2003 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = Compound((yyvsp[-1].stmt));
      scope_end(stab);
      (yyval.stmt)->l = (yyvsp[-2].type);     /* Remember 1st line */
    }
#line 5982 "parser.c" /* yacc.c:1646  */
    break;

  case 247:
#line 2013 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = (yyvsp[0].stmt);
    }
#line 5990 "parser.c" /* yacc.c:1646  */
    break;

  case 248:
#line 2017 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = BlockList((yyvsp[-1].stmt), (yyvsp[0].stmt));
      (yyval.stmt)->l = (yyvsp[-1].stmt)->l;
    }
#line 5999 "parser.c" /* yacc.c:1646  */
    break;

  case 249:
#line 2026 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = (yyvsp[0].stmt);
    }
#line 6007 "parser.c" /* yacc.c:1646  */
    break;

  case 250:
#line 2030 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = (yyvsp[0].stmt);
    }
#line 6015 "parser.c" /* yacc.c:1646  */
    break;

  case 251:
#line 2034 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = OmpStmt((yyvsp[0].ocon));
      (yyval.stmt)->l = (yyvsp[0].ocon)->l;
    }
#line 6024 "parser.c" /* yacc.c:1646  */
    break;

  case 252:
#line 2039 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = OmpixStmt((yyvsp[0].xcon));
      (yyval.stmt)->l = (yyvsp[0].xcon)->l;
    }
#line 6033 "parser.c" /* yacc.c:1646  */
    break;

  case 253:
#line 2048 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = Expression(NULL);
    }
#line 6041 "parser.c" /* yacc.c:1646  */
    break;

  case 254:
#line 2052 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = Expression((yyvsp[-1].expr));
      (yyval.stmt)->l = (yyvsp[-1].expr)->l;
    }
#line 6050 "parser.c" /* yacc.c:1646  */
    break;

  case 255:
#line 2061 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = If((yyvsp[-2].expr), (yyvsp[0].stmt), NULL);
    }
#line 6058 "parser.c" /* yacc.c:1646  */
    break;

  case 256:
#line 2065 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = If((yyvsp[-4].expr), (yyvsp[-2].stmt), (yyvsp[0].stmt));
    }
#line 6066 "parser.c" /* yacc.c:1646  */
    break;

  case 257:
#line 2069 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = Switch((yyvsp[-2].expr), (yyvsp[0].stmt));
    }
#line 6074 "parser.c" /* yacc.c:1646  */
    break;

  case 258:
#line 2078 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = While((yyvsp[-2].expr), (yyvsp[0].stmt));
    }
#line 6082 "parser.c" /* yacc.c:1646  */
    break;

  case 259:
#line 2082 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = Do((yyvsp[-5].stmt), (yyvsp[-2].expr));
    }
#line 6090 "parser.c" /* yacc.c:1646  */
    break;

  case 261:
#line 2090 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = For(NULL, NULL, NULL, (yyvsp[0].stmt));
    }
#line 6098 "parser.c" /* yacc.c:1646  */
    break;

  case 262:
#line 2094 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = For(Expression((yyvsp[-4].expr)), NULL, NULL, (yyvsp[0].stmt));
    }
#line 6106 "parser.c" /* yacc.c:1646  */
    break;

  case 263:
#line 2098 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = For(NULL, (yyvsp[-3].expr), NULL, (yyvsp[0].stmt));
    }
#line 6114 "parser.c" /* yacc.c:1646  */
    break;

  case 264:
#line 2102 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = For(NULL, NULL, (yyvsp[-2].expr), (yyvsp[0].stmt));
    }
#line 6122 "parser.c" /* yacc.c:1646  */
    break;

  case 265:
#line 2106 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = For(Expression((yyvsp[-5].expr)), (yyvsp[-3].expr), NULL, (yyvsp[0].stmt));
    }
#line 6130 "parser.c" /* yacc.c:1646  */
    break;

  case 266:
#line 2110 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = For(Expression((yyvsp[-5].expr)), NULL, (yyvsp[-2].expr), (yyvsp[0].stmt));
    }
#line 6138 "parser.c" /* yacc.c:1646  */
    break;

  case 267:
#line 2114 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = For(NULL, (yyvsp[-4].expr), (yyvsp[-2].expr), (yyvsp[0].stmt));
    }
#line 6146 "parser.c" /* yacc.c:1646  */
    break;

  case 268:
#line 2118 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = For(Expression((yyvsp[-6].expr)), (yyvsp[-4].expr), (yyvsp[-2].expr), (yyvsp[0].stmt));
    }
#line 6154 "parser.c" /* yacc.c:1646  */
    break;

  case 269:
#line 2122 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = For((yyvsp[-3].stmt), NULL, NULL, (yyvsp[0].stmt));
    }
#line 6162 "parser.c" /* yacc.c:1646  */
    break;

  case 270:
#line 2126 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = For((yyvsp[-4].stmt), (yyvsp[-3].expr), NULL, (yyvsp[0].stmt));
    }
#line 6170 "parser.c" /* yacc.c:1646  */
    break;

  case 271:
#line 2130 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = For((yyvsp[-4].stmt), NULL, (yyvsp[-2].expr), (yyvsp[0].stmt));
    }
#line 6178 "parser.c" /* yacc.c:1646  */
    break;

  case 272:
#line 2134 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = For((yyvsp[-5].stmt), (yyvsp[-4].expr), (yyvsp[-2].expr), (yyvsp[0].stmt));
    }
#line 6186 "parser.c" /* yacc.c:1646  */
    break;

  case 273:
#line 2142 "parser.y" /* yacc.c:1646  */
    {
      /* We don't keep track of labels -- we leave it to the native compiler */
      (yyval.stmt) = Goto( Symbol((yyvsp[-1].name)) );
    }
#line 6195 "parser.c" /* yacc.c:1646  */
    break;

  case 274:
#line 2147 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = Continue();
    }
#line 6203 "parser.c" /* yacc.c:1646  */
    break;

  case 275:
#line 2151 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = Break();
    }
#line 6211 "parser.c" /* yacc.c:1646  */
    break;

  case 276:
#line 2155 "parser.y" /* yacc.c:1646  */
    {
      //TODO: simple hack, not 100% correct, does not cover goto
      if (errorOnReturn)
        parse_error(1, "return statement not allowed in an outlined region\n");
      (yyval.stmt) = Return(NULL);
    }
#line 6222 "parser.c" /* yacc.c:1646  */
    break;

  case 277:
#line 2162 "parser.y" /* yacc.c:1646  */
    {
      //TODO: simple hack, not 100% correct, does not cover goto
      if (errorOnReturn)
        parse_error(1, "return statement not allowed in an outlined region\n");
      (yyval.stmt) = Return((yyvsp[-1].expr));
    }
#line 6233 "parser.c" /* yacc.c:1646  */
    break;

  case 278:
#line 2179 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = pastree = (yyvsp[0].stmt);
    }
#line 6241 "parser.c" /* yacc.c:1646  */
    break;

  case 279:
#line 2183 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = pastree = BlockList((yyvsp[-1].stmt), (yyvsp[0].stmt));
    }
#line 6249 "parser.c" /* yacc.c:1646  */
    break;

  case 280:
#line 2191 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = (yyvsp[0].stmt);
    }
#line 6257 "parser.c" /* yacc.c:1646  */
    break;

  case 281:
#line 2195 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = (yyvsp[0].stmt);
    }
#line 6265 "parser.c" /* yacc.c:1646  */
    break;

  case 282:
#line 2202 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = OmpixStmt((yyvsp[0].xcon));
    }
#line 6273 "parser.c" /* yacc.c:1646  */
    break;

  case 283:
#line 2206 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = OmpixStmt((yyvsp[0].xcon));
    }
#line 6281 "parser.c" /* yacc.c:1646  */
    break;

  case 284:
#line 2210 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = Verbatim(strdup((yyvsp[0].name)));
    }
#line 6289 "parser.c" /* yacc.c:1646  */
    break;

  case 285:
#line 2221 "parser.y" /* yacc.c:1646  */
    { (yyval.stmt) = (yyvsp[0].stmt); }
#line 6295 "parser.c" /* yacc.c:1646  */
    break;

  case 286:
#line 2222 "parser.y" /* yacc.c:1646  */
    { (yyval.stmt) = (yyvsp[0].stmt); }
#line 6301 "parser.c" /* yacc.c:1646  */
    break;

  case 287:
#line 2227 "parser.y" /* yacc.c:1646  */
    {
      stentry f;
      
      if (isTypedef || (yyvsp[0].decl)->decl->type != DFUNC)
        parse_error(1, "function definition cannot be parsed.\n");
      f = symtab_get(stab, decl_getidentifier_symbol((yyvsp[0].decl)), FUNCNAME);
      if (f && f->funcdef)
        parse_error(1, "function %s is multiply defined.\n", f->key->name);
      if (f == NULL)
      {
        f = symtab_put(stab, decl_getidentifier_symbol((yyvsp[0].decl)), FUNCNAME);
        f->spec = (yyvsp[-1].spec);
        f->decl = (yyvsp[0].decl);
      }

      scope_start(stab);
      ast_declare_function_params((yyvsp[0].decl));
    }
#line 6324 "parser.c" /* yacc.c:1646  */
    break;

  case 288:
#line 2246 "parser.y" /* yacc.c:1646  */
    {
      scope_end(stab);
      check_for_main_and_declare((yyvsp[-3].spec), (yyvsp[-2].decl));
      (yyval.stmt) = FuncDef((yyvsp[-3].spec), (yyvsp[-2].decl), NULL, (yyvsp[0].stmt));
      symtab_get(stab, decl_getidentifier_symbol((yyvsp[-2].decl)), FUNCNAME)->funcdef = (yyval.stmt);
    }
#line 6335 "parser.c" /* yacc.c:1646  */
    break;

  case 289:
#line 2253 "parser.y" /* yacc.c:1646  */
    {
      stentry f;
      
      if (isTypedef || (yyvsp[0].decl)->decl->type != DFUNC)
        parse_error(1, "function definition cannot be parsed.\n");
      f = symtab_get(stab, decl_getidentifier_symbol((yyvsp[0].decl)), FUNCNAME);
      if (f && f->funcdef)
        parse_error(1, "function %s is multiply defined.\n", f->key->name);
      if (f == NULL)
      {
        f = symtab_put(stab, decl_getidentifier_symbol((yyvsp[0].decl)), FUNCNAME);
        f->spec = NULL;
        f->decl = (yyvsp[0].decl);
      }

      scope_start(stab);
      ast_declare_function_params((yyvsp[0].decl));
    }
#line 6358 "parser.c" /* yacc.c:1646  */
    break;

  case 290:
#line 2272 "parser.y" /* yacc.c:1646  */
    {
      astspec s = Declspec(SPEC_int);  /* return type defaults to "int" */
      stentry f;
      
      scope_end(stab);
      check_for_main_and_declare(s, (yyvsp[-2].decl));
      (yyval.stmt) = FuncDef(s, (yyvsp[-2].decl), NULL, (yyvsp[0].stmt));
      
      f = symtab_get(stab, decl_getidentifier_symbol((yyvsp[-2].decl)), FUNCNAME);
      if (!f->spec) f->spec = s;
      f->funcdef = (yyval.stmt);
    }
#line 6375 "parser.c" /* yacc.c:1646  */
    break;

  case 291:
#line 2288 "parser.y" /* yacc.c:1646  */
    {
      stentry f;
      
      if (isTypedef || (yyvsp[0].decl)->decl->type != DFUNC)
        parse_error(1, "function definition cannot be parsed.\n");
      f = symtab_get(stab, decl_getidentifier_symbol((yyvsp[0].decl)), FUNCNAME);
      if (f && f->funcdef)
        parse_error(1, "function %s is multiply defined.\n", f->key->name);
      if (f == NULL)
      {
        f = symtab_put(stab, decl_getidentifier_symbol((yyvsp[0].decl)), FUNCNAME);
        f->spec = (yyvsp[-1].spec);
        f->decl = (yyvsp[0].decl);
      }

      scope_start(stab);
      /* Notice here that the function parameters are declared through
       * the declaration_list and we need to do nothing else!
       */
    }
#line 6400 "parser.c" /* yacc.c:1646  */
    break;

  case 292:
#line 2309 "parser.y" /* yacc.c:1646  */
    {
      scope_end(stab);
      check_for_main_and_declare((yyvsp[-4].spec), (yyvsp[-3].decl));
      (yyval.stmt) = FuncDef((yyvsp[-4].spec), (yyvsp[-3].decl), (yyvsp[-1].stmt), (yyvsp[0].stmt));
      symtab_get(stab, decl_getidentifier_symbol((yyvsp[-3].decl)), FUNCNAME)->funcdef = (yyval.stmt);
    }
#line 6411 "parser.c" /* yacc.c:1646  */
    break;

  case 293:
#line 2316 "parser.y" /* yacc.c:1646  */
    {
      stentry f;
      
      if (isTypedef || (yyvsp[0].decl)->decl->type != DFUNC)
        parse_error(1, "function definition cannot be parsed.\n");
      f = symtab_get(stab, decl_getidentifier_symbol((yyvsp[0].decl)), FUNCNAME);
      if (f && f->funcdef)
        parse_error(1, "function %s is multiply defined.\n", f->key->name);
      if (f == NULL)
      {
        f = symtab_put(stab, decl_getidentifier_symbol((yyvsp[0].decl)), FUNCNAME);
        f->spec = NULL;
        f->decl = (yyvsp[0].decl);
      }

      scope_start(stab);
      /* Notice here that the function parameters are declared through
       * the declaration_list and we need to do nothing else!
       */
    }
#line 6436 "parser.c" /* yacc.c:1646  */
    break;

  case 294:
#line 2337 "parser.y" /* yacc.c:1646  */
    {
      astspec s = Declspec(SPEC_int);  /* return type defaults to "int" */
      stentry f;

      scope_end(stab);
      check_for_main_and_declare(s, (yyvsp[-3].decl));
      (yyval.stmt) = FuncDef(s, (yyvsp[-3].decl), (yyvsp[-1].stmt), (yyvsp[0].stmt));
      
      f = symtab_get(stab, decl_getidentifier_symbol((yyvsp[-3].decl)), FUNCNAME);
      if (!f->spec) f->spec = s;
      f->funcdef = (yyval.stmt);
    }
#line 6453 "parser.c" /* yacc.c:1646  */
    break;

  case 295:
#line 2354 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = (yyvsp[0].stmt);
    }
#line 6461 "parser.c" /* yacc.c:1646  */
    break;

  case 296:
#line 2358 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = BlockList((yyvsp[-1].stmt), (yyvsp[0].stmt));         /* Same as block list */
    }
#line 6469 "parser.c" /* yacc.c:1646  */
    break;

  case 297:
#line 2378 "parser.y" /* yacc.c:1646  */
    {
      ((yyval.stmt) = (yyvsp[0].stmt))->u.assem->qualifiers = NULL;
    }
#line 6477 "parser.c" /* yacc.c:1646  */
    break;

  case 298:
#line 2382 "parser.y" /* yacc.c:1646  */
    {
      ((yyval.stmt) = (yyvsp[0].stmt))->u.assem->qualifiers = (yyvsp[-1].spec);
    }
#line 6485 "parser.c" /* yacc.c:1646  */
    break;

  case 299:
#line 2389 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = BasicAsm(NULL, (yyvsp[-1].string));
    }
#line 6493 "parser.c" /* yacc.c:1646  */
    break;

  case 300:
#line 2393 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = XtendAsm(NULL, (yyvsp[-3].string), (yyvsp[-1].asmo), NULL, NULL);
    }
#line 6501 "parser.c" /* yacc.c:1646  */
    break;

  case 301:
#line 2397 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = XtendAsm(NULL, (yyvsp[-5].string), (yyvsp[-3].asmo), (yyvsp[-1].asmo), NULL);
    }
#line 6509 "parser.c" /* yacc.c:1646  */
    break;

  case 302:
#line 2401 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = XtendAsm(NULL, (yyvsp[-7].string), (yyvsp[-5].asmo), (yyvsp[-3].asmo), (yyvsp[-1].expr));
    }
#line 6517 "parser.c" /* yacc.c:1646  */
    break;

  case 303:
#line 2405 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = XtendAsmGoto((yyvsp[-8].string), (yyvsp[-5].asmo), (yyvsp[-3].expr), (yyvsp[-1].expr));
    }
#line 6525 "parser.c" /* yacc.c:1646  */
    break;

  case 304:
#line 2412 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = (yyvsp[0].spec);
    }
#line 6533 "parser.c" /* yacc.c:1646  */
    break;

  case 305:
#line 2416 "parser.y" /* yacc.c:1646  */
    {
      (yyval.spec) = Speclist_right((yyvsp[-1].spec), (yyvsp[0].spec));
    }
#line 6541 "parser.c" /* yacc.c:1646  */
    break;

  case 306:
#line 2422 "parser.y" /* yacc.c:1646  */
    { (yyval.spec) = Declspec(SPEC_volatile); }
#line 6547 "parser.c" /* yacc.c:1646  */
    break;

  case 307:
#line 2423 "parser.y" /* yacc.c:1646  */
    { (yyval.spec) = Declspec(SPEC_inline); }
#line 6553 "parser.c" /* yacc.c:1646  */
    break;

  case 308:
#line 2427 "parser.y" /* yacc.c:1646  */
    {
      (yyval.asmo) = NULL;
    }
#line 6561 "parser.c" /* yacc.c:1646  */
    break;

  case 309:
#line 2431 "parser.y" /* yacc.c:1646  */
    {
      (yyval.asmo) = (yyvsp[0].asmo);
    }
#line 6569 "parser.c" /* yacc.c:1646  */
    break;

  case 310:
#line 2435 "parser.y" /* yacc.c:1646  */
    {
      (yyval.asmo) = XAsmOpList((yyvsp[-2].asmo), (yyvsp[0].asmo));
    }
#line 6577 "parser.c" /* yacc.c:1646  */
    break;

  case 311:
#line 2442 "parser.y" /* yacc.c:1646  */
    {
      (yyval.asmo) = XAsmOperand(IdentName((yyvsp[-5].name)), (yyvsp[-3].string), (yyvsp[-1].expr));
    }
#line 6585 "parser.c" /* yacc.c:1646  */
    break;

  case 312:
#line 2446 "parser.y" /* yacc.c:1646  */
    {
      (yyval.asmo) = XAsmOperand(NULL, (yyvsp[-3].string), (yyvsp[-1].expr));
    }
#line 6593 "parser.c" /* yacc.c:1646  */
    break;

  case 313:
#line 2452 "parser.y" /* yacc.c:1646  */
    {
      (yyval.asmo) = NULL;
    }
#line 6601 "parser.c" /* yacc.c:1646  */
    break;

  case 314:
#line 2456 "parser.y" /* yacc.c:1646  */
    {
      (yyval.asmo) = (yyvsp[0].asmo);
    }
#line 6609 "parser.c" /* yacc.c:1646  */
    break;

  case 315:
#line 2460 "parser.y" /* yacc.c:1646  */
    {
      (yyval.asmo) = XAsmOpList((yyvsp[-2].asmo), (yyvsp[0].asmo));
    }
#line 6617 "parser.c" /* yacc.c:1646  */
    break;

  case 316:
#line 2467 "parser.y" /* yacc.c:1646  */
    {
      (yyval.asmo) = XAsmOperand(IdentName((yyvsp[-5].name)), (yyvsp[-3].string), (yyvsp[-1].expr));
    }
#line 6625 "parser.c" /* yacc.c:1646  */
    break;

  case 317:
#line 2471 "parser.y" /* yacc.c:1646  */
    {
      (yyval.asmo) = XAsmOperand(NULL, (yyvsp[-3].string), (yyvsp[-1].expr));
    }
#line 6633 "parser.c" /* yacc.c:1646  */
    break;

  case 318:
#line 2478 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = String((yyvsp[0].string));
    }
#line 6641 "parser.c" /* yacc.c:1646  */
    break;

  case 319:
#line 2482 "parser.y" /* yacc.c:1646  */
    {
       (yyval.expr) = CommaList((yyvsp[-2].expr), String((yyvsp[0].string)));
    }
#line 6649 "parser.c" /* yacc.c:1646  */
    break;

  case 320:
#line 2489 "parser.y" /* yacc.c:1646  */
    { 
      (yyval.expr) = IdentName((yyvsp[0].name));
    }
#line 6657 "parser.c" /* yacc.c:1646  */
    break;

  case 321:
#line 2493 "parser.y" /* yacc.c:1646  */
    {
       (yyval.expr) = CommaList((yyvsp[-2].expr), IdentName((yyvsp[0].name)));
    }
#line 6665 "parser.c" /* yacc.c:1646  */
    break;

  case 322:
#line 2505 "parser.y" /* yacc.c:1646  */
    {
			(yyval.spec) = NULL;
		}
#line 6673 "parser.c" /* yacc.c:1646  */
    break;

  case 323:
#line 2509 "parser.y" /* yacc.c:1646  */
    {
			(yyval.spec) = (yyvsp[0].spec);
		}
#line 6681 "parser.c" /* yacc.c:1646  */
    break;

  case 324:
#line 2516 "parser.y" /* yacc.c:1646  */
    {
			(yyval.spec) = (yyvsp[0].spec);
		}
#line 6689 "parser.c" /* yacc.c:1646  */
    break;

  case 325:
#line 2520 "parser.y" /* yacc.c:1646  */
    {
			(yyval.spec) = Speclist_left((yyvsp[-1].spec), (yyvsp[0].spec));
		}
#line 6697 "parser.c" /* yacc.c:1646  */
    break;

  case 326:
#line 2527 "parser.y" /* yacc.c:1646  */
    {
			(yyval.spec) = AttrSpec((yyvsp[-2].string));
		}
#line 6705 "parser.c" /* yacc.c:1646  */
    break;

  case 327:
#line 2534 "parser.y" /* yacc.c:1646  */
    {
			(yyval.string) = (yyvsp[0].string);
		}
#line 6713 "parser.c" /* yacc.c:1646  */
    break;

  case 328:
#line 2538 "parser.y" /* yacc.c:1646  */
    {
			if ((yyvsp[-2].string) == NULL && (yyvsp[0].string) == NULL)
				(yyval.string) = strdup(",");
			else
			  if ((yyvsp[-2].string) == NULL)
					(yyval.string) = strdupcat(strdup(", "), (yyvsp[0].string), 1);
				else
					if ((yyvsp[0].string) == NULL)
						(yyval.string) = strdupcat((yyvsp[-2].string), strdup(", "), 1);
					else
						(yyval.string) = strdupcat((yyvsp[-2].string), strdupcat(strdup(", "), (yyvsp[0].string), 1), 1);
		}
#line 6730 "parser.c" /* yacc.c:1646  */
    break;

  case 329:
#line 2554 "parser.y" /* yacc.c:1646  */
    {
			(yyval.string) = NULL;
		}
#line 6738 "parser.c" /* yacc.c:1646  */
    break;

  case 330:
#line 2558 "parser.y" /* yacc.c:1646  */
    {
			(yyval.string) = (yyvsp[0].string);
		}
#line 6746 "parser.c" /* yacc.c:1646  */
    break;

  case 331:
#line 2562 "parser.y" /* yacc.c:1646  */
    {
			static str xp = NULL;
			
			if (xp == NULL) xp = Strnew();
			str_printf(xp, "%s(", (yyvsp[-3].string));
			if ((yyvsp[-1].expr))
				ast_expr_print(xp, (yyvsp[-1].expr));
			str_printf(xp, ")");
		  (yyval.string) = strdup(str_string(xp));
		  str_truncate(xp);
		  free((yyvsp[-3].string));
		}
#line 6763 "parser.c" /* yacc.c:1646  */
    break;

  case 332:
#line 2577 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = strdup((yyvsp[0].name)); }
#line 6769 "parser.c" /* yacc.c:1646  */
    break;

  case 333:
#line 2578 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = strdup((yyvsp[0].name)); }
#line 6775 "parser.c" /* yacc.c:1646  */
    break;

  case 334:
#line 2579 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = strdup((yyvsp[0].name)); }
#line 6781 "parser.c" /* yacc.c:1646  */
    break;

  case 335:
#line 2599 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = (yyvsp[0].stmt);
    }
#line 6789 "parser.c" /* yacc.c:1646  */
    break;

  case 336:
#line 2603 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = (yyvsp[0].stmt);
    }
#line 6797 "parser.c" /* yacc.c:1646  */
    break;

  case 337:
#line 2611 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = (yyvsp[0].stmt);
    }
#line 6805 "parser.c" /* yacc.c:1646  */
    break;

  case 338:
#line 2620 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = (yyvsp[0].stmt);
    }
#line 6813 "parser.c" /* yacc.c:1646  */
    break;

  case 339:
#line 2624 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = pastree = BlockList((yyvsp[-1].stmt), (yyvsp[0].stmt));
    }
#line 6821 "parser.c" /* yacc.c:1646  */
    break;

  case 340:
#line 2631 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = (yyvsp[0].ocon);
    }
#line 6829 "parser.c" /* yacc.c:1646  */
    break;

  case 341:
#line 2635 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = (yyvsp[0].ocon);
    }
#line 6837 "parser.c" /* yacc.c:1646  */
    break;

  case 342:
#line 2639 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = (yyvsp[0].ocon);
    }
#line 6845 "parser.c" /* yacc.c:1646  */
    break;

  case 343:
#line 2643 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = (yyvsp[0].ocon);
    }
#line 6853 "parser.c" /* yacc.c:1646  */
    break;

  case 344:
#line 2647 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = (yyvsp[0].ocon);
    }
#line 6861 "parser.c" /* yacc.c:1646  */
    break;

  case 345:
#line 2651 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = (yyvsp[0].ocon);
    }
#line 6869 "parser.c" /* yacc.c:1646  */
    break;

  case 346:
#line 2655 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = (yyvsp[0].ocon);
    }
#line 6877 "parser.c" /* yacc.c:1646  */
    break;

  case 347:
#line 2659 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = (yyvsp[0].ocon);
    }
#line 6885 "parser.c" /* yacc.c:1646  */
    break;

  case 348:
#line 2663 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = (yyvsp[0].ocon);
    }
#line 6893 "parser.c" /* yacc.c:1646  */
    break;

  case 349:
#line 2667 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = (yyvsp[0].ocon);
    }
#line 6901 "parser.c" /* yacc.c:1646  */
    break;

  case 350:
#line 2672 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = (yyvsp[0].ocon);
    }
#line 6909 "parser.c" /* yacc.c:1646  */
    break;

  case 351:
#line 2677 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = (yyvsp[0].ocon);
    }
#line 6917 "parser.c" /* yacc.c:1646  */
    break;

  case 352:
#line 2681 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = (yyvsp[0].ocon);
    }
#line 6925 "parser.c" /* yacc.c:1646  */
    break;

  case 353:
#line 2685 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = (yyvsp[0].ocon);
    }
#line 6933 "parser.c" /* yacc.c:1646  */
    break;

  case 354:
#line 2689 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = (yyvsp[0].ocon);
    }
#line 6941 "parser.c" /* yacc.c:1646  */
    break;

  case 355:
#line 2693 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = (yyvsp[0].ocon);
    }
#line 6949 "parser.c" /* yacc.c:1646  */
    break;

  case 356:
#line 2697 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = (yyvsp[0].ocon);
    }
#line 6957 "parser.c" /* yacc.c:1646  */
    break;

  case 357:
#line 2701 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = (yyvsp[0].ocon);
    }
#line 6965 "parser.c" /* yacc.c:1646  */
    break;

  case 358:
#line 2705 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = (yyvsp[0].ocon);
    }
#line 6973 "parser.c" /* yacc.c:1646  */
    break;

  case 359:
#line 2709 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = (yyvsp[0].ocon);
    }
#line 6981 "parser.c" /* yacc.c:1646  */
    break;

  case 360:
#line 2713 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = (yyvsp[0].ocon);
    }
#line 6989 "parser.c" /* yacc.c:1646  */
    break;

  case 361:
#line 2717 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = (yyvsp[0].ocon);
    }
#line 6997 "parser.c" /* yacc.c:1646  */
    break;

  case 362:
#line 2721 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = (yyvsp[0].ocon);
    }
#line 7005 "parser.c" /* yacc.c:1646  */
    break;

  case 363:
#line 2725 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = (yyvsp[0].ocon);
    }
#line 7013 "parser.c" /* yacc.c:1646  */
    break;

  case 364:
#line 2729 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = (yyvsp[0].ocon);
    }
#line 7021 "parser.c" /* yacc.c:1646  */
    break;

  case 365:
#line 2733 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = (yyvsp[0].ocon);
    }
#line 7029 "parser.c" /* yacc.c:1646  */
    break;

  case 366:
#line 2737 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = (yyvsp[0].ocon);
    }
#line 7037 "parser.c" /* yacc.c:1646  */
    break;

  case 367:
#line 2741 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = (yyvsp[0].ocon);
    }
#line 7045 "parser.c" /* yacc.c:1646  */
    break;

  case 368:
#line 2745 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = (yyvsp[0].ocon);
    }
#line 7053 "parser.c" /* yacc.c:1646  */
    break;

  case 369:
#line 2749 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = (yyvsp[0].ocon);
    }
#line 7061 "parser.c" /* yacc.c:1646  */
    break;

  case 370:
#line 2753 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = (yyvsp[0].ocon);
    }
#line 7069 "parser.c" /* yacc.c:1646  */
    break;

  case 371:
#line 2757 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = (yyvsp[0].ocon);
    }
#line 7077 "parser.c" /* yacc.c:1646  */
    break;

  case 372:
#line 2762 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = (yyvsp[0].ocon);
    }
#line 7085 "parser.c" /* yacc.c:1646  */
    break;

  case 373:
#line 2767 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = (yyvsp[0].ocon);
    }
#line 7093 "parser.c" /* yacc.c:1646  */
    break;

  case 374:
#line 2784 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCBARRIER, (yyvsp[0].odir), NULL);
    }
#line 7101 "parser.c" /* yacc.c:1646  */
    break;

  case 375:
#line 2788 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCFLUSH, (yyvsp[0].odir), NULL);
    }
#line 7109 "parser.c" /* yacc.c:1646  */
    break;

  case 376:
#line 2793 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCTASKWAIT, (yyvsp[0].odir), NULL);
    }
#line 7117 "parser.c" /* yacc.c:1646  */
    break;

  case 377:
#line 2798 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCTASKYIELD, (yyvsp[0].odir), NULL);
    }
#line 7125 "parser.c" /* yacc.c:1646  */
    break;

  case 378:
#line 2803 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCCANCEL, (yyvsp[0].odir), NULL);
    }
#line 7133 "parser.c" /* yacc.c:1646  */
    break;

  case 379:
#line 2808 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCCANCELLATIONPOINT, (yyvsp[0].odir), NULL);
    }
#line 7141 "parser.c" /* yacc.c:1646  */
    break;

  case 380:
#line 2813 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCTARGETUPD, (yyvsp[0].odir), NULL);
    }
#line 7149 "parser.c" /* yacc.c:1646  */
    break;

  case 381:
#line 2818 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCTARGENTERDATA, (yyvsp[0].odir), NULL);
    }
#line 7157 "parser.c" /* yacc.c:1646  */
    break;

  case 382:
#line 2823 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCTARGEXITDATA, (yyvsp[0].odir), NULL);
    }
#line 7165 "parser.c" /* yacc.c:1646  */
    break;

  case 383:
#line 2830 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = (yyvsp[0].stmt);
    }
#line 7173 "parser.c" /* yacc.c:1646  */
    break;

  case 384:
#line 2837 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCPARALLEL, (yyvsp[-1].odir), (yyvsp[0].stmt));
      (yyval.ocon)->l = (yyvsp[-1].odir)->l;
    }
#line 7182 "parser.c" /* yacc.c:1646  */
    break;

  case 385:
#line 2845 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCPARALLEL, (yyvsp[-1].ocla));
    }
#line 7190 "parser.c" /* yacc.c:1646  */
    break;

  case 386:
#line 2852 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = NULL;
    }
#line 7198 "parser.c" /* yacc.c:1646  */
    break;

  case 387:
#line 2856 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
    }
#line 7206 "parser.c" /* yacc.c:1646  */
    break;

  case 388:
#line 2860 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
    }
#line 7214 "parser.c" /* yacc.c:1646  */
    break;

  case 389:
#line 2867 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 7222 "parser.c" /* yacc.c:1646  */
    break;

  case 390:
#line 2871 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 7230 "parser.c" /* yacc.c:1646  */
    break;

  case 391:
#line 2875 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 7238 "parser.c" /* yacc.c:1646  */
    break;

  case 392:
#line 2879 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 7246 "parser.c" /* yacc.c:1646  */
    break;

  case 393:
#line 2883 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 7254 "parser.c" /* yacc.c:1646  */
    break;

  case 394:
#line 2887 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 7262 "parser.c" /* yacc.c:1646  */
    break;

  case 395:
#line 2891 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 7270 "parser.c" /* yacc.c:1646  */
    break;

  case 396:
#line 2897 "parser.y" /* yacc.c:1646  */
    { sc_pause_openmp(); }
#line 7276 "parser.c" /* yacc.c:1646  */
    break;

  case 397:
#line 2898 "parser.y" /* yacc.c:1646  */
    {
      sc_start_openmp();
      (yyval.ocla) = NumthreadsClause((yyvsp[-1].expr));
    }
#line 7285 "parser.c" /* yacc.c:1646  */
    break;

  case 398:
#line 2902 "parser.y" /* yacc.c:1646  */
    { sc_pause_openmp(); }
#line 7291 "parser.c" /* yacc.c:1646  */
    break;

  case 399:
#line 2903 "parser.y" /* yacc.c:1646  */
    {
      sc_start_openmp();
      (yyval.ocla) = VarlistClause(OCCOPYIN, (yyvsp[-1].decl));
    }
#line 7300 "parser.c" /* yacc.c:1646  */
    break;

  case 400:
#line 2909 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 7308 "parser.c" /* yacc.c:1646  */
    break;

  case 401:
#line 2913 "parser.y" /* yacc.c:1646  */
    { sc_pause_openmp(); }
#line 7314 "parser.c" /* yacc.c:1646  */
    break;

  case 402:
#line 2914 "parser.y" /* yacc.c:1646  */
    {
      sc_start_openmp();
      (yyval.ocla) = VarlistClause(OCAUTO, (yyvsp[-1].decl));
    }
#line 7323 "parser.c" /* yacc.c:1646  */
    break;

  case 403:
#line 2922 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCFOR, (yyvsp[-1].odir), (yyvsp[0].stmt));
    }
#line 7331 "parser.c" /* yacc.c:1646  */
    break;

  case 404:
#line 2929 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCFOR, (yyvsp[-1].ocla));
    }
#line 7339 "parser.c" /* yacc.c:1646  */
    break;

  case 405:
#line 2936 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = NULL;
    }
#line 7347 "parser.c" /* yacc.c:1646  */
    break;

  case 406:
#line 2940 "parser.y" /* yacc.c:1646  */
    {
      #ifdef OMPI_OMP_EXT
        (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
      #else
        if ((yyvsp[0].ocla)->type==OCTAG){
          parse_warning("tag clause ignored;"
                "activate it by configuring OMPi with --enable-ext\n");
          (yyval.ocla) = (yyvsp[-1].ocla);
        }else
          (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
      #endif
    }
#line 7364 "parser.c" /* yacc.c:1646  */
    break;

  case 407:
#line 2953 "parser.y" /* yacc.c:1646  */
    {
      #ifdef OMPI_OMP_EXT
        (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
      #else
        if ((yyvsp[0].ocla)->type==OCTAG){
          parse_warning("tag clause ignored;"
                "activate it by configuring OMPi with --enable-ext\n");
          (yyval.ocla) = (yyvsp[-2].ocla);
        }else
          (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
      #endif
    }
#line 7381 "parser.c" /* yacc.c:1646  */
    break;

  case 408:
#line 2969 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 7389 "parser.c" /* yacc.c:1646  */
    break;

  case 409:
#line 2973 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 7397 "parser.c" /* yacc.c:1646  */
    break;

  case 410:
#line 2977 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 7405 "parser.c" /* yacc.c:1646  */
    break;

  case 411:
#line 2981 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 7413 "parser.c" /* yacc.c:1646  */
    break;

  case 412:
#line 2985 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 7421 "parser.c" /* yacc.c:1646  */
    break;

  case 413:
#line 2989 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = PlainClause(OCNOWAIT);
    }
#line 7429 "parser.c" /* yacc.c:1646  */
    break;

  case 414:
#line 2996 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = PlainClause(OCORDERED);
    }
#line 7437 "parser.c" /* yacc.c:1646  */
    break;

  case 415:
#line 3000 "parser.y" /* yacc.c:1646  */
    {
      int n = 0, er = 0;
      if (xar_expr_is_constant((yyvsp[-1].expr)))
      {
        n = xar_calc_int_expr((yyvsp[-1].expr), &er);
        if (er) n = 0;
      }
      if (n <= 0)
        parse_error(1, "invalid number in ordered() clause.\n");
      (yyval.ocla) = OrderedNumClause(n);
    }
#line 7453 "parser.c" /* yacc.c:1646  */
    break;

  case 416:
#line 3012 "parser.y" /* yacc.c:1646  */
    {
      check_schedule((yyvsp[-1].type), (yyvsp[-2].type));
      (yyval.ocla) = ScheduleClause((yyvsp[-1].type), (yyvsp[-2].type), NULL);
    }
#line 7462 "parser.c" /* yacc.c:1646  */
    break;

  case 417:
#line 3017 "parser.y" /* yacc.c:1646  */
    { sc_pause_openmp(); }
#line 7468 "parser.c" /* yacc.c:1646  */
    break;

  case 418:
#line 3018 "parser.y" /* yacc.c:1646  */
    {
      sc_start_openmp();
      if ((yyvsp[-4].type) == OC_runtime)
        parse_error(1, "\"runtime\" schedules may not have a chunksize.\n");
      check_schedule((yyvsp[-4].type), (yyvsp[-5].type));
      (yyval.ocla) = ScheduleClause((yyvsp[-4].type), (yyvsp[-5].type), (yyvsp[-1].expr));
    }
#line 7480 "parser.c" /* yacc.c:1646  */
    break;

  case 419:
#line 3026 "parser.y" /* yacc.c:1646  */
    {  /* non-OpenMP schedule */
      tempsave = checkDecls;
      checkDecls = 0;   /* Because the index of the loop is usualy involved */
      sc_pause_openmp();
    }
#line 7490 "parser.c" /* yacc.c:1646  */
    break;

  case 420:
#line 3032 "parser.y" /* yacc.c:1646  */
    {
      sc_start_openmp();
      checkDecls = tempsave;
      (yyval.ocla) = ScheduleClause(OC_affinity, OCM_none, (yyvsp[-1].expr));
    }
#line 7500 "parser.c" /* yacc.c:1646  */
    break;

  case 421:
#line 3038 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 7508 "parser.c" /* yacc.c:1646  */
    break;

  case 422:
#line 3042 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 7516 "parser.c" /* yacc.c:1646  */
    break;

  case 423:
#line 3049 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = OC_static;
    }
#line 7524 "parser.c" /* yacc.c:1646  */
    break;

  case 424:
#line 3053 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = OC_dynamic;
    }
#line 7532 "parser.c" /* yacc.c:1646  */
    break;

  case 425:
#line 3057 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = OC_guided;
    }
#line 7540 "parser.c" /* yacc.c:1646  */
    break;

  case 426:
#line 3061 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = OC_runtime;
    }
#line 7548 "parser.c" /* yacc.c:1646  */
    break;

  case 427:
#line 3065 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = OC_auto;
    }
#line 7556 "parser.c" /* yacc.c:1646  */
    break;

  case 428:
#line 3068 "parser.y" /* yacc.c:1646  */
    { parse_error(1, "invalid openmp schedule type.\n"); }
#line 7562 "parser.c" /* yacc.c:1646  */
    break;

  case 429:
#line 3073 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = OCM_none;
    }
#line 7570 "parser.c" /* yacc.c:1646  */
    break;

  case 430:
#line 3077 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = OCM_monotonic;
    }
#line 7578 "parser.c" /* yacc.c:1646  */
    break;

  case 431:
#line 3081 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = OCM_nonmonotonic;
    }
#line 7586 "parser.c" /* yacc.c:1646  */
    break;

  case 432:
#line 3088 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCSECTIONS, (yyvsp[-1].odir), (yyvsp[0].stmt));
    }
#line 7594 "parser.c" /* yacc.c:1646  */
    break;

  case 433:
#line 3095 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCSECTIONS, (yyvsp[-1].ocla));
    }
#line 7602 "parser.c" /* yacc.c:1646  */
    break;

  case 434:
#line 3102 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = NULL;
    }
#line 7610 "parser.c" /* yacc.c:1646  */
    break;

  case 435:
#line 3106 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
    }
#line 7618 "parser.c" /* yacc.c:1646  */
    break;

  case 436:
#line 3110 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
    }
#line 7626 "parser.c" /* yacc.c:1646  */
    break;

  case 437:
#line 3117 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 7634 "parser.c" /* yacc.c:1646  */
    break;

  case 438:
#line 3121 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 7642 "parser.c" /* yacc.c:1646  */
    break;

  case 439:
#line 3125 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 7650 "parser.c" /* yacc.c:1646  */
    break;

  case 440:
#line 3129 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 7658 "parser.c" /* yacc.c:1646  */
    break;

  case 441:
#line 3133 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = PlainClause(OCNOWAIT);
    }
#line 7666 "parser.c" /* yacc.c:1646  */
    break;

  case 442:
#line 3140 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = Compound((yyvsp[-1].stmt));
    }
#line 7674 "parser.c" /* yacc.c:1646  */
    break;

  case 443:
#line 3147 "parser.y" /* yacc.c:1646  */
    {
      /* Make it look like it had a section pragma */
      (yyval.stmt) = OmpStmt( OmpConstruct(DCSECTION, OmpDirective(DCSECTION,NULL), (yyvsp[0].stmt)) );
    }
#line 7683 "parser.c" /* yacc.c:1646  */
    break;

  case 444:
#line 3152 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = OmpStmt( OmpConstruct(DCSECTION, (yyvsp[-1].odir), (yyvsp[0].stmt)) );
    }
#line 7691 "parser.c" /* yacc.c:1646  */
    break;

  case 445:
#line 3156 "parser.y" /* yacc.c:1646  */
    {
      (yyval.stmt) = BlockList((yyvsp[-2].stmt), OmpStmt( OmpConstruct(DCSECTION, (yyvsp[-1].odir), (yyvsp[0].stmt)) ));
    }
#line 7699 "parser.c" /* yacc.c:1646  */
    break;

  case 446:
#line 3163 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCSECTION, NULL);
    }
#line 7707 "parser.c" /* yacc.c:1646  */
    break;

  case 447:
#line 3170 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCSINGLE, (yyvsp[-1].odir), (yyvsp[0].stmt));
    }
#line 7715 "parser.c" /* yacc.c:1646  */
    break;

  case 448:
#line 3177 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCSINGLE, (yyvsp[-1].ocla));
    }
#line 7723 "parser.c" /* yacc.c:1646  */
    break;

  case 449:
#line 3184 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = NULL;
    }
#line 7731 "parser.c" /* yacc.c:1646  */
    break;

  case 450:
#line 3188 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
    }
#line 7739 "parser.c" /* yacc.c:1646  */
    break;

  case 451:
#line 3192 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
    }
#line 7747 "parser.c" /* yacc.c:1646  */
    break;

  case 452:
#line 3199 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 7755 "parser.c" /* yacc.c:1646  */
    break;

  case 453:
#line 3203 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 7763 "parser.c" /* yacc.c:1646  */
    break;

  case 454:
#line 3207 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 7771 "parser.c" /* yacc.c:1646  */
    break;

  case 455:
#line 3211 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = PlainClause(OCNOWAIT);
    }
#line 7779 "parser.c" /* yacc.c:1646  */
    break;

  case 456:
#line 3217 "parser.y" /* yacc.c:1646  */
    { sc_pause_openmp(); }
#line 7785 "parser.c" /* yacc.c:1646  */
    break;

  case 457:
#line 3218 "parser.y" /* yacc.c:1646  */
    {
      sc_start_openmp();
      (yyval.ocla) = VarlistClause(OCCOPYPRIVATE, (yyvsp[-1].decl));
    }
#line 7794 "parser.c" /* yacc.c:1646  */
    break;

  case 458:
#line 3227 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCSIMD, (yyvsp[-1].odir), (yyvsp[0].stmt));
    }
#line 7802 "parser.c" /* yacc.c:1646  */
    break;

  case 459:
#line 3235 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCSIMD, (yyvsp[-1].ocla));
    }
#line 7810 "parser.c" /* yacc.c:1646  */
    break;

  case 460:
#line 3242 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = NULL;
    }
#line 7818 "parser.c" /* yacc.c:1646  */
    break;

  case 461:
#line 3246 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
    }
#line 7826 "parser.c" /* yacc.c:1646  */
    break;

  case 462:
#line 3250 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
    }
#line 7834 "parser.c" /* yacc.c:1646  */
    break;

  case 463:
#line 3258 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 7842 "parser.c" /* yacc.c:1646  */
    break;

  case 464:
#line 3262 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 7850 "parser.c" /* yacc.c:1646  */
    break;

  case 465:
#line 3266 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 7858 "parser.c" /* yacc.c:1646  */
    break;

  case 466:
#line 3270 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 7866 "parser.c" /* yacc.c:1646  */
    break;

  case 467:
#line 3274 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 7874 "parser.c" /* yacc.c:1646  */
    break;

  case 468:
#line 3278 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 7882 "parser.c" /* yacc.c:1646  */
    break;

  case 469:
#line 3286 "parser.y" /* yacc.c:1646  */
    {
      int n = 0, er = 0;
      if (xar_expr_is_constant((yyvsp[-1].expr)))
      {
        n = xar_calc_int_expr((yyvsp[-1].expr), &er);
        if (er) n = 0;
      }
      if (n <= 0)
        parse_error(1, "invalid number in simdlen() clause.\n");
      //$$ = CollapseClause(n); //TODO SAFELEN
    }
#line 7898 "parser.c" /* yacc.c:1646  */
    break;

  case 470:
#line 3298 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 7906 "parser.c" /* yacc.c:1646  */
    break;

  case 471:
#line 3302 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 7914 "parser.c" /* yacc.c:1646  */
    break;

  case 472:
#line 3310 "parser.y" /* yacc.c:1646  */
    {
      //$$ = PlainClause(OCINBRANCH); TODO ast
    }
#line 7922 "parser.c" /* yacc.c:1646  */
    break;

  case 473:
#line 3314 "parser.y" /* yacc.c:1646  */
    {
      //$$ = PlainClause(OCNOTINBRANCH); TODO ast
    }
#line 7930 "parser.c" /* yacc.c:1646  */
    break;

  case 474:
#line 3321 "parser.y" /* yacc.c:1646  */
    { sc_pause_openmp(); }
#line 7936 "parser.c" /* yacc.c:1646  */
    break;

  case 475:
#line 3322 "parser.y" /* yacc.c:1646  */
    {
      sc_start_openmp();
      //$$ = VarlistClause(OCUNIFORM, $4); TODO ast
    }
#line 7945 "parser.c" /* yacc.c:1646  */
    break;

  case 476:
#line 3330 "parser.y" /* yacc.c:1646  */
    { sc_pause_openmp(); }
#line 7951 "parser.c" /* yacc.c:1646  */
    break;

  case 477:
#line 3331 "parser.y" /* yacc.c:1646  */
    {
      sc_start_openmp();
      // TODO ast
    }
#line 7960 "parser.c" /* yacc.c:1646  */
    break;

  case 478:
#line 3339 "parser.y" /* yacc.c:1646  */
    { sc_pause_openmp(); }
#line 7966 "parser.c" /* yacc.c:1646  */
    break;

  case 479:
#line 3340 "parser.y" /* yacc.c:1646  */
    {
      sc_start_openmp();
      // TODO ast
    }
#line 7975 "parser.c" /* yacc.c:1646  */
    break;

  case 480:
#line 3348 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = NULL;
    }
#line 7983 "parser.c" /* yacc.c:1646  */
    break;

  case 481:
#line 3352 "parser.y" /* yacc.c:1646  */
    {
      // TODO ast
    }
#line 7991 "parser.c" /* yacc.c:1646  */
    break;

  case 482:
#line 3360 "parser.y" /* yacc.c:1646  */
    {
      //$$ = OmpConstruct(DCDECLSIMD, $1, $2); TODO DCDECLSIMD or change it to stmt
    }
#line 7999 "parser.c" /* yacc.c:1646  */
    break;

  case 483:
#line 3368 "parser.y" /* yacc.c:1646  */
    {
      //TODO
    }
#line 8007 "parser.c" /* yacc.c:1646  */
    break;

  case 484:
#line 3372 "parser.y" /* yacc.c:1646  */
    {
        //TODO
    }
#line 8015 "parser.c" /* yacc.c:1646  */
    break;

  case 485:
#line 3380 "parser.y" /* yacc.c:1646  */
    {
      //$$ = OmpDirective(DCDECLSIMD, $4); TODO DCDECLSIMD
    }
#line 8023 "parser.c" /* yacc.c:1646  */
    break;

  case 486:
#line 3387 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = NULL;
    }
#line 8031 "parser.c" /* yacc.c:1646  */
    break;

  case 487:
#line 3391 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
    }
#line 8039 "parser.c" /* yacc.c:1646  */
    break;

  case 488:
#line 3395 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
    }
#line 8047 "parser.c" /* yacc.c:1646  */
    break;

  case 489:
#line 3404 "parser.y" /* yacc.c:1646  */
    {
      int n = 0, er = 0;
      if (xar_expr_is_constant((yyvsp[-1].expr)))
      {
        n = xar_calc_int_expr((yyvsp[-1].expr), &er);
        if (er) n = 0;
      }
      if (n <= 0)
        parse_error(1, "invalid number in simdlen() clause.\n");
      //$$ = CollapseClause(n); //TODO SIMDLEN
    }
#line 8063 "parser.c" /* yacc.c:1646  */
    break;

  case 490:
#line 3416 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 8071 "parser.c" /* yacc.c:1646  */
    break;

  case 491:
#line 3420 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 8079 "parser.c" /* yacc.c:1646  */
    break;

  case 492:
#line 3424 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 8087 "parser.c" /* yacc.c:1646  */
    break;

  case 493:
#line 3428 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 8095 "parser.c" /* yacc.c:1646  */
    break;

  case 494:
#line 3436 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCFORSIMD, (yyvsp[-1].odir), (yyvsp[0].stmt));
    }
#line 8103 "parser.c" /* yacc.c:1646  */
    break;

  case 495:
#line 3444 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCFORSIMD, (yyvsp[-1].ocla));
    }
#line 8111 "parser.c" /* yacc.c:1646  */
    break;

  case 496:
#line 3451 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = NULL;
    }
#line 8119 "parser.c" /* yacc.c:1646  */
    break;

  case 497:
#line 3455 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
    }
#line 8127 "parser.c" /* yacc.c:1646  */
    break;

  case 498:
#line 3459 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
    }
#line 8135 "parser.c" /* yacc.c:1646  */
    break;

  case 499:
#line 3466 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 8143 "parser.c" /* yacc.c:1646  */
    break;

  case 500:
#line 3470 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 8151 "parser.c" /* yacc.c:1646  */
    break;

  case 501:
#line 3478 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCPARFORSIMD, (yyvsp[-1].odir), (yyvsp[0].stmt));
    }
#line 8159 "parser.c" /* yacc.c:1646  */
    break;

  case 502:
#line 3486 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCPARFORSIMD, (yyvsp[-1].ocla));
    }
#line 8167 "parser.c" /* yacc.c:1646  */
    break;

  case 503:
#line 3493 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = NULL;
    }
#line 8175 "parser.c" /* yacc.c:1646  */
    break;

  case 504:
#line 3497 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
    }
#line 8183 "parser.c" /* yacc.c:1646  */
    break;

  case 505:
#line 3501 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
    }
#line 8191 "parser.c" /* yacc.c:1646  */
    break;

  case 506:
#line 3508 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 8199 "parser.c" /* yacc.c:1646  */
    break;

  case 507:
#line 3512 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 8207 "parser.c" /* yacc.c:1646  */
    break;

  case 508:
#line 3520 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCTARGETDATA, (yyvsp[-1].odir), (yyvsp[0].stmt));
      __has_target = 1;
    }
#line 8216 "parser.c" /* yacc.c:1646  */
    break;

  case 509:
#line 3529 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCTARGETDATA, (yyvsp[-1].ocla));
    }
#line 8224 "parser.c" /* yacc.c:1646  */
    break;

  case 510:
#line 3536 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = NULL;
    }
#line 8232 "parser.c" /* yacc.c:1646  */
    break;

  case 511:
#line 3540 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
    }
#line 8240 "parser.c" /* yacc.c:1646  */
    break;

  case 512:
#line 3544 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
    }
#line 8248 "parser.c" /* yacc.c:1646  */
    break;

  case 513:
#line 3551 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 8256 "parser.c" /* yacc.c:1646  */
    break;

  case 514:
#line 3555 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
      /* OpenMP v4.5, 2.10.1, page 97: must be to/from/tofrom/alloc */
      if ((yyval.ocla)->subtype != OC_tofrom && (yyval.ocla)->subtype != OC_to && 
          (yyval.ocla)->subtype != OC_from   && (yyval.ocla)->subtype != OC_alloc)
        parse_error(1, "expected a map type of 'to', 'from', 'tofrom' or 'alloc'\n");
    }
#line 8268 "parser.c" /* yacc.c:1646  */
    break;

  case 515:
#line 3563 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 8276 "parser.c" /* yacc.c:1646  */
    break;

  case 516:
#line 3567 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 8284 "parser.c" /* yacc.c:1646  */
    break;

  case 517:
#line 3574 "parser.y" /* yacc.c:1646  */
    { sc_pause_openmp(); }
#line 8290 "parser.c" /* yacc.c:1646  */
    break;

  case 518:
#line 3575 "parser.y" /* yacc.c:1646  */
    {
      sc_start_openmp();
      (yyval.ocla) = DeviceClause((yyvsp[-1].expr));
    }
#line 8299 "parser.c" /* yacc.c:1646  */
    break;

  case 519:
#line 3584 "parser.y" /* yacc.c:1646  */
    { sc_pause_openmp(); }
#line 8305 "parser.c" /* yacc.c:1646  */
    break;

  case 520:
#line 3585 "parser.y" /* yacc.c:1646  */
    {
      sc_start_openmp();
      (yyval.ocla) = MapClause((yyvsp[-4].type), (yyvsp[-5].type), (yyvsp[-1].oxli));
    }
#line 8314 "parser.c" /* yacc.c:1646  */
    break;

  case 521:
#line 3589 "parser.y" /* yacc.c:1646  */
    { sc_pause_openmp(); }
#line 8320 "parser.c" /* yacc.c:1646  */
    break;

  case 522:
#line 3590 "parser.y" /* yacc.c:1646  */
    {
      sc_start_openmp();
      (yyval.ocla) = MapClause(OC_tofrom, OCM_none, (yyvsp[-1].oxli));
    }
#line 8329 "parser.c" /* yacc.c:1646  */
    break;

  case 523:
#line 3599 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = OCM_none;
    }
#line 8337 "parser.c" /* yacc.c:1646  */
    break;

  case 524:
#line 3603 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = OCM_always;
    }
#line 8345 "parser.c" /* yacc.c:1646  */
    break;

  case 525:
#line 3607 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = OCM_always;
    }
#line 8353 "parser.c" /* yacc.c:1646  */
    break;

  case 526:
#line 3615 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = OC_alloc;
    }
#line 8361 "parser.c" /* yacc.c:1646  */
    break;

  case 527:
#line 3619 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = OC_to;
    }
#line 8369 "parser.c" /* yacc.c:1646  */
    break;

  case 528:
#line 3623 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = OC_from;
    }
#line 8377 "parser.c" /* yacc.c:1646  */
    break;

  case 529:
#line 3627 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = OC_tofrom;
    }
#line 8385 "parser.c" /* yacc.c:1646  */
    break;

  case 530:
#line 3631 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = OC_release; 
    }
#line 8393 "parser.c" /* yacc.c:1646  */
    break;

  case 531:
#line 3635 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = OC_delete;
    }
#line 8401 "parser.c" /* yacc.c:1646  */
    break;

  case 532:
#line 3642 "parser.y" /* yacc.c:1646  */
    { sc_pause_openmp(); }
#line 8407 "parser.c" /* yacc.c:1646  */
    break;

  case 533:
#line 3643 "parser.y" /* yacc.c:1646  */
    {
      sc_start_openmp();
      (yyval.ocla) = VarlistClause(OCUSEDEVPTR, (yyvsp[-1].decl));
    }
#line 8416 "parser.c" /* yacc.c:1646  */
    break;

  case 534:
#line 3652 "parser.y" /* yacc.c:1646  */
    {
      /* No parameters needed */
      (yyval.ocla) = PlainClause(OCDEFAULTMAP);
    }
#line 8425 "parser.c" /* yacc.c:1646  */
    break;

  case 535:
#line 3660 "parser.y" /* yacc.c:1646  */
    { sc_pause_openmp(); }
#line 8431 "parser.c" /* yacc.c:1646  */
    break;

  case 536:
#line 3661 "parser.y" /* yacc.c:1646  */
    {
      sc_start_openmp();
      (yyval.ocla) = VarlistClause(OCISDEVPTR, (yyvsp[-1].decl));
    }
#line 8440 "parser.c" /* yacc.c:1646  */
    break;

  case 537:
#line 3669 "parser.y" /* yacc.c:1646  */
    { (yyval.type) = errorOnReturn;  errorOnReturn = 1; }
#line 8446 "parser.c" /* yacc.c:1646  */
    break;

  case 538:
#line 3671 "parser.y" /* yacc.c:1646  */
    {
      errorOnReturn = (yyvsp[-1].type);
      (yyval.ocon) = OmpConstruct(DCTARGET, (yyvsp[-2].odir), (yyvsp[0].stmt));
      __has_target = 1;
    }
#line 8456 "parser.c" /* yacc.c:1646  */
    break;

  case 539:
#line 3681 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCTARGET, (yyvsp[-1].ocla));
    }
#line 8464 "parser.c" /* yacc.c:1646  */
    break;

  case 540:
#line 3688 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = NULL;
    }
#line 8472 "parser.c" /* yacc.c:1646  */
    break;

  case 541:
#line 3692 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
    }
#line 8480 "parser.c" /* yacc.c:1646  */
    break;

  case 542:
#line 3696 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
    }
#line 8488 "parser.c" /* yacc.c:1646  */
    break;

  case 543:
#line 3703 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 8496 "parser.c" /* yacc.c:1646  */
    break;

  case 544:
#line 3707 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 8504 "parser.c" /* yacc.c:1646  */
    break;

  case 545:
#line 3711 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 8512 "parser.c" /* yacc.c:1646  */
    break;

  case 546:
#line 3715 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = PlainClause(OCNOWAIT);
    }
#line 8520 "parser.c" /* yacc.c:1646  */
    break;

  case 547:
#line 3719 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 8528 "parser.c" /* yacc.c:1646  */
    break;

  case 548:
#line 3723 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 8536 "parser.c" /* yacc.c:1646  */
    break;

  case 549:
#line 3730 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 8544 "parser.c" /* yacc.c:1646  */
    break;

  case 550:
#line 3734 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
      /* OpenMP v4.5, 2.10.4, page 106: must be to/from/tofrom/alloc */
      if ((yyval.ocla)->subtype != OC_tofrom && (yyval.ocla)->subtype != OC_to && 
          (yyval.ocla)->subtype != OC_from   && (yyval.ocla)->subtype != OC_alloc)
        parse_error(1, "expected a map type of 'to', 'from', 'tofrom' or 'alloc'\n");
    }
#line 8556 "parser.c" /* yacc.c:1646  */
    break;

  case 551:
#line 3742 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 8564 "parser.c" /* yacc.c:1646  */
    break;

  case 552:
#line 3746 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 8572 "parser.c" /* yacc.c:1646  */
    break;

  case 553:
#line 3754 "parser.y" /* yacc.c:1646  */
    {
      if (xc_clauselist_get_clause((yyvsp[-1].ocla), OCMAP, 0) == NULL)
        parse_error(1, "target enter data directives must contain at least 1 "
                       "map() clause");
      (yyval.odir) = OmpDirective(DCTARGENTERDATA, (yyvsp[-1].ocla));
      __has_target = 1;
    }
#line 8584 "parser.c" /* yacc.c:1646  */
    break;

  case 554:
#line 3765 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 8592 "parser.c" /* yacc.c:1646  */
    break;

  case 555:
#line 3769 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
    }
#line 8600 "parser.c" /* yacc.c:1646  */
    break;

  case 556:
#line 3773 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
    }
#line 8608 "parser.c" /* yacc.c:1646  */
    break;

  case 557:
#line 3780 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
      /* OpenMP v4.5, 2.10.2, page 99: must be to/alloc */
      if ((yyval.ocla)->subtype != OC_to && (yyval.ocla)->subtype != OC_alloc)
        parse_error(1, "expected a map type of 'to' or 'alloc'\n");
    }
#line 8619 "parser.c" /* yacc.c:1646  */
    break;

  case 558:
#line 3787 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 8627 "parser.c" /* yacc.c:1646  */
    break;

  case 559:
#line 3791 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 8635 "parser.c" /* yacc.c:1646  */
    break;

  case 560:
#line 3795 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 8643 "parser.c" /* yacc.c:1646  */
    break;

  case 561:
#line 3799 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = PlainClause(OCNOWAIT);
    }
#line 8651 "parser.c" /* yacc.c:1646  */
    break;

  case 562:
#line 3806 "parser.y" /* yacc.c:1646  */
    {
      if (xc_clauselist_get_clause((yyvsp[-1].ocla), OCMAP, 0) == NULL)
        parse_error(1, "target exit data directives must contain at least 1 "
                       "map() clause");
      (yyval.odir) = OmpDirective(DCTARGEXITDATA, (yyvsp[-1].ocla));
      __has_target = 1;
    }
#line 8663 "parser.c" /* yacc.c:1646  */
    break;

  case 563:
#line 3817 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 8671 "parser.c" /* yacc.c:1646  */
    break;

  case 564:
#line 3821 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
    }
#line 8679 "parser.c" /* yacc.c:1646  */
    break;

  case 565:
#line 3825 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
    }
#line 8687 "parser.c" /* yacc.c:1646  */
    break;

  case 566:
#line 3832 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
      /* OpenMP v4.5, 2.10.3, page 102: must be from/release/delete */
      if ((yyval.ocla)->subtype != OC_from && (yyval.ocla)->subtype != OC_release &&
          (yyval.ocla)->subtype != OC_delete)
        parse_error(1, "expected a map type of 'from', 'release' or 'delete'\n");
    }
#line 8699 "parser.c" /* yacc.c:1646  */
    break;

  case 567:
#line 3840 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 8707 "parser.c" /* yacc.c:1646  */
    break;

  case 568:
#line 3844 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 8715 "parser.c" /* yacc.c:1646  */
    break;

  case 569:
#line 3848 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 8723 "parser.c" /* yacc.c:1646  */
    break;

  case 570:
#line 3852 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = PlainClause(OCNOWAIT);
    }
#line 8731 "parser.c" /* yacc.c:1646  */
    break;

  case 571:
#line 3860 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCTARGETUPD, (yyvsp[-1].ocla));
      __has_target = 1;
    }
#line 8740 "parser.c" /* yacc.c:1646  */
    break;

  case 572:
#line 3868 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 8748 "parser.c" /* yacc.c:1646  */
    break;

  case 573:
#line 3872 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
    }
#line 8756 "parser.c" /* yacc.c:1646  */
    break;

  case 574:
#line 3876 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
    }
#line 8764 "parser.c" /* yacc.c:1646  */
    break;

  case 575:
#line 3883 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 8772 "parser.c" /* yacc.c:1646  */
    break;

  case 576:
#line 3887 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 8780 "parser.c" /* yacc.c:1646  */
    break;

  case 577:
#line 3891 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 8788 "parser.c" /* yacc.c:1646  */
    break;

  case 578:
#line 3895 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 8796 "parser.c" /* yacc.c:1646  */
    break;

  case 579:
#line 3899 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = PlainClause(OCNOWAIT);
    }
#line 8804 "parser.c" /* yacc.c:1646  */
    break;

  case 580:
#line 3906 "parser.y" /* yacc.c:1646  */
    { sc_pause_openmp(); }
#line 8810 "parser.c" /* yacc.c:1646  */
    break;

  case 581:
#line 3907 "parser.y" /* yacc.c:1646  */
    {
      sc_start_openmp();
      (yyval.ocla) = FilterClause((yyvsp[-1].expr));
    }
#line 8819 "parser.c" /* yacc.c:1646  */
    break;

  case 582:
#line 3915 "parser.y" /* yacc.c:1646  */
    { sc_pause_openmp(); }
#line 8825 "parser.c" /* yacc.c:1646  */
    break;

  case 583:
#line 3916 "parser.y" /* yacc.c:1646  */
    {
      sc_start_openmp();
      (yyval.ocla) = UpdateClause(OCTO, (yyvsp[-1].oxli));
    }
#line 8834 "parser.c" /* yacc.c:1646  */
    break;

  case 584:
#line 3920 "parser.y" /* yacc.c:1646  */
    { sc_pause_openmp(); }
#line 8840 "parser.c" /* yacc.c:1646  */
    break;

  case 585:
#line 3921 "parser.y" /* yacc.c:1646  */
    {
      sc_start_openmp();
      (yyval.ocla) = UpdateClause(OCFROM, (yyvsp[-1].oxli));
    }
#line 8849 "parser.c" /* yacc.c:1646  */
    break;

  case 586:
#line 3932 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCDECLTARGET, (yyvsp[-2].odir), (yyvsp[-1].stmt));
    }
#line 8857 "parser.c" /* yacc.c:1646  */
    break;

  case 587:
#line 3936 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCDECLTARGET, (yyvsp[0].odir), NULL);
    }
#line 8865 "parser.c" /* yacc.c:1646  */
    break;

  case 588:
#line 3943 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCDECLTARGET, NULL);
    }
#line 8873 "parser.c" /* yacc.c:1646  */
    break;

  case 589:
#line 3950 "parser.y" /* yacc.c:1646  */
    {
      //$$ = OmpDirective(DCENDDECLTARGET, NULL); TODO DCENDDECLTARGET
    }
#line 8881 "parser.c" /* yacc.c:1646  */
    break;

  case 590:
#line 3959 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCDECLTARGET, UpdateClause(OCTO, (yyvsp[-2].oxli)));
    }
#line 8889 "parser.c" /* yacc.c:1646  */
    break;

  case 591:
#line 3963 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCDECLTARGET, (yyvsp[-1].ocla));
    }
#line 8897 "parser.c" /* yacc.c:1646  */
    break;

  case 592:
#line 3971 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 8905 "parser.c" /* yacc.c:1646  */
    break;

  case 593:
#line 3975 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
    }
#line 8913 "parser.c" /* yacc.c:1646  */
    break;

  case 594:
#line 3979 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
    }
#line 8921 "parser.c" /* yacc.c:1646  */
    break;

  case 595:
#line 3986 "parser.y" /* yacc.c:1646  */
    { sc_pause_openmp(); }
#line 8927 "parser.c" /* yacc.c:1646  */
    break;

  case 596:
#line 3987 "parser.y" /* yacc.c:1646  */
    {
      sc_start_openmp();
      (yyval.ocla) = UpdateClause(OCTO, (yyvsp[-1].oxli));
    }
#line 8936 "parser.c" /* yacc.c:1646  */
    break;

  case 597:
#line 3992 "parser.y" /* yacc.c:1646  */
    { 
      tempsave = checkDecls;   /* No check--the directive can appear anywhere */
      checkDecls = 0; 
      sc_pause_openmp(); 
    }
#line 8946 "parser.c" /* yacc.c:1646  */
    break;

  case 598:
#line 3998 "parser.y" /* yacc.c:1646  */
    {
      sc_start_openmp();
      checkDecls = tempsave;
      (yyval.ocla) = UpdateClause(OCLINK, (yyvsp[-1].oxli));
    }
#line 8956 "parser.c" /* yacc.c:1646  */
    break;

  case 599:
#line 4010 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCTEAMS, (yyvsp[-1].odir), (yyvsp[0].stmt));
    }
#line 8964 "parser.c" /* yacc.c:1646  */
    break;

  case 600:
#line 4020 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCTEAMS, (yyvsp[-1].ocla));
    }
#line 8972 "parser.c" /* yacc.c:1646  */
    break;

  case 601:
#line 4027 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = NULL;
    }
#line 8980 "parser.c" /* yacc.c:1646  */
    break;

  case 602:
#line 4031 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
    }
#line 8988 "parser.c" /* yacc.c:1646  */
    break;

  case 603:
#line 4035 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
    }
#line 8996 "parser.c" /* yacc.c:1646  */
    break;

  case 604:
#line 4042 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9004 "parser.c" /* yacc.c:1646  */
    break;

  case 605:
#line 4046 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9012 "parser.c" /* yacc.c:1646  */
    break;

  case 606:
#line 4050 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9020 "parser.c" /* yacc.c:1646  */
    break;

  case 607:
#line 4054 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9028 "parser.c" /* yacc.c:1646  */
    break;

  case 608:
#line 4058 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9036 "parser.c" /* yacc.c:1646  */
    break;

  case 609:
#line 4062 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9044 "parser.c" /* yacc.c:1646  */
    break;

  case 610:
#line 4071 "parser.y" /* yacc.c:1646  */
    { sc_pause_openmp(); }
#line 9050 "parser.c" /* yacc.c:1646  */
    break;

  case 611:
#line 4072 "parser.y" /* yacc.c:1646  */
    {
      sc_start_openmp();
      (yyval.ocla) = ((yyvsp[-1].expr) == NULL) ? NumteamsClause(NULL, (yyvsp[-2].expr)) : NumteamsClause((yyvsp[-2].expr), (yyvsp[-1].expr));
    }
#line 9059 "parser.c" /* yacc.c:1646  */
    break;

  case 612:
#line 4077 "parser.y" /* yacc.c:1646  */
    { sc_pause_openmp(); }
#line 9065 "parser.c" /* yacc.c:1646  */
    break;

  case 613:
#line 4078 "parser.y" /* yacc.c:1646  */
    {
      sc_start_openmp();
      (yyval.ocla) = ThreadlimitClause((yyvsp[-1].expr));
    }
#line 9074 "parser.c" /* yacc.c:1646  */
    break;

  case 614:
#line 4088 "parser.y" /* yacc.c:1646  */
    { (yyval.expr) = NULL; }
#line 9080 "parser.c" /* yacc.c:1646  */
    break;

  case 615:
#line 4090 "parser.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 9086 "parser.c" /* yacc.c:1646  */
    break;

  case 616:
#line 4096 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCDISTRIBUTE, (yyvsp[-1].odir), (yyvsp[0].stmt));
    }
#line 9094 "parser.c" /* yacc.c:1646  */
    break;

  case 617:
#line 4104 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCDISTRIBUTE, (yyvsp[-1].ocla));
    }
#line 9102 "parser.c" /* yacc.c:1646  */
    break;

  case 618:
#line 4111 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = NULL;
    }
#line 9110 "parser.c" /* yacc.c:1646  */
    break;

  case 619:
#line 4115 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
    }
#line 9118 "parser.c" /* yacc.c:1646  */
    break;

  case 620:
#line 4119 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
    }
#line 9126 "parser.c" /* yacc.c:1646  */
    break;

  case 621:
#line 4126 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9134 "parser.c" /* yacc.c:1646  */
    break;

  case 622:
#line 4130 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9142 "parser.c" /* yacc.c:1646  */
    break;

  case 623:
#line 4134 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9150 "parser.c" /* yacc.c:1646  */
    break;

  case 624:
#line 4138 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9158 "parser.c" /* yacc.c:1646  */
    break;

  case 625:
#line 4142 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9166 "parser.c" /* yacc.c:1646  */
    break;

  case 626:
#line 4149 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = DistScheduleClause(OC_static, OCM_none, NULL);
    }
#line 9174 "parser.c" /* yacc.c:1646  */
    break;

  case 627:
#line 4152 "parser.y" /* yacc.c:1646  */
    { sc_pause_openmp(); }
#line 9180 "parser.c" /* yacc.c:1646  */
    break;

  case 628:
#line 4153 "parser.y" /* yacc.c:1646  */
    {
      sc_start_openmp();
      (yyval.ocla) = DistScheduleClause(OC_static,OCM_none,  (yyvsp[-1].expr));
    }
#line 9189 "parser.c" /* yacc.c:1646  */
    break;

  case 629:
#line 4162 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCDISTSIMD, (yyvsp[-1].odir), (yyvsp[0].stmt));
      (yyval.ocon)->l = (yyvsp[-1].odir)->l;
    }
#line 9198 "parser.c" /* yacc.c:1646  */
    break;

  case 630:
#line 4171 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCDISTSIMD, (yyvsp[-1].ocla));
    }
#line 9206 "parser.c" /* yacc.c:1646  */
    break;

  case 631:
#line 4178 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = NULL;
    }
#line 9214 "parser.c" /* yacc.c:1646  */
    break;

  case 632:
#line 4182 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
    }
#line 9222 "parser.c" /* yacc.c:1646  */
    break;

  case 633:
#line 4186 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
    }
#line 9230 "parser.c" /* yacc.c:1646  */
    break;

  case 634:
#line 4193 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9238 "parser.c" /* yacc.c:1646  */
    break;

  case 635:
#line 4197 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9246 "parser.c" /* yacc.c:1646  */
    break;

  case 636:
#line 4201 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9254 "parser.c" /* yacc.c:1646  */
    break;

  case 637:
#line 4209 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCDISTPARFOR, (yyvsp[-1].odir), (yyvsp[0].stmt));
      (yyval.ocon)->l = (yyvsp[-1].odir)->l;
    }
#line 9263 "parser.c" /* yacc.c:1646  */
    break;

  case 638:
#line 4218 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCDISTPARFOR, (yyvsp[-1].ocla));
    }
#line 9271 "parser.c" /* yacc.c:1646  */
    break;

  case 639:
#line 4225 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = NULL;
    }
#line 9279 "parser.c" /* yacc.c:1646  */
    break;

  case 640:
#line 4229 "parser.y" /* yacc.c:1646  */
    {
      #ifdef OMPI_OMP_EXT
        (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
      #else
        if ((yyvsp[0].ocla)->type==OCTAG){
          parse_warning("tag clause ignored;"
                "activate it by configuring OMPi with --enable-ext\n");
          (yyval.ocla) = (yyvsp[-1].ocla);
        }else
          (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
      #endif
    }
#line 9296 "parser.c" /* yacc.c:1646  */
    break;

  case 641:
#line 4242 "parser.y" /* yacc.c:1646  */
    {
      #ifdef OMPI_OMP_EXT
        (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
      #else
        if ((yyvsp[0].ocla)->type==OCTAG){
          parse_warning("tag clause ignored;"
                "activate it by configuring OMPi with --enable-ext\n");
          (yyval.ocla) = (yyvsp[-2].ocla);
        }else
          (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
      #endif
    }
#line 9313 "parser.c" /* yacc.c:1646  */
    break;

  case 642:
#line 4258 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9321 "parser.c" /* yacc.c:1646  */
    break;

  case 643:
#line 4262 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9329 "parser.c" /* yacc.c:1646  */
    break;

  case 644:
#line 4270 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCDISTPARFORSIMD, (yyvsp[-1].odir), (yyvsp[0].stmt));
      (yyval.ocon)->l = (yyvsp[-1].odir)->l;
    }
#line 9338 "parser.c" /* yacc.c:1646  */
    break;

  case 645:
#line 4279 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCDISTPARFORSIMD, (yyvsp[-1].ocla));
    }
#line 9346 "parser.c" /* yacc.c:1646  */
    break;

  case 646:
#line 4286 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = NULL;
    }
#line 9354 "parser.c" /* yacc.c:1646  */
    break;

  case 647:
#line 4290 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
    }
#line 9362 "parser.c" /* yacc.c:1646  */
    break;

  case 648:
#line 4294 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
    }
#line 9370 "parser.c" /* yacc.c:1646  */
    break;

  case 649:
#line 4301 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9378 "parser.c" /* yacc.c:1646  */
    break;

  case 650:
#line 4305 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9386 "parser.c" /* yacc.c:1646  */
    break;

  case 651:
#line 4313 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCTARGETTEAMS, (yyvsp[-1].odir), (yyvsp[0].stmt));
      __has_target = 1;
    }
#line 9395 "parser.c" /* yacc.c:1646  */
    break;

  case 652:
#line 4322 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCTARGETTEAMS, (yyvsp[-1].ocla));
    }
#line 9403 "parser.c" /* yacc.c:1646  */
    break;

  case 653:
#line 4329 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = NULL;
    }
#line 9411 "parser.c" /* yacc.c:1646  */
    break;

  case 654:
#line 4333 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
    }
#line 9419 "parser.c" /* yacc.c:1646  */
    break;

  case 655:
#line 4337 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
    }
#line 9427 "parser.c" /* yacc.c:1646  */
    break;

  case 656:
#line 4344 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9435 "parser.c" /* yacc.c:1646  */
    break;

  case 657:
#line 4348 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9443 "parser.c" /* yacc.c:1646  */
    break;

  case 658:
#line 4352 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9451 "parser.c" /* yacc.c:1646  */
    break;

  case 659:
#line 4356 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9459 "parser.c" /* yacc.c:1646  */
    break;

  case 660:
#line 4360 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = PlainClause(OCNOWAIT);
    }
#line 9467 "parser.c" /* yacc.c:1646  */
    break;

  case 661:
#line 4368 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCTARGETPARALLEL, (yyvsp[-1].odir), (yyvsp[0].stmt));
      __has_target = 1;
    }
#line 9476 "parser.c" /* yacc.c:1646  */
    break;

  case 662:
#line 4377 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCTARGETPARALLEL, (yyvsp[-1].ocla));
    }
#line 9484 "parser.c" /* yacc.c:1646  */
    break;

  case 663:
#line 4384 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = NULL;
    }
#line 9492 "parser.c" /* yacc.c:1646  */
    break;

  case 664:
#line 4388 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
    }
#line 9500 "parser.c" /* yacc.c:1646  */
    break;

  case 665:
#line 4392 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
    }
#line 9508 "parser.c" /* yacc.c:1646  */
    break;

  case 666:
#line 4399 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9516 "parser.c" /* yacc.c:1646  */
    break;

  case 667:
#line 4403 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9524 "parser.c" /* yacc.c:1646  */
    break;

  case 668:
#line 4407 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9532 "parser.c" /* yacc.c:1646  */
    break;

  case 669:
#line 4411 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9540 "parser.c" /* yacc.c:1646  */
    break;

  case 670:
#line 4415 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9548 "parser.c" /* yacc.c:1646  */
    break;

  case 671:
#line 4419 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9556 "parser.c" /* yacc.c:1646  */
    break;

  case 672:
#line 4423 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9564 "parser.c" /* yacc.c:1646  */
    break;

  case 673:
#line 4427 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9572 "parser.c" /* yacc.c:1646  */
    break;

  case 674:
#line 4431 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9580 "parser.c" /* yacc.c:1646  */
    break;

  case 675:
#line 4435 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = PlainClause(OCNOWAIT);
    }
#line 9588 "parser.c" /* yacc.c:1646  */
    break;

  case 676:
#line 4443 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCTEAMSDIST, (yyvsp[-1].odir), (yyvsp[0].stmt));
    }
#line 9596 "parser.c" /* yacc.c:1646  */
    break;

  case 677:
#line 4451 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCTEAMSDIST, (yyvsp[-1].ocla));
    }
#line 9604 "parser.c" /* yacc.c:1646  */
    break;

  case 678:
#line 4458 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = NULL;
    }
#line 9612 "parser.c" /* yacc.c:1646  */
    break;

  case 679:
#line 4462 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
    }
#line 9620 "parser.c" /* yacc.c:1646  */
    break;

  case 680:
#line 4466 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
    }
#line 9628 "parser.c" /* yacc.c:1646  */
    break;

  case 681:
#line 4473 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9636 "parser.c" /* yacc.c:1646  */
    break;

  case 682:
#line 4477 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9644 "parser.c" /* yacc.c:1646  */
    break;

  case 683:
#line 4481 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9652 "parser.c" /* yacc.c:1646  */
    break;

  case 684:
#line 4485 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9660 "parser.c" /* yacc.c:1646  */
    break;

  case 685:
#line 4493 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCTEAMSDISTSIMD, (yyvsp[-1].odir), (yyvsp[0].stmt));
    }
#line 9668 "parser.c" /* yacc.c:1646  */
    break;

  case 686:
#line 4501 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCTEAMSDISTSIMD, (yyvsp[-1].ocla));
    }
#line 9676 "parser.c" /* yacc.c:1646  */
    break;

  case 687:
#line 4508 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = NULL;
    }
#line 9684 "parser.c" /* yacc.c:1646  */
    break;

  case 688:
#line 4512 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
    }
#line 9692 "parser.c" /* yacc.c:1646  */
    break;

  case 689:
#line 4516 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
    }
#line 9700 "parser.c" /* yacc.c:1646  */
    break;

  case 690:
#line 4523 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9708 "parser.c" /* yacc.c:1646  */
    break;

  case 691:
#line 4527 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9716 "parser.c" /* yacc.c:1646  */
    break;

  case 692:
#line 4531 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9724 "parser.c" /* yacc.c:1646  */
    break;

  case 693:
#line 4535 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9732 "parser.c" /* yacc.c:1646  */
    break;

  case 694:
#line 4543 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCTARGETTEAMSDIST, (yyvsp[-1].odir), (yyvsp[0].stmt));
      __has_target = 1;
    }
#line 9741 "parser.c" /* yacc.c:1646  */
    break;

  case 695:
#line 4552 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCTARGETTEAMSDIST, (yyvsp[-1].ocla));
    }
#line 9749 "parser.c" /* yacc.c:1646  */
    break;

  case 696:
#line 4559 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = NULL;
    }
#line 9757 "parser.c" /* yacc.c:1646  */
    break;

  case 697:
#line 4563 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
    }
#line 9765 "parser.c" /* yacc.c:1646  */
    break;

  case 698:
#line 4567 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
    }
#line 9773 "parser.c" /* yacc.c:1646  */
    break;

  case 699:
#line 4574 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9781 "parser.c" /* yacc.c:1646  */
    break;

  case 700:
#line 4578 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9789 "parser.c" /* yacc.c:1646  */
    break;

  case 701:
#line 4582 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9797 "parser.c" /* yacc.c:1646  */
    break;

  case 702:
#line 4586 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9805 "parser.c" /* yacc.c:1646  */
    break;

  case 703:
#line 4590 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = PlainClause(OCNOWAIT);
    }
#line 9813 "parser.c" /* yacc.c:1646  */
    break;

  case 704:
#line 4598 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCTARGETTEAMSDISTSIMD, (yyvsp[-1].odir), (yyvsp[0].stmt));
      __has_target = 1;
    }
#line 9822 "parser.c" /* yacc.c:1646  */
    break;

  case 705:
#line 4608 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCTARGETTEAMSDISTSIMD, (yyvsp[-1].ocla));
    }
#line 9830 "parser.c" /* yacc.c:1646  */
    break;

  case 706:
#line 4615 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = NULL;
    }
#line 9838 "parser.c" /* yacc.c:1646  */
    break;

  case 707:
#line 4620 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
    }
#line 9846 "parser.c" /* yacc.c:1646  */
    break;

  case 708:
#line 4625 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
    }
#line 9854 "parser.c" /* yacc.c:1646  */
    break;

  case 709:
#line 4632 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9862 "parser.c" /* yacc.c:1646  */
    break;

  case 710:
#line 4636 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9870 "parser.c" /* yacc.c:1646  */
    break;

  case 711:
#line 4640 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9878 "parser.c" /* yacc.c:1646  */
    break;

  case 712:
#line 4644 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = PlainClause(OCNOWAIT);
    }
#line 9886 "parser.c" /* yacc.c:1646  */
    break;

  case 713:
#line 4652 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCTEAMSDISTPARFOR, (yyvsp[-1].odir), (yyvsp[0].stmt));
      (yyval.ocon)->l = (yyvsp[-1].odir)->l;
    }
#line 9895 "parser.c" /* yacc.c:1646  */
    break;

  case 714:
#line 4662 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCTEAMSDISTPARFOR, (yyvsp[-1].ocla));
    }
#line 9903 "parser.c" /* yacc.c:1646  */
    break;

  case 715:
#line 4669 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = NULL;
    }
#line 9911 "parser.c" /* yacc.c:1646  */
    break;

  case 716:
#line 4674 "parser.y" /* yacc.c:1646  */
    {
      #ifdef OMPI_OMP_EXT
        (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
      #else
        if ((yyvsp[0].ocla)->type==OCTAG){
          parse_warning("tag clause ignored;"
                "activate it by configuring OMPi with --enable-ext\n");
          (yyval.ocla) = (yyvsp[-1].ocla);
        }else
          (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
      #endif
    }
#line 9928 "parser.c" /* yacc.c:1646  */
    break;

  case 717:
#line 4688 "parser.y" /* yacc.c:1646  */
    {
      #ifdef OMPI_OMP_EXT
        (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
      #else
        if ((yyvsp[0].ocla)->type==OCTAG){
          parse_warning("tag clause ignored;"
                "activate it by configuring OMPi with --enable-ext\n");
          (yyval.ocla) = (yyvsp[-2].ocla);
        }else
          (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
      #endif
    }
#line 9945 "parser.c" /* yacc.c:1646  */
    break;

  case 718:
#line 4704 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9953 "parser.c" /* yacc.c:1646  */
    break;

  case 719:
#line 4708 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 9961 "parser.c" /* yacc.c:1646  */
    break;

  case 720:
#line 4716 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCTARGETTEAMSDISTPARFOR, (yyvsp[-1].odir), (yyvsp[0].stmt));
      (yyval.ocon)->l = (yyvsp[-1].odir)->l;
      __has_target = 1;
    }
#line 9971 "parser.c" /* yacc.c:1646  */
    break;

  case 721:
#line 4726 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCTARGETTEAMSDISTPARFOR, (yyvsp[-1].ocla));
    }
#line 9979 "parser.c" /* yacc.c:1646  */
    break;

  case 722:
#line 4733 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = NULL;
    }
#line 9987 "parser.c" /* yacc.c:1646  */
    break;

  case 723:
#line 4737 "parser.y" /* yacc.c:1646  */
    {
      #ifdef OMPI_OMP_EXT
        (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
      #else
        if ((yyvsp[0].ocla)->type==OCTAG){
          parse_warning("tag clause ignored;"
                "activate it by configuring OMPi with --enable-ext\n");
          (yyval.ocla) = (yyvsp[-1].ocla);
        }else
          (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
      #endif
    }
#line 10004 "parser.c" /* yacc.c:1646  */
    break;

  case 724:
#line 4750 "parser.y" /* yacc.c:1646  */
    {
      #ifdef OMPI_OMP_EXT
        (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
      #else
        if ((yyvsp[0].ocla)->type==OCTAG){
          parse_warning("tag clause ignored;"
                "activate it by configuring OMPi with --enable-ext\n");
          (yyval.ocla) = (yyvsp[-2].ocla);
        }else
          (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
      #endif
    }
#line 10021 "parser.c" /* yacc.c:1646  */
    break;

  case 725:
#line 4766 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 10029 "parser.c" /* yacc.c:1646  */
    break;

  case 726:
#line 4770 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 10037 "parser.c" /* yacc.c:1646  */
    break;

  case 727:
#line 4774 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 10045 "parser.c" /* yacc.c:1646  */
    break;

  case 728:
#line 4778 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = PlainClause(OCNOWAIT);
    }
#line 10053 "parser.c" /* yacc.c:1646  */
    break;

  case 729:
#line 4786 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCTEAMSDISTPARFORSIMD, (yyvsp[-1].odir), (yyvsp[0].stmt));
      (yyval.ocon)->l = (yyvsp[-1].odir)->l;
    }
#line 10062 "parser.c" /* yacc.c:1646  */
    break;

  case 730:
#line 4795 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCTEAMSDISTPARFORSIMD, (yyvsp[-1].ocla));
    }
#line 10070 "parser.c" /* yacc.c:1646  */
    break;

  case 731:
#line 4802 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = NULL;
    }
#line 10078 "parser.c" /* yacc.c:1646  */
    break;

  case 732:
#line 4806 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
    }
#line 10086 "parser.c" /* yacc.c:1646  */
    break;

  case 733:
#line 4810 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
    }
#line 10094 "parser.c" /* yacc.c:1646  */
    break;

  case 734:
#line 4817 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 10102 "parser.c" /* yacc.c:1646  */
    break;

  case 735:
#line 4821 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 10110 "parser.c" /* yacc.c:1646  */
    break;

  case 736:
#line 4829 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCTARGETTEAMSDISTPARFORSIMD, (yyvsp[-1].odir), (yyvsp[0].stmt));
      (yyval.ocon)->l = (yyvsp[-1].odir)->l;
      __has_target = 1;
    }
#line 10120 "parser.c" /* yacc.c:1646  */
    break;

  case 737:
#line 4839 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCTARGETTEAMSDISTPARFORSIMD, (yyvsp[-1].ocla));
    }
#line 10128 "parser.c" /* yacc.c:1646  */
    break;

  case 738:
#line 4846 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = NULL;
    }
#line 10136 "parser.c" /* yacc.c:1646  */
    break;

  case 739:
#line 4850 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
    }
#line 10144 "parser.c" /* yacc.c:1646  */
    break;

  case 740:
#line 4854 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
    }
#line 10152 "parser.c" /* yacc.c:1646  */
    break;

  case 741:
#line 4861 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 10160 "parser.c" /* yacc.c:1646  */
    break;

  case 742:
#line 4865 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 10168 "parser.c" /* yacc.c:1646  */
    break;

  case 743:
#line 4869 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 10176 "parser.c" /* yacc.c:1646  */
    break;

  case 744:
#line 4873 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = PlainClause(OCNOWAIT);
    }
#line 10184 "parser.c" /* yacc.c:1646  */
    break;

  case 745:
#line 4881 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCTARGETPARFOR, (yyvsp[-1].odir), (yyvsp[0].stmt));
      __has_target = 1;
    }
#line 10193 "parser.c" /* yacc.c:1646  */
    break;

  case 746:
#line 4890 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCTARGETPARFOR, (yyvsp[-1].ocla));
    }
#line 10201 "parser.c" /* yacc.c:1646  */
    break;

  case 747:
#line 4897 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = NULL;
    }
#line 10209 "parser.c" /* yacc.c:1646  */
    break;

  case 748:
#line 4901 "parser.y" /* yacc.c:1646  */
    {
      #ifdef OMPI_OMP_EXT
        (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
      #else
        if ((yyvsp[0].ocla)->type==OCTAG){
          parse_warning("tag clause ignored;"
                "activate it by configuring OMPi with --enable-ext\n");
          (yyval.ocla) = (yyvsp[-1].ocla);
        }else
          (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
      #endif
    }
#line 10226 "parser.c" /* yacc.c:1646  */
    break;

  case 749:
#line 4914 "parser.y" /* yacc.c:1646  */
    {
      #ifdef OMPI_OMP_EXT
        (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
      #else
        if ((yyvsp[0].ocla)->type==OCTAG){
          parse_warning("tag clause ignored;"
                "activate it by configuring OMPi with --enable-ext\n");
          (yyval.ocla) = (yyvsp[-2].ocla);
        }else
          (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
      #endif
    }
#line 10243 "parser.c" /* yacc.c:1646  */
    break;

  case 750:
#line 4930 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 10251 "parser.c" /* yacc.c:1646  */
    break;

  case 751:
#line 4934 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
  	}
#line 10259 "parser.c" /* yacc.c:1646  */
    break;

  case 752:
#line 4938 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 10267 "parser.c" /* yacc.c:1646  */
    break;

  case 753:
#line 4942 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = PlainClause(OCNOWAIT);
    }
#line 10275 "parser.c" /* yacc.c:1646  */
    break;

  case 754:
#line 4950 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCTASK, (yyvsp[-1].odir), (yyvsp[0].stmt));
      (yyval.ocon)->l = (yyvsp[-1].odir)->l;
    }
#line 10284 "parser.c" /* yacc.c:1646  */
    break;

  case 755:
#line 4959 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCTASK, (yyvsp[-1].ocla));
    }
#line 10292 "parser.c" /* yacc.c:1646  */
    break;

  case 756:
#line 4967 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = NULL;
    }
#line 10300 "parser.c" /* yacc.c:1646  */
    break;

  case 757:
#line 4971 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
    }
#line 10308 "parser.c" /* yacc.c:1646  */
    break;

  case 758:
#line 4975 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
    }
#line 10316 "parser.c" /* yacc.c:1646  */
    break;

  case 759:
#line 4983 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 10324 "parser.c" /* yacc.c:1646  */
    break;

  case 760:
#line 4987 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 10332 "parser.c" /* yacc.c:1646  */
    break;

  case 761:
#line 4991 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 10340 "parser.c" /* yacc.c:1646  */
    break;

  case 762:
#line 4995 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 10348 "parser.c" /* yacc.c:1646  */
    break;

  case 763:
#line 4999 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 10356 "parser.c" /* yacc.c:1646  */
    break;

  case 764:
#line 5003 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 10364 "parser.c" /* yacc.c:1646  */
    break;

  case 765:
#line 5007 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 10372 "parser.c" /* yacc.c:1646  */
    break;

  case 766:
#line 5011 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 10380 "parser.c" /* yacc.c:1646  */
    break;

  case 767:
#line 5018 "parser.y" /* yacc.c:1646  */
    { sc_pause_openmp(); }
#line 10386 "parser.c" /* yacc.c:1646  */
    break;

  case 768:
#line 5019 "parser.y" /* yacc.c:1646  */
    {
      sc_start_openmp();
      (yyval.ocla) = FinalClause((yyvsp[-1].expr));
    }
#line 10395 "parser.c" /* yacc.c:1646  */
    break;

  case 769:
#line 5024 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = PlainClause(OCUNTIED);
    }
#line 10403 "parser.c" /* yacc.c:1646  */
    break;

  case 770:
#line 5028 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = PlainClause(OCMERGEABLE);
    }
#line 10411 "parser.c" /* yacc.c:1646  */
    break;

  case 771:
#line 5033 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = PriorityClause((yyvsp[-1].expr));
    }
#line 10419 "parser.c" /* yacc.c:1646  */
    break;

  case 772:
#line 5040 "parser.y" /* yacc.c:1646  */
    { sc_pause_openmp(); }
#line 10425 "parser.c" /* yacc.c:1646  */
    break;

  case 773:
#line 5041 "parser.y" /* yacc.c:1646  */
    {
      sc_start_openmp();
      (yyval.ocla) = DependClause((yyvsp[-4].type), (yyvsp[-1].oxli));
    }
#line 10434 "parser.c" /* yacc.c:1646  */
    break;

  case 774:
#line 5050 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = OC_in;
    }
#line 10442 "parser.c" /* yacc.c:1646  */
    break;

  case 775:
#line 5054 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = OC_out;
    }
#line 10450 "parser.c" /* yacc.c:1646  */
    break;

  case 776:
#line 5058 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = OC_inout;
    }
#line 10458 "parser.c" /* yacc.c:1646  */
    break;

  case 777:
#line 5065 "parser.y" /* yacc.c:1646  */
    { sc_pause_openmp(); }
#line 10464 "parser.c" /* yacc.c:1646  */
    break;

  case 778:
#line 5067 "parser.y" /* yacc.c:1646  */
    {
      sc_start_openmp();
      (yyval.ocla) = InReductionClause((yyvsp[-4].type), (yyvsp[-1].oxli));
    }
#line 10473 "parser.c" /* yacc.c:1646  */
    break;

  case 779:
#line 5076 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCPARFOR, (yyvsp[-1].odir), (yyvsp[0].stmt));
      (yyval.ocon)->l = (yyvsp[-1].odir)->l;
    }
#line 10482 "parser.c" /* yacc.c:1646  */
    break;

  case 780:
#line 5084 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCPARFOR, (yyvsp[-1].ocla));
    }
#line 10490 "parser.c" /* yacc.c:1646  */
    break;

  case 781:
#line 5091 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = NULL;
    }
#line 10498 "parser.c" /* yacc.c:1646  */
    break;

  case 782:
#line 5095 "parser.y" /* yacc.c:1646  */
    {
      #ifdef OMPI_OMP_EXT
        (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
      #else
        if ((yyvsp[0].ocla)->type==OCTAG){
          parse_warning("tag clause ignored;"
                "activate it by configuring OMPi with --enable-ext\n");
          (yyval.ocla) = (yyvsp[-1].ocla);
        }else
          (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
      #endif
    }
#line 10515 "parser.c" /* yacc.c:1646  */
    break;

  case 783:
#line 5108 "parser.y" /* yacc.c:1646  */
    {
      #ifdef OMPI_OMP_EXT
        (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
      #else
        if ((yyvsp[0].ocla)->type==OCTAG){
          parse_warning("tag clause ignored;"
                "activate it by configuring OMPi with --enable-ext\n");
          (yyval.ocla) = (yyvsp[-2].ocla);
        }else
          (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
      #endif
    }
#line 10532 "parser.c" /* yacc.c:1646  */
    break;

  case 784:
#line 5124 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 10540 "parser.c" /* yacc.c:1646  */
    break;

  case 785:
#line 5128 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 10548 "parser.c" /* yacc.c:1646  */
    break;

  case 786:
#line 5132 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 10556 "parser.c" /* yacc.c:1646  */
    break;

  case 787:
#line 5136 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 10564 "parser.c" /* yacc.c:1646  */
    break;

  case 788:
#line 5140 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 10572 "parser.c" /* yacc.c:1646  */
    break;

  case 789:
#line 5144 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 10580 "parser.c" /* yacc.c:1646  */
    break;

  case 790:
#line 5148 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 10588 "parser.c" /* yacc.c:1646  */
    break;

  case 791:
#line 5152 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 10596 "parser.c" /* yacc.c:1646  */
    break;

  case 792:
#line 5156 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 10604 "parser.c" /* yacc.c:1646  */
    break;

  case 793:
#line 5163 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCPARSECTIONS, (yyvsp[-1].odir), (yyvsp[0].stmt));
      (yyval.ocon)->l = (yyvsp[-1].odir)->l;
    }
#line 10613 "parser.c" /* yacc.c:1646  */
    break;

  case 794:
#line 5171 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCPARSECTIONS, (yyvsp[-1].ocla));
    }
#line 10621 "parser.c" /* yacc.c:1646  */
    break;

  case 795:
#line 5178 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = NULL;
    }
#line 10629 "parser.c" /* yacc.c:1646  */
    break;

  case 796:
#line 5182 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
    }
#line 10637 "parser.c" /* yacc.c:1646  */
    break;

  case 797:
#line 5186 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
    }
#line 10645 "parser.c" /* yacc.c:1646  */
    break;

  case 798:
#line 5193 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 10653 "parser.c" /* yacc.c:1646  */
    break;

  case 799:
#line 5197 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 10661 "parser.c" /* yacc.c:1646  */
    break;

  case 800:
#line 5201 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 10669 "parser.c" /* yacc.c:1646  */
    break;

  case 801:
#line 5205 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 10677 "parser.c" /* yacc.c:1646  */
    break;

  case 802:
#line 5209 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 10685 "parser.c" /* yacc.c:1646  */
    break;

  case 803:
#line 5213 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 10693 "parser.c" /* yacc.c:1646  */
    break;

  case 804:
#line 5217 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 10701 "parser.c" /* yacc.c:1646  */
    break;

  case 805:
#line 5221 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 10709 "parser.c" /* yacc.c:1646  */
    break;

  case 806:
#line 5228 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCMASTER, (yyvsp[-1].odir), (yyvsp[0].stmt));
    }
#line 10717 "parser.c" /* yacc.c:1646  */
    break;

  case 807:
#line 5235 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCMASTER, NULL);
    }
#line 10725 "parser.c" /* yacc.c:1646  */
    break;

  case 808:
#line 5242 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCCRITICAL, (yyvsp[-1].odir), (yyvsp[0].stmt));
    }
#line 10733 "parser.c" /* yacc.c:1646  */
    break;

  case 809:
#line 5249 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpCriticalDirective(NULL, NULL);
    }
#line 10741 "parser.c" /* yacc.c:1646  */
    break;

  case 810:
#line 5253 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpCriticalDirective((yyvsp[-1].symb), NULL);
    }
#line 10749 "parser.c" /* yacc.c:1646  */
    break;

  case 811:
#line 5258 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpCriticalDirective((yyvsp[-2].symb), (yyvsp[-1].ocla));
    }
#line 10757 "parser.c" /* yacc.c:1646  */
    break;

  case 812:
#line 5265 "parser.y" /* yacc.c:1646  */
    {
      (yyval.symb) = Symbol((yyvsp[-1].name));
    }
#line 10765 "parser.c" /* yacc.c:1646  */
    break;

  case 813:
#line 5273 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = HintClause((yyvsp[-1].expr));
    }
#line 10773 "parser.c" /* yacc.c:1646  */
    break;

  case 814:
#line 5280 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCBARRIER, NULL);
    }
#line 10781 "parser.c" /* yacc.c:1646  */
    break;

  case 815:
#line 5288 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCTASKWAIT, NULL);
    }
#line 10789 "parser.c" /* yacc.c:1646  */
    break;

  case 816:
#line 5296 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCTASKGROUP, (yyvsp[-1].odir), (yyvsp[0].stmt));
    }
#line 10797 "parser.c" /* yacc.c:1646  */
    break;

  case 817:
#line 5305 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCTASKGROUP, (yyvsp[-1].ocla));
    }
#line 10805 "parser.c" /* yacc.c:1646  */
    break;

  case 818:
#line 5312 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = NULL;
    }
#line 10813 "parser.c" /* yacc.c:1646  */
    break;

  case 819:
#line 5316 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
    }
#line 10821 "parser.c" /* yacc.c:1646  */
    break;

  case 820:
#line 5320 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
    }
#line 10829 "parser.c" /* yacc.c:1646  */
    break;

  case 821:
#line 5327 "parser.y" /* yacc.c:1646  */
    { sc_pause_openmp(); }
#line 10835 "parser.c" /* yacc.c:1646  */
    break;

  case 822:
#line 5329 "parser.y" /* yacc.c:1646  */
    {
      sc_start_openmp();
      (yyval.ocla) = TaskReductionClause((yyvsp[-4].type), (yyvsp[-1].oxli));
    }
#line 10844 "parser.c" /* yacc.c:1646  */
    break;

  case 823:
#line 5338 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCTASKYIELD, NULL);
    }
#line 10852 "parser.c" /* yacc.c:1646  */
    break;

  case 824:
#line 5345 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCATOMIC, (yyvsp[-1].odir), (yyvsp[0].stmt));
    }
#line 10860 "parser.c" /* yacc.c:1646  */
    break;

  case 825:
#line 5356 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCATOMIC, NULL);  //TODO Check how to do it since it now has 2 clauses
    }
#line 10868 "parser.c" /* yacc.c:1646  */
    break;

  case 826:
#line 5364 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCMASKED, (yyvsp[-1].odir), (yyvsp[0].stmt));
    }
#line 10876 "parser.c" /* yacc.c:1646  */
    break;

  case 827:
#line 5371 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCMASKED, (yyvsp[-1].ocla));
    }
#line 10884 "parser.c" /* yacc.c:1646  */
    break;

  case 828:
#line 5378 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = NULL;
    }
#line 10892 "parser.c" /* yacc.c:1646  */
    break;

  case 829:
#line 5382 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 10900 "parser.c" /* yacc.c:1646  */
    break;

  case 830:
#line 5391 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = NULL;
    }
#line 10908 "parser.c" /* yacc.c:1646  */
    break;

  case 831:
#line 5395 "parser.y" /* yacc.c:1646  */
    {
      //$$ = TODO
    }
#line 10916 "parser.c" /* yacc.c:1646  */
    break;

  case 832:
#line 5399 "parser.y" /* yacc.c:1646  */
    {
      //$$ = TODO
    }
#line 10924 "parser.c" /* yacc.c:1646  */
    break;

  case 833:
#line 5403 "parser.y" /* yacc.c:1646  */
    {
      //$$ = TODO
    }
#line 10932 "parser.c" /* yacc.c:1646  */
    break;

  case 834:
#line 5407 "parser.y" /* yacc.c:1646  */
    {
      //$$ = TODO
    }
#line 10940 "parser.c" /* yacc.c:1646  */
    break;

  case 835:
#line 5415 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = NULL;
    }
#line 10948 "parser.c" /* yacc.c:1646  */
    break;

  case 836:
#line 5419 "parser.y" /* yacc.c:1646  */
    {
      //$$ = TODO
    }
#line 10956 "parser.c" /* yacc.c:1646  */
    break;

  case 837:
#line 5426 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpFlushDirective(NULL);
    }
#line 10964 "parser.c" /* yacc.c:1646  */
    break;

  case 838:
#line 5430 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpFlushDirective((yyvsp[-1].decl));
    }
#line 10972 "parser.c" /* yacc.c:1646  */
    break;

  case 839:
#line 5436 "parser.y" /* yacc.c:1646  */
    { sc_pause_openmp(); }
#line 10978 "parser.c" /* yacc.c:1646  */
    break;

  case 840:
#line 5437 "parser.y" /* yacc.c:1646  */
    {
      sc_start_openmp();
      (yyval.decl) = (yyvsp[-1].decl);
    }
#line 10987 "parser.c" /* yacc.c:1646  */
    break;

  case 841:
#line 5445 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCORDERED, (yyvsp[-1].odir), (yyvsp[0].stmt));
    }
#line 10995 "parser.c" /* yacc.c:1646  */
    break;

  case 842:
#line 5449 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocon) = OmpConstruct(DCORDERED, (yyvsp[0].odir), NULL);
    }
#line 11003 "parser.c" /* yacc.c:1646  */
    break;

  case 843:
#line 5456 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCORDERED, (yyvsp[-1].ocla));
    }
#line 11011 "parser.c" /* yacc.c:1646  */
    break;

  case 844:
#line 5463 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCORDERED, DependClause(OC_source,NULL));
    }
#line 11019 "parser.c" /* yacc.c:1646  */
    break;

  case 845:
#line 5467 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCORDERED, (yyvsp[-1].ocla));
    }
#line 11027 "parser.c" /* yacc.c:1646  */
    break;

  case 846:
#line 5475 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = NULL;
    }
#line 11035 "parser.c" /* yacc.c:1646  */
    break;

  case 847:
#line 5479 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
    }
#line 11043 "parser.c" /* yacc.c:1646  */
    break;

  case 848:
#line 5483 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
    }
#line 11051 "parser.c" /* yacc.c:1646  */
    break;

  case 849:
#line 5491 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = PlainClause(OCTHREADS);
    }
#line 11059 "parser.c" /* yacc.c:1646  */
    break;

  case 850:
#line 5495 "parser.y" /* yacc.c:1646  */
    {
      //TODO
    }
#line 11067 "parser.c" /* yacc.c:1646  */
    break;

  case 851:
#line 5503 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = (yyvsp[0].ocla);
    }
#line 11075 "parser.c" /* yacc.c:1646  */
    break;

  case 852:
#line 5507 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-1].ocla), (yyvsp[0].ocla));
    }
#line 11083 "parser.c" /* yacc.c:1646  */
    break;

  case 853:
#line 5511 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = OmpClauseList((yyvsp[-2].ocla), (yyvsp[0].ocla));
    }
#line 11091 "parser.c" /* yacc.c:1646  */
    break;

  case 854:
#line 5519 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = DependClause(OC_sink, NULL);
      (yyval.ocla)->u.expr = (yyvsp[-1].expr);
    }
#line 11100 "parser.c" /* yacc.c:1646  */
    break;

  case 855:
#line 5527 "parser.y" /* yacc.c:1646  */
    {
      (yyval.expr) = (yyvsp[0].expr);
    }
#line 11108 "parser.c" /* yacc.c:1646  */
    break;

  case 856:
#line 5531 "parser.y" /* yacc.c:1646  */
    { 
      (yyval.expr) = CommaList((yyvsp[-2].expr), (yyvsp[0].expr));
    }
#line 11116 "parser.c" /* yacc.c:1646  */
    break;

  case 857:
#line 5538 "parser.y" /* yacc.c:1646  */
    {
      if (checkDecls)
        check_uknown_var((yyvsp[0].name));
      (yyval.expr) = BinaryOperator(BOP_add, IdentName((yyvsp[0].name)), ZeroExpr());
    }
#line 11126 "parser.c" /* yacc.c:1646  */
    break;

  case 858:
#line 5544 "parser.y" /* yacc.c:1646  */
    {
      if (checkDecls)
        check_uknown_var((yyvsp[-2].name));
      (yyval.expr) = BinaryOperator(BOP_add, IdentName((yyvsp[-2].name)), (yyvsp[0].expr));
    }
#line 11136 "parser.c" /* yacc.c:1646  */
    break;

  case 859:
#line 5550 "parser.y" /* yacc.c:1646  */
    {
      if (checkDecls)
        check_uknown_var((yyvsp[-2].name));
      (yyval.expr) = BinaryOperator(BOP_sub, IdentName((yyvsp[-2].name)), (yyvsp[0].expr));
    }
#line 11146 "parser.c" /* yacc.c:1646  */
    break;

  case 860:
#line 5560 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCCANCEL, (yyvsp[-1].ocla));
    }
#line 11154 "parser.c" /* yacc.c:1646  */
    break;

  case 861:
#line 5564 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCCANCEL, OmpClauseList((yyvsp[-2].ocla), (yyvsp[-1].ocla)));
    }
#line 11162 "parser.c" /* yacc.c:1646  */
    break;

  case 862:
#line 5568 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCCANCEL, OmpClauseList((yyvsp[-3].ocla), (yyvsp[-1].ocla)));
    }
#line 11170 "parser.c" /* yacc.c:1646  */
    break;

  case 863:
#line 5575 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = PlainClause(OCPARALLEL);
    }
#line 11178 "parser.c" /* yacc.c:1646  */
    break;

  case 864:
#line 5579 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = PlainClause(OCSECTIONS);
    }
#line 11186 "parser.c" /* yacc.c:1646  */
    break;

  case 865:
#line 5583 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = PlainClause(OCFOR);
    }
#line 11194 "parser.c" /* yacc.c:1646  */
    break;

  case 866:
#line 5587 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = PlainClause(OCTASKGROUP);
    }
#line 11202 "parser.c" /* yacc.c:1646  */
    break;

  case 867:
#line 5595 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpDirective(DCCANCELLATIONPOINT, (yyvsp[-1].ocla));
    }
#line 11210 "parser.c" /* yacc.c:1646  */
    break;

  case 868:
#line 5601 "parser.y" /* yacc.c:1646  */
    { sc_pause_openmp(); }
#line 11216 "parser.c" /* yacc.c:1646  */
    break;

  case 869:
#line 5601 "parser.y" /* yacc.c:1646  */
    { sc_start_openmp(); }
#line 11222 "parser.c" /* yacc.c:1646  */
    break;

  case 870:
#line 5602 "parser.y" /* yacc.c:1646  */
    {
      (yyval.odir) = OmpThreadprivateDirective((yyvsp[-3].decl));
    }
#line 11230 "parser.c" /* yacc.c:1646  */
    break;

  case 871:
#line 5609 "parser.y" /* yacc.c:1646  */
    { sc_pause_openmp(); }
#line 11236 "parser.c" /* yacc.c:1646  */
    break;

  case 872:
#line 5609 "parser.y" /* yacc.c:1646  */
    { sc_start_openmp(); }
#line 11242 "parser.c" /* yacc.c:1646  */
    break;

  case 873:
#line 5610 "parser.y" /* yacc.c:1646  */
    {
      //$$ = TODO
    }
#line 11250 "parser.c" /* yacc.c:1646  */
    break;

  case 874:
#line 5617 "parser.y" /* yacc.c:1646  */
    {
      parse_error(1, "user-defined reductions are not implemented yet.\n");
      //$$ = OC_identifier TODO
      //Symbol($2);  TODO
    }
#line 11260 "parser.c" /* yacc.c:1646  */
    break;

  case 875:
#line 5624 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = OC_plus;
    }
#line 11268 "parser.c" /* yacc.c:1646  */
    break;

  case 876:
#line 5628 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = OC_times;
    }
#line 11276 "parser.c" /* yacc.c:1646  */
    break;

  case 877:
#line 5632 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = OC_minus;
    }
#line 11284 "parser.c" /* yacc.c:1646  */
    break;

  case 878:
#line 5636 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = OC_band;
    }
#line 11292 "parser.c" /* yacc.c:1646  */
    break;

  case 879:
#line 5640 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = OC_xor;
    }
#line 11300 "parser.c" /* yacc.c:1646  */
    break;

  case 880:
#line 5644 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = OC_bor;
    }
#line 11308 "parser.c" /* yacc.c:1646  */
    break;

  case 881:
#line 5648 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = OC_land;
    }
#line 11316 "parser.c" /* yacc.c:1646  */
    break;

  case 882:
#line 5652 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = OC_lor;
    }
#line 11324 "parser.c" /* yacc.c:1646  */
    break;

  case 883:
#line 5656 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = OC_min;
    }
#line 11332 "parser.c" /* yacc.c:1646  */
    break;

  case 884:
#line 5660 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = OC_max;
    }
#line 11340 "parser.c" /* yacc.c:1646  */
    break;

  case 885:
#line 5667 "parser.y" /* yacc.c:1646  */
    {
      //TODO
    }
#line 11348 "parser.c" /* yacc.c:1646  */
    break;

  case 886:
#line 5671 "parser.y" /* yacc.c:1646  */
    {
      //TODO
    }
#line 11356 "parser.c" /* yacc.c:1646  */
    break;

  case 887:
#line 5678 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = NULL;
    }
#line 11364 "parser.c" /* yacc.c:1646  */
    break;

  case 888:
#line 5682 "parser.y" /* yacc.c:1646  */
    {
        //TODO must check if identifier is omp_priv and that conditional
        //expression contains only omp_priv and omp_orig variables
    }
#line 11373 "parser.c" /* yacc.c:1646  */
    break;

  case 889:
#line 5687 "parser.y" /* yacc.c:1646  */
    {
      //TODO in argument_expression_list one of the variables must be &omp_priv
      // TODO check ox_funccall_expression
      //$$ = strcmp($1, "main") ?
      //       FunctionCall(IdentName($1), $3) :
      //       FunctionCall(IdentName(MAIN_NEWNAME), $3);
    }
#line 11385 "parser.c" /* yacc.c:1646  */
    break;

  case 890:
#line 5698 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = DefaultClause(OC_defshared);
    }
#line 11393 "parser.c" /* yacc.c:1646  */
    break;

  case 891:
#line 5702 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = DefaultClause(OC_defnone);
    }
#line 11401 "parser.c" /* yacc.c:1646  */
    break;

  case 892:
#line 5707 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = DefaultClause(OC_auto); //I'm using the existing subtype (Alexandros)
    }
#line 11409 "parser.c" /* yacc.c:1646  */
    break;

  case 893:
#line 5713 "parser.y" /* yacc.c:1646  */
    { sc_pause_openmp(); }
#line 11415 "parser.c" /* yacc.c:1646  */
    break;

  case 894:
#line 5714 "parser.y" /* yacc.c:1646  */
    {
      sc_start_openmp();
      (yyval.ocla) = VarlistClause(OCPRIVATE, (yyvsp[-1].decl));
    }
#line 11424 "parser.c" /* yacc.c:1646  */
    break;

  case 895:
#line 5721 "parser.y" /* yacc.c:1646  */
    { sc_pause_openmp(); }
#line 11430 "parser.c" /* yacc.c:1646  */
    break;

  case 896:
#line 5722 "parser.y" /* yacc.c:1646  */
    {
      sc_start_openmp();
      (yyval.ocla) = VarlistClause(OCFIRSTPRIVATE, (yyvsp[-1].decl));
    }
#line 11439 "parser.c" /* yacc.c:1646  */
    break;

  case 897:
#line 5729 "parser.y" /* yacc.c:1646  */
    { sc_pause_openmp(); }
#line 11445 "parser.c" /* yacc.c:1646  */
    break;

  case 898:
#line 5730 "parser.y" /* yacc.c:1646  */
    {
      sc_start_openmp();
      (yyval.ocla) = VarlistClause(OCLASTPRIVATE, (yyvsp[-1].decl));
    }
#line 11454 "parser.c" /* yacc.c:1646  */
    break;

  case 899:
#line 5737 "parser.y" /* yacc.c:1646  */
    { sc_pause_openmp(); }
#line 11460 "parser.c" /* yacc.c:1646  */
    break;

  case 900:
#line 5738 "parser.y" /* yacc.c:1646  */
    {
      sc_start_openmp();
      (yyval.ocla) = VarlistClause(OCSHARED, (yyvsp[-1].decl));
    }
#line 11469 "parser.c" /* yacc.c:1646  */
    break;

  case 901:
#line 5745 "parser.y" /* yacc.c:1646  */
    { sc_pause_openmp(); }
#line 11475 "parser.c" /* yacc.c:1646  */
    break;

  case 902:
#line 5747 "parser.y" /* yacc.c:1646  */
    {
      sc_start_openmp();
      (yyval.ocla) = ReductionClause((yyvsp[-4].type), (yyvsp[-1].oxli), OCM_none);
    }
#line 11484 "parser.c" /* yacc.c:1646  */
    break;

  case 903:
#line 5753 "parser.y" /* yacc.c:1646  */
    { sc_pause_openmp(); }
#line 11490 "parser.c" /* yacc.c:1646  */
    break;

  case 904:
#line 5754 "parser.y" /* yacc.c:1646  */
    {
      sc_start_openmp();
      (yyval.ocla) = ReductionClause((yyvsp[-4].type), (yyvsp[-1].oxli), (yyvsp[-6].type));
    }
#line 11499 "parser.c" /* yacc.c:1646  */
    break;

  case 905:
#line 5762 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = OCM_none;
    }
#line 11507 "parser.c" /* yacc.c:1646  */
    break;

  case 906:
#line 5766 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = OCM_default;
    }
#line 11515 "parser.c" /* yacc.c:1646  */
    break;

  case 907:
#line 5770 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = OCM_task;
    }
#line 11523 "parser.c" /* yacc.c:1646  */
    break;

  case 908:
#line 5774 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = OCM_inscan;
    }
#line 11531 "parser.c" /* yacc.c:1646  */
    break;

  case 909:
#line 5780 "parser.y" /* yacc.c:1646  */
    { sc_pause_openmp(); }
#line 11537 "parser.c" /* yacc.c:1646  */
    break;

  case 910:
#line 5781 "parser.y" /* yacc.c:1646  */
    {
      sc_start_openmp();
      (yyval.ocla) = IfClause((yyvsp[-1].expr), OCM_none);
    }
#line 11546 "parser.c" /* yacc.c:1646  */
    break;

  case 911:
#line 5786 "parser.y" /* yacc.c:1646  */
    { sc_pause_openmp(); }
#line 11552 "parser.c" /* yacc.c:1646  */
    break;

  case 912:
#line 5787 "parser.y" /* yacc.c:1646  */
    {
      sc_start_openmp();
      (yyval.ocla) = IfClause((yyvsp[-1].expr), (yyvsp[-4].type));
    }
#line 11561 "parser.c" /* yacc.c:1646  */
    break;

  case 913:
#line 5794 "parser.y" /* yacc.c:1646  */
    { (yyval.type) = OCM_parallel; }
#line 11567 "parser.c" /* yacc.c:1646  */
    break;

  case 914:
#line 5795 "parser.y" /* yacc.c:1646  */
    { (yyval.type) = OCM_task; }
#line 11573 "parser.c" /* yacc.c:1646  */
    break;

  case 915:
#line 5796 "parser.y" /* yacc.c:1646  */
    { (yyval.type) = OCM_target; }
#line 11579 "parser.c" /* yacc.c:1646  */
    break;

  case 916:
#line 5797 "parser.y" /* yacc.c:1646  */
    { (yyval.type) = OCM_targetdata; }
#line 11585 "parser.c" /* yacc.c:1646  */
    break;

  case 917:
#line 5798 "parser.y" /* yacc.c:1646  */
    { (yyval.type) = OCM_targetenterdata; }
#line 11591 "parser.c" /* yacc.c:1646  */
    break;

  case 918:
#line 5799 "parser.y" /* yacc.c:1646  */
    { (yyval.type) = OCM_targetexitdata; }
#line 11597 "parser.c" /* yacc.c:1646  */
    break;

  case 919:
#line 5800 "parser.y" /* yacc.c:1646  */
    { (yyval.type) = OCM_targetupdate; }
#line 11603 "parser.c" /* yacc.c:1646  */
    break;

  case 920:
#line 5801 "parser.y" /* yacc.c:1646  */
    { (yyval.type) = OCM_cancel; }
#line 11609 "parser.c" /* yacc.c:1646  */
    break;

  case 921:
#line 5802 "parser.y" /* yacc.c:1646  */
    { (yyval.type) = OCM_simd; }
#line 11615 "parser.c" /* yacc.c:1646  */
    break;

  case 922:
#line 5807 "parser.y" /* yacc.c:1646  */
    {
      int n = 0, er = 0;
      if (xar_expr_is_constant((yyvsp[-1].expr)))
      {
        n = xar_calc_int_expr((yyvsp[-1].expr), &er);
        if (er) n = 0;
      }
      if (n <= 0)
        parse_error(1, "invalid number in collapse() clause.\n");
      (yyval.ocla) = CollapseClause(n);
    }
#line 11631 "parser.c" /* yacc.c:1646  */
    break;

  case 923:
#line 5822 "parser.y" /* yacc.c:1646  */
    {
      if (checkDecls)
        if (symtab_get(stab, Symbol((yyvsp[0].name)), IDNAME) == NULL)
          parse_error(-1, "unknown identifier `%s'.\n", (yyvsp[0].name));
      (yyval.decl) = IdentifierDecl( Symbol((yyvsp[0].name)) );
    }
#line 11642 "parser.c" /* yacc.c:1646  */
    break;

  case 924:
#line 5829 "parser.y" /* yacc.c:1646  */
    {
      if (checkDecls)
        if (symtab_get(stab, Symbol((yyvsp[0].name)), IDNAME) == NULL)
          parse_error(-1, "unknown identifier `%s'.\n", (yyvsp[0].name));
      (yyval.decl) = IdList((yyvsp[-2].decl), IdentifierDecl( Symbol((yyvsp[0].name)) ));
    }
#line 11653 "parser.c" /* yacc.c:1646  */
    break;

  case 925:
#line 5839 "parser.y" /* yacc.c:1646  */
    {
      (yyval.oxli) = (yyvsp[0].oxli);
    }
#line 11661 "parser.c" /* yacc.c:1646  */
    break;

  case 926:
#line 5843 "parser.y" /* yacc.c:1646  */
    {
      ompxli l = (yyvsp[-2].oxli);
      
      for (; l->next; l = l->next) ;  /* Till the end */
      l->next = (yyvsp[0].oxli);
      (yyval.oxli) = (yyvsp[-2].oxli);
    }
#line 11673 "parser.c" /* yacc.c:1646  */
    break;

  case 927:
#line 5854 "parser.y" /* yacc.c:1646  */
    {
      if (checkDecls)
        if (symtab_get(stab, Symbol((yyvsp[0].name)), IDNAME) == NULL)
          parse_error(-1, "unknown identifier `%s'.\n", (yyvsp[0].name));
      (yyval.oxli) = PlainXLI( Symbol((yyvsp[0].name)) );
    }
#line 11684 "parser.c" /* yacc.c:1646  */
    break;

  case 928:
#line 5861 "parser.y" /* yacc.c:1646  */
    {
      if (checkDecls)
        if (symtab_get(stab, Symbol((yyvsp[-1].name)), IDNAME) == NULL)
          parse_error(-1, "unknown identifier `%s'.\n", (yyvsp[-1].name));
      (yyval.oxli) = ArraySection( Symbol((yyvsp[-1].name)), (yyvsp[0].oasd) );
    }
#line 11695 "parser.c" /* yacc.c:1646  */
    break;

  case 929:
#line 5875 "parser.y" /* yacc.c:1646  */
    {
      (yyval.oxli) = (yyvsp[0].oxli);
    }
#line 11703 "parser.c" /* yacc.c:1646  */
    break;

  case 930:
#line 5879 "parser.y" /* yacc.c:1646  */
    {
      ompxli l = (yyvsp[-2].oxli);
      
      for (; l->next; l = l->next) ;  /* Till the end */
      l->next = (yyvsp[0].oxli);
      (yyval.oxli) = (yyvsp[-2].oxli);
    }
#line 11715 "parser.c" /* yacc.c:1646  */
    break;

  case 931:
#line 5890 "parser.y" /* yacc.c:1646  */
    {
      /* No check for known identifiers since constuct can be anywhere */
      (yyval.oxli) = PlainXLI( Symbol((yyvsp[0].name)) );
    }
#line 11724 "parser.c" /* yacc.c:1646  */
    break;

  case 932:
#line 5895 "parser.y" /* yacc.c:1646  */
    {
      /* No check for known identifiers since constuct can be anywhere */
      (yyval.oxli) = ArraySection( Symbol((yyvsp[-1].name)), (yyvsp[0].oasd) );
    }
#line 11733 "parser.c" /* yacc.c:1646  */
    break;

  case 933:
#line 5902 "parser.y" /* yacc.c:1646  */
    { sc_pause_openmp(); }
#line 11739 "parser.c" /* yacc.c:1646  */
    break;

  case 934:
#line 5903 "parser.y" /* yacc.c:1646  */
    {
      omparrdim d = (yyvsp[-4].oasd);
      
      sc_start_openmp();
      for (; d->next; d = d->next) ;  /* Till the end */
      d->next = (yyvsp[-1].oasd);
      (yyval.oasd) = (yyvsp[-4].oasd);
    }
#line 11752 "parser.c" /* yacc.c:1646  */
    break;

  case 935:
#line 5911 "parser.y" /* yacc.c:1646  */
    { sc_pause_openmp(); }
#line 11758 "parser.c" /* yacc.c:1646  */
    break;

  case 936:
#line 5912 "parser.y" /* yacc.c:1646  */
    {
      sc_start_openmp();
      (yyval.oasd) = (yyvsp[-1].oasd);
    }
#line 11767 "parser.c" /* yacc.c:1646  */
    break;

  case 937:
#line 5920 "parser.y" /* yacc.c:1646  */
    {
      (yyval.oasd) = OmpArrDim((yyvsp[-2].expr), (yyvsp[0].expr));
    }
#line 11775 "parser.c" /* yacc.c:1646  */
    break;

  case 938:
#line 5924 "parser.y" /* yacc.c:1646  */
    {
      (yyval.oasd) = OmpArrDim((yyvsp[-1].expr), NULL);
    }
#line 11783 "parser.c" /* yacc.c:1646  */
    break;

  case 939:
#line 5928 "parser.y" /* yacc.c:1646  */
    {
      (yyval.oasd) = OmpArrDim((yyvsp[0].expr), OneExpr());
    }
#line 11791 "parser.c" /* yacc.c:1646  */
    break;

  case 940:
#line 5932 "parser.y" /* yacc.c:1646  */
    {
      (yyval.oasd) = OmpArrDim(ZeroExpr(), (yyvsp[0].expr));
    }
#line 11799 "parser.c" /* yacc.c:1646  */
    break;

  case 941:
#line 5936 "parser.y" /* yacc.c:1646  */
    {
      (yyval.oasd) = OmpArrDim(ZeroExpr(), NULL);
    }
#line 11807 "parser.c" /* yacc.c:1646  */
    break;

  case 942:
#line 5944 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = ProcBindClause(OC_bindmaster);
    }
#line 11815 "parser.c" /* yacc.c:1646  */
    break;

  case 943:
#line 5948 "parser.y" /* yacc.c:1646  */
    {	
      (yyval.ocla) = ProcBindClause(OC_bindprimary);
    }
#line 11823 "parser.c" /* yacc.c:1646  */
    break;

  case 944:
#line 5952 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = ProcBindClause(OC_bindclose);
    }
#line 11831 "parser.c" /* yacc.c:1646  */
    break;

  case 945:
#line 5956 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = ProcBindClause(OC_bindspread);
    }
#line 11839 "parser.c" /* yacc.c:1646  */
    break;

  case 946:
#line 5968 "parser.y" /* yacc.c:1646  */
    {
      if (checkDecls)
      {
        stentry e = symtab_get(stab, Symbol((yyvsp[0].name)), IDNAME);
        if (e == NULL)
          parse_error(-1, "unknown identifier `%s'.\n", (yyvsp[0].name));
        if (e->scopelevel != stab->scopelevel)
          parse_error(-1, "threadprivate directive appears at different "
                          "scope level\nfrom the one `%s' was declared.\n", (yyvsp[0].name));
        if (stab->scopelevel > 0)    /* Don't care for globals */
          if (speclist_getspec(e->spec, STCLASSSPEC, SPEC_static) == NULL)
            parse_error(-1, "threadprivate variable `%s' does not have static "
                            "storage type.\n", (yyvsp[0].name));
        e->isthrpriv = true;   /* Mark */
      }
      (yyval.decl) = IdentifierDecl( Symbol((yyvsp[0].name)) );
    }
#line 11861 "parser.c" /* yacc.c:1646  */
    break;

  case 947:
#line 5986 "parser.y" /* yacc.c:1646  */
    {
      if (checkDecls)
      {
        stentry e = symtab_get(stab, Symbol((yyvsp[0].name)), IDNAME);
        if (e == NULL)
          parse_error(-1, "unknown identifier `%s'.\n", (yyvsp[0].name));
        if (e->scopelevel != stab->scopelevel)
          parse_error(-1, "threadprivate directive appears at different "
                          "scope level\nfrom the one `%s' was declared.\n", (yyvsp[0].name));
        if (stab->scopelevel > 0)    /* Don't care for globals */
          if (speclist_getspec(e->spec, STCLASSSPEC, SPEC_static) == NULL)
            parse_error(-1, "threadprivate variable `%s' does not have static "
                            "storage type.\n", (yyvsp[0].name));
        e->isthrpriv = true;   /* Mark */
      }
      (yyval.decl) = IdList((yyvsp[-2].decl), IdentifierDecl( Symbol((yyvsp[0].name)) ));
    }
#line 11883 "parser.c" /* yacc.c:1646  */
    break;

  case 948:
#line 6019 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcon) = OmpixConstruct(OX_DCTASKSYNC, (yyvsp[0].xdir), NULL);
    }
#line 11891 "parser.c" /* yacc.c:1646  */
    break;

  case 949:
#line 6023 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcon) = OmpixConstruct(OX_DCTASKSCHEDULE, (yyvsp[0].xdir), NULL);
    }
#line 11899 "parser.c" /* yacc.c:1646  */
    break;

  case 950:
#line 6030 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xdir) = OmpixDirective(OX_DCTASKSYNC, NULL);
    }
#line 11907 "parser.c" /* yacc.c:1646  */
    break;

  case 951:
#line 6037 "parser.y" /* yacc.c:1646  */
    {
      scope_start(stab);
    }
#line 11915 "parser.c" /* yacc.c:1646  */
    break;

  case 952:
#line 6041 "parser.y" /* yacc.c:1646  */
    {
      scope_end(stab);
      (yyval.xdir) = OmpixDirective(OX_DCTASKSCHEDULE, (yyvsp[-1].xcla));
    }
#line 11924 "parser.c" /* yacc.c:1646  */
    break;

  case 953:
#line 6049 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcla) = NULL;
    }
#line 11932 "parser.c" /* yacc.c:1646  */
    break;

  case 954:
#line 6053 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcla) = OmpixClauseList((yyvsp[-1].xcla), (yyvsp[0].xcla));
    }
#line 11940 "parser.c" /* yacc.c:1646  */
    break;

  case 955:
#line 6057 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcla) = OmpixClauseList((yyvsp[-2].xcla), (yyvsp[0].xcla));
    }
#line 11948 "parser.c" /* yacc.c:1646  */
    break;

  case 956:
#line 6064 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcla) = OmpixStrideClause((yyvsp[-1].expr));
    }
#line 11956 "parser.c" /* yacc.c:1646  */
    break;

  case 957:
#line 6068 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcla) = OmpixStartClause((yyvsp[-1].expr));
    }
#line 11964 "parser.c" /* yacc.c:1646  */
    break;

  case 958:
#line 6072 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcla) = OmpixScopeClause((yyvsp[-1].type));
    }
#line 11972 "parser.c" /* yacc.c:1646  */
    break;

  case 959:
#line 6076 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcla) = OmpixPlainClause(OX_OCTIED);
    }
#line 11980 "parser.c" /* yacc.c:1646  */
    break;

  case 960:
#line 6080 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcla) = OmpixPlainClause(OX_OCUNTIED);
    }
#line 11988 "parser.c" /* yacc.c:1646  */
    break;

  case 961:
#line 6087 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = OX_SCOPE_NODES;
    }
#line 11996 "parser.c" /* yacc.c:1646  */
    break;

  case 962:
#line 6091 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = OX_SCOPE_WGLOBAL;
    }
#line 12004 "parser.c" /* yacc.c:1646  */
    break;

  case 963:
#line 6095 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = OX_SCOPE_WGLOBAL;
    }
#line 12012 "parser.c" /* yacc.c:1646  */
    break;

  case 964:
#line 6099 "parser.y" /* yacc.c:1646  */
    {
      (yyval.type) = OX_SCOPE_WLOCAL;
    }
#line 12020 "parser.c" /* yacc.c:1646  */
    break;

  case 965:
#line 6106 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcon) = (yyvsp[0].xcon);
    }
#line 12028 "parser.c" /* yacc.c:1646  */
    break;

  case 966:
#line 6110 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcon) = (yyvsp[0].xcon);
    }
#line 12036 "parser.c" /* yacc.c:1646  */
    break;

  case 967:
#line 6114 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcon) = (yyvsp[0].xcon);
    }
#line 12044 "parser.c" /* yacc.c:1646  */
    break;

  case 968:
#line 6118 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcon) = (yyvsp[0].xcon);
    }
#line 12052 "parser.c" /* yacc.c:1646  */
    break;

  case 969:
#line 6126 "parser.y" /* yacc.c:1646  */
    {
      /* Should put the name of the callback function in the stab, too
      if (symtab_get(stab, decl_getidentifier_symbol($2->u.declaration.decl),
            FUNCNAME) == NULL)
        symtab_put(stab, decl_getidentifier_symbol($2->u.declaration.spec),
            FUNCNAME);
      */
      scope_start(stab);   /* re-declare the arguments of the task function */
      ast_declare_function_params((yyvsp[0].stmt)->u.declaration.decl);
    }
#line 12067 "parser.c" /* yacc.c:1646  */
    break;

  case 970:
#line 6137 "parser.y" /* yacc.c:1646  */
    {
      scope_end(stab);
      (yyval.xcon) = OmpixTaskdef((yyvsp[-3].xdir), (yyvsp[-2].stmt), (yyvsp[0].stmt));
      (yyval.xcon)->l = (yyvsp[-3].xdir)->l;
    }
#line 12077 "parser.c" /* yacc.c:1646  */
    break;

  case 971:
#line 6143 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcon) = OmpixTaskdef((yyvsp[-1].xdir), (yyvsp[0].stmt), NULL);
      (yyval.xcon)->l = (yyvsp[-1].xdir)->l;
    }
#line 12086 "parser.c" /* yacc.c:1646  */
    break;

  case 972:
#line 6151 "parser.y" /* yacc.c:1646  */
    {
      scope_start(stab);
    }
#line 12094 "parser.c" /* yacc.c:1646  */
    break;

  case 973:
#line 6155 "parser.y" /* yacc.c:1646  */
    {
      scope_end(stab);
      (yyval.xdir) = OmpixDirective(OX_DCTASKDEF, (yyvsp[-1].xcla));
    }
#line 12103 "parser.c" /* yacc.c:1646  */
    break;

  case 974:
#line 6163 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcla) = NULL;
    }
#line 12111 "parser.c" /* yacc.c:1646  */
    break;

  case 975:
#line 6167 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcla) = OmpixClauseList((yyvsp[-1].xcla), (yyvsp[0].xcla));
    }
#line 12119 "parser.c" /* yacc.c:1646  */
    break;

  case 976:
#line 6171 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcla) = OmpixClauseList((yyvsp[-2].xcla), (yyvsp[0].xcla));
    }
#line 12127 "parser.c" /* yacc.c:1646  */
    break;

  case 977:
#line 6178 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcla) = OmpixVarlistClause(OX_OCIN, (yyvsp[-1].decl));
    }
#line 12135 "parser.c" /* yacc.c:1646  */
    break;

  case 978:
#line 6182 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcla) = OmpixVarlistClause(OX_OCOUT, (yyvsp[-1].decl));
    }
#line 12143 "parser.c" /* yacc.c:1646  */
    break;

  case 979:
#line 6186 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcla) = OmpixVarlistClause(OX_OCINOUT, (yyvsp[-1].decl));
    }
#line 12151 "parser.c" /* yacc.c:1646  */
    break;

  case 980:
#line 6190 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcla) = OmpixReductionClause((yyvsp[-3].type), (yyvsp[-1].decl));
    }
#line 12159 "parser.c" /* yacc.c:1646  */
    break;

  case 981:
#line 6197 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = (yyvsp[0].decl);
    }
#line 12167 "parser.c" /* yacc.c:1646  */
    break;

  case 982:
#line 6201 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = IdList((yyvsp[-2].decl), (yyvsp[0].decl));
    }
#line 12175 "parser.c" /* yacc.c:1646  */
    break;

  case 983:
#line 6208 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = IdentifierDecl( Symbol((yyvsp[0].name)) );
      symtab_put(stab, Symbol((yyvsp[0].name)), IDNAME);
    }
#line 12184 "parser.c" /* yacc.c:1646  */
    break;

  case 984:
#line 6213 "parser.y" /* yacc.c:1646  */
    {
      if (checkDecls) check_uknown_var((yyvsp[-1].name));
      /* Use extern to differentiate */
      (yyval.decl) = ArrayDecl(IdentifierDecl( Symbol((yyvsp[-4].name)) ), StClassSpec(SPEC_extern),
                     IdentName((yyvsp[-1].name)));
      symtab_put(stab, Symbol((yyvsp[-4].name)), IDNAME);
    }
#line 12196 "parser.c" /* yacc.c:1646  */
    break;

  case 985:
#line 6221 "parser.y" /* yacc.c:1646  */
    {
      (yyval.decl) = ArrayDecl(IdentifierDecl( Symbol((yyvsp[-3].name)) ), NULL, (yyvsp[-1].expr));
      symtab_put(stab, Symbol((yyvsp[-3].name)), IDNAME);
    }
#line 12205 "parser.c" /* yacc.c:1646  */
    break;

  case 986:
#line 6229 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcon) = OmpixConstruct(OX_DCTASK, (yyvsp[-5].xdir), 
             FuncCallStmt(IdentName(strcmp((yyvsp[-4].name),"main") ? (yyvsp[-4].name) : MAIN_NEWNAME),(yyvsp[-2].expr)));
      (yyval.xcon)->l = (yyvsp[-5].xdir)->l;
    }
#line 12215 "parser.c" /* yacc.c:1646  */
    break;

  case 987:
#line 6238 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xdir) = OmpixDirective(OX_DCTASK, (yyvsp[-1].xcla));
    }
#line 12223 "parser.c" /* yacc.c:1646  */
    break;

  case 988:
#line 6245 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcla) = NULL;
    }
#line 12231 "parser.c" /* yacc.c:1646  */
    break;

  case 989:
#line 6249 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcla) = OmpixClauseList((yyvsp[-1].xcla), (yyvsp[0].xcla));
    }
#line 12239 "parser.c" /* yacc.c:1646  */
    break;

  case 990:
#line 6253 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcla) = OmpixClauseList((yyvsp[-2].xcla), (yyvsp[0].xcla));
    }
#line 12247 "parser.c" /* yacc.c:1646  */
    break;

  case 991:
#line 6260 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcla) = OmpixPlainClause(OX_OCATALL);
    }
#line 12255 "parser.c" /* yacc.c:1646  */
    break;

  case 992:
#line 6264 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcla) = OmpixAtnodeClause((yyvsp[-1].expr));
    }
#line 12263 "parser.c" /* yacc.c:1646  */
    break;

  case 993:
#line 6268 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcla) = OmpixPlainClause(OX_OCLOCAL);
    }
#line 12271 "parser.c" /* yacc.c:1646  */
    break;

  case 994:
#line 6272 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcla) = OmpixPlainClause(OX_OCREMOTE);
    }
#line 12279 "parser.c" /* yacc.c:1646  */
    break;

  case 995:
#line 6276 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcla) = OmpixAtworkerClause((yyvsp[-1].expr));
    }
#line 12287 "parser.c" /* yacc.c:1646  */
    break;

  case 996:
#line 6280 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcla) = OmpixPlainClause(OX_OCTIED);
    }
#line 12295 "parser.c" /* yacc.c:1646  */
    break;

  case 997:
#line 6284 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcla) = OmpixPlainClause(OX_OCUNTIED);
    }
#line 12303 "parser.c" /* yacc.c:1646  */
    break;

  case 998:
#line 6288 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcla) = OmpixPlainClause(OX_OCDETACHED);
    }
#line 12311 "parser.c" /* yacc.c:1646  */
    break;

  case 999:
#line 6292 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcla) = OmpixHintsClause((yyvsp[-1].expr));
    }
#line 12319 "parser.c" /* yacc.c:1646  */
    break;

  case 1000:
#line 6296 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcla) = OmpixIfClause((yyvsp[-1].expr));
    }
#line 12327 "parser.c" /* yacc.c:1646  */
    break;

  case 1001:
#line 6304 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcon) = OmpixConstruct(OX_DCPROCEXT, (yyvsp[0].xdir), NULL);
    }
#line 12335 "parser.c" /* yacc.c:1646  */
    break;

  case 1002:
#line 6311 "parser.y" /* yacc.c:1646  */
    { sc_pause_ompix(); }
#line 12341 "parser.c" /* yacc.c:1646  */
    break;

  case 1003:
#line 6311 "parser.y" /* yacc.c:1646  */
    { sc_start_ompix(); }
#line 12347 "parser.c" /* yacc.c:1646  */
    break;

  case 1004:
#line 6312 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xdir) = OmpixDirective(OX_DCPROCEXT, NULL);
      (yyval.xdir)->varlist = (yyvsp[-3].decl);
    }
#line 12356 "parser.c" /* yacc.c:1646  */
    break;

  case 1005:
#line 6320 "parser.y" /* yacc.c:1646  */
    {
      stentry e = symtab_get(stab, Symbol((yyvsp[0].name)), IDNAME);
      
      if (symtab_get(stab, Symbol((yyvsp[0].name)), IDNAME) == NULL)
        parse_error(-1, "unknown identifier `%s'.\n", (yyvsp[0].name));
      if (e->scopelevel != 0)
        parse_error(-1, "procshared directive should only be used for global "
                        "variables (%s).\n", (yyvsp[0].name));
      if (speclist_getspec(e->spec, STCLASSSPEC, SPEC_extern) == NULL)
        parse_warning("variable `%s' is not declared as extern; ignoring\n", (yyvsp[0].name));
      (yyval.decl) = IdentifierDecl( Symbol((yyvsp[0].name)) );
    }
#line 12373 "parser.c" /* yacc.c:1646  */
    break;

  case 1006:
#line 6333 "parser.y" /* yacc.c:1646  */
    {
      stentry e = symtab_get(stab, Symbol((yyvsp[0].name)), IDNAME);
      
      if (symtab_get(stab, Symbol((yyvsp[0].name)), IDNAME) == NULL)
        parse_error(-1, "unknown identifier `%s'.\n", (yyvsp[0].name));
      if (e->scopelevel != 0)
        parse_error(-1, "procshared directive should only be used for global "
                        "variables (%s).\n", (yyvsp[0].name));
      if (speclist_getspec(e->spec, STCLASSSPEC, SPEC_extern) == NULL)
        parse_warning("variable `%s' is not declared as extern; ignoring\n", (yyvsp[0].name));
      (yyval.decl) = IdList((yyvsp[-2].decl), IdentifierDecl( Symbol((yyvsp[0].name)) ));
    }
#line 12390 "parser.c" /* yacc.c:1646  */
    break;

  case 1007:
#line 6349 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcon) = OmpixConstruct(OX_DCTAG, (yyvsp[-1].xdir), OmpStmt((yyvsp[0].ocon)));
    }
#line 12398 "parser.c" /* yacc.c:1646  */
    break;

  case 1008:
#line 6353 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcon) = OmpixConstruct(OX_DCTAG, (yyvsp[-1].xdir), OmpixStmt((yyvsp[0].xcon)));
    }
#line 12406 "parser.c" /* yacc.c:1646  */
    break;

  case 1009:
#line 6360 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xdir) = OmpixDirective(OX_DCTAG, (yyvsp[-1].xcla));
    }
#line 12414 "parser.c" /* yacc.c:1646  */
    break;

  case 1010:
#line 6367 "parser.y" /* yacc.c:1646  */
    {
      (yyval.xcla) = OmpixClause(OX_OCTAG, NULL, String((yyvsp[-1].string)));
    }
#line 12422 "parser.c" /* yacc.c:1646  */
    break;

  case 1011:
#line 6370 "parser.y" /* yacc.c:1646  */
    { sc_pause_ompix(); }
#line 12428 "parser.c" /* yacc.c:1646  */
    break;

  case 1012:
#line 6371 "parser.y" /* yacc.c:1646  */
    {
      sc_start_ompix();
      (yyval.xcla) = OmpixClause(OX_OCTAG, NULL, CommaList(String((yyvsp[-4].string)), (yyvsp[-1].expr)));
    }
#line 12437 "parser.c" /* yacc.c:1646  */
    break;

  case 1013:
#line 6379 "parser.y" /* yacc.c:1646  */
    {
      (yyval.ocla) = TagClause(String((yyvsp[-1].string)));
    }
#line 12445 "parser.c" /* yacc.c:1646  */
    break;

  case 1014:
#line 6382 "parser.y" /* yacc.c:1646  */
    { sc_pause_openmp(); }
#line 12451 "parser.c" /* yacc.c:1646  */
    break;

  case 1015:
#line 6383 "parser.y" /* yacc.c:1646  */
    {
      sc_start_openmp();
      (yyval.ocla) = TagClause(CommaList(String((yyvsp[-4].string)), (yyvsp[-1].expr)));
    }
#line 12460 "parser.c" /* yacc.c:1646  */
    break;


#line 12464 "parser.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 6389 "parser.y" /* yacc.c:1906  */



/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *                                                               *
 *     CODE                                                      *
 *                                                               *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */


void yyerror(const char *s)
{
	fprintf(stderr, "(file %s, line %d, column %d):\n\t%s\n",
	                sc_original_file(), sc_original_line(), sc_column(), s);
}


/* Utility function 
 */
char *strdupcat(char *first, char *second, int freethem)
{
	char *res;
	
	if (first == NULL && second == NULL)
		return NULL;
	if (first == NULL) 
		return (freethem) ? second : strdup(second);
	if (second == NULL) 
		return (freethem) ? first : strdup(first);
	if ((res = malloc(strlen(first)+strlen(second)+1)) == NULL)
		parse_error(1, "strdupcat ran out of memory\n");
	sprintf(res, "%s%s", first, second);
	if (freethem)
	{
		free(first);
		free(second);
	}
	return res;
}


/* Check whether the identifier is known or not
 */
void check_uknown_var(char *name)
{
	symbol s = Symbol(name);
	if (symtab_get(stab, s, IDNAME) == NULL &&
			symtab_get(stab, s, LABELNAME) == NULL &&
			symtab_get(stab, s, FUNCNAME) == NULL)
		parse_error(-1, "unknown identifier `%s'.\n", name);
}



/* See the "declaration" rule: if the last element of the list
 * is a user typename, we remove it, and we return it as an
 * identifier declarator.
 * The list should have 3 elements (typedef xxx type).
 */
astdecl fix_known_typename(astspec s)
{
	astspec prev;
	astdecl d;

	if (s->type != SPECLIST || s->u.next->type != SPECLIST) return (NULL);

	for (; s->u.next->type == SPECLIST; prev = s, s = s->u.next)
		;   /* goto last list node */
	if (s->u.next->type != USERTYPE)         /* nope */
		return (NULL);

	prev->u.next = s->body;

	d = Declarator(NULL, IdentifierDecl(s->u.next->name));
	if (checkDecls)
		symtab_put(stab, s->u.next->name, TYPENAME);
	free(s);
	return (d);
}


void check_for_main_and_declare(astspec s, astdecl d)
{
	astdecl n = decl_getidentifier(d);

	assert(d->type == DECLARATOR);
	assert(d->decl->type == DFUNC);

	if (strcmp(n->u.id->name, "main") == 0)
	{
		n->u.id = Symbol(MAIN_NEWNAME);         /* Catch main()'s definition */
		hasMainfunc = 1;

		/* Now check for return type and # parameters */
		/* It d != NULL then its parameters is either (id or idlist) or
		* (paramtype or parmatypelist). If it is a list, assume the
		* standard 2 params, otherwise, we guess the single argument
		* must be the type "void" which means no params.
		* In any case, we always force main have (argc, argv[]).
		*/
		if (d->decl->u.params == NULL || d->decl->u.params->type != DLIST)
			d->decl->u.params =
					ParamList(
						ParamDecl(
							Declspec(SPEC_int),
							Declarator( NULL, IdentifierDecl( Symbol("_argc_ignored") ) )
						),
						ParamDecl(
							Declspec(SPEC_char),
							Declarator(Speclist_right( Pointer(), Pointer() ),
												IdentifierDecl( Symbol("_argv_ignored") ))
						)
					);

		mainfuncRettype = 0; /* int */
		if (s != NULL)
		{
			for (; s->type == SPECLIST && s->subtype == SPEC_Rlist; s = s->u.next)
				if (s->body->type == SPEC && s->body->subtype == SPEC_void)
				{
					s = s->body;
					break;
				};
			if (s->type == SPEC && s->subtype == SPEC_void)
				mainfuncRettype = 1; /* void */
		}
	}
	if (symtab_get(stab, n->u.id, FUNCNAME) == NULL)/* From earlier declaration */
		symtab_put(stab, n->u.id, FUNCNAME);
}


/* For each variable/typename in the given declaration, add pointers in the
 * symbol table entries back to the declaration nodes.
 */
void add_declaration_links(astspec s, astdecl d)
{
	astdecl ini = NULL;

	if (d->type == DLIST && d->subtype == DECL_decllist)
	{
		add_declaration_links(s, d->u.next);
		d = d->decl;
	}
	if (d->type == DINIT) d = (ini = d)->decl;   /* Skip the initializer */
	assert(d->type == DECLARATOR);
	if (d->decl != NULL && d->decl->type != ABSDECLARATOR)
	{
		symbol  t = decl_getidentifier_symbol(d->decl);
		stentry e = isTypedef ?
		            symtab_get(stab,t,TYPENAME) :
		            symtab_get(stab,t,(decl_getkind(d)==DFUNC) ? FUNCNAME : IDNAME);
		e->spec  = s;
		e->decl  = d;
		e->idecl = ini;
	}
}


void  check_schedule(ompclsubt_e sched, ompclmod_e mod)
{
	if (mod == OCM_none) return;
	if (mod == OCM_nonmonotonic && sched != OC_dynamic && sched != OC_guided)
		parse_error(1, "nonmonotonic modifier is only allowed in dynamic or "
		                 "guided schedules\n");
}


void parse_error(int exitvalue, char *format, ...)
{
	va_list ap;

	va_start(ap, format);
	fprintf(stderr, "(%s, line %d)\n\t", sc_original_file(), sc_original_line());
	vfprintf(stderr, format, ap);
	va_end(ap);
	if (strcmp(sc_original_file(), "injected_code") == 0)
		fprintf(stderr, "\n>>>>>>>\n%s\n>>>>>>>\n", parsingstring);
	_exit(exitvalue);
}


void parse_warning(char *format, ...)
{
	va_list ap;

	va_start(ap, format);
	fprintf(stderr, "[warning] ");
	vfprintf(stderr, format, ap);
	va_end(ap);
}


aststmt parse_file(char *fname, int *error)
{
	*error = 0;
	if ( (yyin = fopen(fname, "r")) == NULL )
		return (NULL);
	sc_set_filename(fname);      /* Inform the scanner */
	*error = yyparse();
	fclose(yyin);                /* No longer needed */
	return (pastree);
}


#define PARSE_STRING_SIZE 16384


astexpr parse_expression_string(char *format, ...)
{
	static char s[PARSE_STRING_SIZE];
	int    savecD;

	va_list ap;
	va_start(ap, format);
	vsnprintf(s, PARSE_STRING_SIZE-1, format, ap);
	va_end(ap);
	parsingstring = s;
	sc_scan_string(s);
	sc_set_start_token(START_SYMBOL_EXPRESSION);

	savecD = checkDecls;
	checkDecls = 0;         /* Don't check identifiers & don't declare them */
	yyparse();
	checkDecls = savecD;    /* Reset it */
	return ( pastree_expr );
}


aststmt parse_blocklist_string(char *format, ...)
{
	static char s[PARSE_STRING_SIZE];
	int    savecD;

	va_list ap;
	va_start(ap, format);
	vsnprintf(s, PARSE_STRING_SIZE-1, format, ap);
	va_end(ap);
	parsingstring = s;
	sc_scan_string(s);
	sc_set_start_token(START_SYMBOL_BLOCKLIST);

	savecD = checkDecls;
	checkDecls = 0;         /* Don't check identifiers & don't declare them */
	yyparse();
	checkDecls = savecD;    /* Reset it */
	return ( pastree_stmt );
}


aststmt parse_and_declare_blocklist_string(char *format, ...)
{
	static char s[PARSE_STRING_SIZE];
	int    savecD;

	va_list ap;
	va_start(ap, format);
	vsnprintf(s, PARSE_STRING_SIZE-1, format, ap);
	va_end(ap);
	parsingstring = s;
	sc_scan_string(s);
	sc_set_start_token(START_SYMBOL_BLOCKLIST);

	savecD = checkDecls;
	checkDecls = 1;         /* Do check identifiers & do declare them */
	yyparse();
	checkDecls = savecD;    /* Reset it */
	return ( pastree_stmt );
}


aststmt parse_transunit_string(char *format, ...)
{
	static char s[PARSE_STRING_SIZE];
	int    savecD;

	va_list ap;
	va_start(ap, format);
	vsnprintf(s, PARSE_STRING_SIZE-1, format, ap);
	va_end(ap);
	parsingstring = s;
	sc_scan_string(s);
	sc_set_start_token(START_SYMBOL_TRANSUNIT);

	savecD = checkDecls;
	checkDecls = 0;         /* Don't check identifiers & don't declare them */
	yyparse();
	checkDecls = savecD;    /* Reset it */
	return ( pastree_stmt );
}
